/* $Id$ */
/*============================================================================*
 |                 Copyright (c) 2015 Applaud Solutions UK Ltd                |
 |                             All rights reserved                            |
 *===========================================================================*/

SET VERIFY OFF
SET FEEDBACK OFF
SET SCAN OFF
WHENEVER OSERROR  EXIT FAILURE ROLLBACK
WHENEVER SQLERROR EXIT FAILURE ROLLBACK



DECLARE 

  e_dir_exists EXCEPTION;
  PRAGMA EXCEPTION_INIT(e_dir_exists, -31003);

  e_does_not_exists EXCEPTION;
  PRAGMA EXCEPTION_INIT(e_does_not_exists , -31001);

  result boolean;
  
BEGIN

  BEGIN

    result := DBMS_XDB.createfolder('/public/xxas/');
    result := DBMS_XDB.createfolder('/public/xxas/emp/');
    result := DBMS_XDB.createfolder('/public/xxas/emp/view/');

  EXCEPTION
    WHEN e_dir_exists THEN
      NULL;
  END;

  
  BEGIN

    DBMS_XDB.DeleteResource('/public/xxas/emp/view/list_sort.xml');

  EXCEPTION
    WHEN e_does_not_exists THEN
      NULL;
  END;

  
  result := DBMS_XDB.createresource('/public/xxas/emp/view/list_sort.xml',
'<View deleteAllowed="true" title="Flexible block sort details" defaultFormHandler="xxas_block_pkg.post_block_update">

  <CreateFields>
      <TextInput id="SORT_FIELD" label="Field" enabled="true" visible="true" required="true"/>
      <TextInput id="SORT_TITLE" label="Title" enabled="true" visible="true" required="true"/>
      <Poplist id="SORT_DIRECTION" label="Direction" enabled="true" visible="true" required="true"
      listProvider="LOOKUP_TYPE:XXAS_SORT_DIRECTIONS" value="A"/>
	  <Poplist id="SORT_TYPE" label="Selected by default" showAsBoolean="true" enabled="true" visible="true" listProvider="LOOKUP_TYPE:YES_NO" positiveBooleanValue="Y"/>
  </CreateFields>

</View>' ); 
xxas_forms_pkg.update_forms_resource('/public/xxas/emp/view/list_sort.xml');
END;
/
COMMIT;
EXIT;
