/* $Id$ */
/*============================================================================*
 |                 Copyright (c) 2013 Applaud Solutions UK Ltd                |
 |                             All rights reserved                            |
 *===========================================================================*/

SET VERIFY OFF
SET FEEDBACK OFF
WHENEVER OSERROR  EXIT FAILURE ROLLBACK
WHENEVER SQLERROR EXIT FAILURE ROLLBACK

CREATE OR REPLACE TYPE BODY xxas_com_keys_type IS
  

CONSTRUCTOR FUNCTION xxas_com_keys_type
  (p_com_keys_xml IN XMLTYPE) RETURN SELF AS RESULT
IS  

  CURSOR c_data
  IS
  SELECT x.column_value.getrootelement()   name
  ,      extractvalue(x.column_value, '.') value
  FROM   TABLE
           (XMLSEQUENCE
             (EXTRACT(p_com_keys_xml, 'Keys/*'))) x;
                  
BEGIN
  keys := xxas_com_named_value_table(); 

  FOR l_data IN c_data
  LOOP
    keys.EXTEND;
    keys(keys.COUNT) := xxas_com_named_value_type(l_data.name, l_data.value);
  END LOOP;
     
  RETURN; 
END;


MEMBER PROCEDURE set_key
  (p_name  IN VARCHAR2
  ,p_value IN VARCHAR2)
IS
BEGIN
  IF keys IS NULL
  THEN
    keys := xxas_com_named_value_table(); 
  END IF;

  FOR i IN 1..keys.COUNT
  LOOP  
    IF keys(i).name = p_name
    THEN 
      keys(i).value := p_value;
      RETURN;
    END IF;
    
  END LOOP;
  
  keys.EXTEND;
  keys(keys.COUNT) := xxas_com_named_value_type
                        (name  => p_name
                        ,value => p_value); 
END set_key;


MEMBER FUNCTION get_key
  (p_name IN VARCHAR2) RETURN VARCHAR2

IS
BEGIN
  
  IF keys IS NOT NULL
  THEN
    FOR i IN 1..keys.COUNT
    LOOP  
      IF keys(i).name = p_name
      THEN 
        RETURN keys(i).value;
      END IF;
    END LOOP;
  END IF;
  
  RETURN NULL;

END get_key;


MEMBER FUNCTION get_xml RETURN XMLTYPE

IS
  l_xml XMLTYPE;

BEGIN
  
  SELECT XMLELEMENT
          ("Keys"
          ,XMLAgg
            (XMLELEMENT
              (EVALNAME d.name, d.value))) 
  INTO   l_xml   
  FROM   TABLE(keys) d;

  RETURN l_xml;
END;
  
END;
/

COMMIT;
EXIT;
