/* $Id$ */
/*============================================================================*
 |                 Copyright (c) 2016 Applaud Solutions UK Ltd                |
 |                             All rights reserved                            |
 *===========================================================================*/

SET VERIFY OFF
SET FEEDBACK OFF
WHENEVER OSERROR  EXIT FAILURE ROLLBACK
WHENEVER SQLERROR EXIT FAILURE ROLLBACK

CREATE OR REPLACE TYPE BODY xxas_com_sorts IS
  
CONSTRUCTOR FUNCTION xxas_com_sorts RETURN SELF AS RESULT
IS  

BEGIN
  self.sorts := xxas_com_sorts_table(); 

  RETURN; 
END;

MEMBER PROCEDURE add_sort
  (p_id           VARCHAR2
  ,p_title        VARCHAR2 
  ,p_sort_type    VARCHAR2
  ,p_direction    VARCHAR2) IS

BEGIN
  sorts.extend;
  sorts(sorts.count) :=
      xxas_com_sort_type
      (id         => p_id
      ,title      => p_title
      ,sort_type  => p_sort_type
      ,direction  => p_direction
      ,selected   => 'N'); -- Selected value is set to N by default.
END;

MEMBER PROCEDURE set_selected
  (p_id   VARCHAR2)
IS

BEGIN
  IF sorts.count > 0 THEN
    FOR i IN 1..sorts.count LOOP
      IF UPPER(sorts(i).id) = UPPER(p_id) THEN
        sorts(i).selected := 'Y';
        EXIT;
      END IF;
    END LOOP;
  END IF;
END;

MEMBER FUNCTION get_xml RETURN XMLType
IS

  l_xml XMLType;
BEGIN
  
  SELECT --XMLElement
          --("items",
          XMLAgg
            (XMLElement
              ("item"
              ,XMLForest
                (s.id         "id"
                ,s.title      "title"
                ,s.sort_type  "type"
                ,s.direction  "direction"
                ,CASE s.selected 
                  WHEN 'Y' THEN 'true' 
                  ELSE null 
                 END          "selected"
                )
              )
            )
          --)
  INTO l_xml
  FROM TABLE(sorts) s;
  
  RETURN l_xml;
END;

END;
/

COMMIT;
EXIT;