/* $Id: xxas_contacts_type.pkb 5251 2018-03-07 13:44:36Z rgangadharan $ */
/*============================================================================*
 |                 Copyright (c) 2013 Applaud Solutions UK Ltd                |
 |                             All rights reserved                            |
 *===========================================================================*/

SET VERIFY OFF
SET FEEDBACK OFF
WHENEVER OSERROR  EXIT FAILURE ROLLBACK
WHENEVER SQLERROR EXIT FAILURE ROLLBACK

CREATE OR REPLACE TYPE BODY xxas_emp_contact_basic_details IS


  CONSTRUCTOR FUNCTION xxas_emp_contact_basic_details
    (p_person_id          IN  NUMBER
    ,p_contact_person_id  IN  NUMBER   DEFAULT NULL
    ,p_transaction_id     IN  NUMBER   DEFAULT NULL) RETURN SELF AS RESULT
  IS

    CURSOR csr_contact_basic_details IS
    SELECT  pcr.person_id,
            pcr.contact_person_id,
            pcr.contact_relationship_id,
            pcr.contact_type,
            pcr.object_version_number,
            hr_general.decode_lookup
            ('CONTACT'
            ,pcr.contact_type)  contact_type_meaning,
            papf.business_group_id,
            papf.first_name,
            papf.last_name,
            DECODE(pcr.primary_contact_flag
             ,'Y'
             ,'Y'
             ,pcr.primary_contact_flag) primary_contact_flag,
            hr_general.decode_lookup
            ('YES_NO'
              ,DECODE(pcr.primary_contact_flag
                ,'Y'
                ,'Y'
                ,pcr.primary_contact_flag))      primary_contact_flag_meaning,
            DECODE(pcr.contact_type
                  ,'EMRG'
                  ,'N'
                  ,'Y')                            emrg_contact_flag,
            hr_general.decode_lookup
             ('YES_NO'
             ,DECODE(pcr.contact_type
                    ,'EMRG'
                    ,'N'
                    ,'Y'))                  emrg_contact_flag_meaning,
            pcr.third_party_pay_flag,
            pcr.bondholder_flag,
            pcr.date_start,
            pcr.start_life_reason_id,
            pcr.date_end,
            pcr.end_life_reason_id,
            pcr.personal_flag,
            pcr.sequence_number,
            pcr.dependent_flag,
            pcr.beneficiary_flag,
            pcr.rltd_per_rsds_w_dsgntr_flag,
            pcr.cont_attribute_category,
            pcr.cont_attribute1,
            pcr.cont_attribute2,
            pcr.cont_attribute3,
            pcr.cont_attribute4,
            pcr.cont_attribute5,
            pcr.cont_attribute6,
            pcr.cont_attribute7,
            pcr.cont_attribute8,
            pcr.cont_attribute9,
            pcr.cont_attribute10,
            pcr.cont_attribute11,
            pcr.cont_attribute12,
            pcr.cont_attribute13,
            pcr.cont_attribute14,
            pcr.cont_attribute15,
            pcr.cont_attribute16,
            pcr.cont_attribute17,
            pcr.cont_attribute18,
            pcr.cont_attribute19,
            pcr.cont_attribute20,
            pcr.cont_information_category,
            pcr.cont_information1,
            pcr.cont_information2,
            pcr.cont_information3,
            pcr.cont_information4,
            pcr.cont_information5,
            pcr.cont_information6,
            pcr.cont_information7,
            pcr.cont_information8,
            pcr.cont_information9,
            pcr.cont_information10,
            pcr.cont_information11,
            pcr.cont_information12,
            pcr.cont_information13,
            pcr.cont_information14,
            pcr.cont_information15,
            pcr.cont_information16,
            pcr.cont_information17,
            pcr.cont_information18,
            pcr.cont_information19,
            pcr.cont_information20,
            papf.person_type_id,
            papf.applicant_number,
            papf.date_employee_data_verified,
            papf.date_of_birth,
            papf.email_address,
            papf.employee_number,
            papf.npw_number,
            papf.expense_check_send_to_address,
            papf.known_as,
            papf.marital_status,
            hr_general.decode_lookup
                     ('MAR_STATUS'
                     ,papf.marital_status)                   marital_status_meaning,
            papf.middle_names,
            papf.nationality,
            papf.national_identifier,
            papf.previous_last_name,
            papf.registered_disabled_flag,
            hr_general.decode_lookup
                    ('REGISTERED_DISABLED'
                    ,papf.registered_disabled_flag)         registered_disabled_meaning,
            papf.sex,
            hr_general.decode_lookup
                     ('SEX'
                     ,papf.sex)                             sex_meaning,
            papf.title,
            hr_general.decode_lookup
                     ('TITLE'
                     ,papf.title)                           title_meaning,
            papf.vendor_id,
            papf.work_telephone
    FROM    per_contact_relationships pcr, per_all_people_f papf
    WHERE   pcr.person_id         = p_person_id
    AND     pcr.contact_person_id = p_contact_person_id
    AND     pcr.personal_flag     = 'Y'
    AND     pcr.contact_type      <> 'EMRG'
    AND     papf.person_id        = p_contact_person_id
    AND     TRUNC(SYSDATE) BETWEEN papf.effective_start_date AND papf.effective_end_date
    UNION
    SELECT  pcr.person_id,
            pcr.contact_person_id,
            pcr.contact_relationship_id,
            pcr.contact_type,
            pcr.object_version_number,
            hr_general.decode_lookup
            ('CONTACT'
            ,pcr.contact_type)  contact_type_meaning,
            papf.business_group_id,
            papf.first_name,
            papf.last_name,
            DECODE(pcr.primary_contact_flag
             ,'Y'
             ,'Y'
             ,pcr.primary_contact_flag) primary_contact_flag,
            hr_general.decode_lookup
            ('YES_NO'
              ,DECODE(pcr.primary_contact_flag
                ,'Y'
                ,'Y'
                ,pcr.primary_contact_flag))      primary_contact_flag_meaning,
            DECODE(pcr.contact_type
                  ,'EMRG'
                  ,'N'
                  ,'Y')                            emrg_contact_flag,
            hr_general.decode_lookup
             ('YES_NO'
             ,DECODE(pcr.contact_type
                    ,'EMRG'
                    ,'N'
                    ,'Y'))                  emrg_contact_flag_meaning,
            pcr.third_party_pay_flag,
            pcr.bondholder_flag,
            pcr.date_start,
            pcr.start_life_reason_id,
            pcr.date_end,
            pcr.end_life_reason_id,
            pcr.personal_flag,
            pcr.sequence_number,
            pcr.dependent_flag,
            pcr.beneficiary_flag,
            pcr.rltd_per_rsds_w_dsgntr_flag,
            pcr.cont_attribute_category,
            pcr.cont_attribute1,
            pcr.cont_attribute2,
            pcr.cont_attribute3,
            pcr.cont_attribute4,
            pcr.cont_attribute5,
            pcr.cont_attribute6,
            pcr.cont_attribute7,
            pcr.cont_attribute8,
            pcr.cont_attribute9,
            pcr.cont_attribute10,
            pcr.cont_attribute11,
            pcr.cont_attribute12,
            pcr.cont_attribute13,
            pcr.cont_attribute14,
            pcr.cont_attribute15,
            pcr.cont_attribute16,
            pcr.cont_attribute17,
            pcr.cont_attribute18,
            pcr.cont_attribute19,
            pcr.cont_attribute20,
            pcr.cont_information_category,
            pcr.cont_information1,
            pcr.cont_information2,
            pcr.cont_information3,
            pcr.cont_information4,
            pcr.cont_information5,
            pcr.cont_information6,
            pcr.cont_information7,
            pcr.cont_information8,
            pcr.cont_information9,
            pcr.cont_information10,
            pcr.cont_information11,
            pcr.cont_information12,
            pcr.cont_information13,
            pcr.cont_information14,
            pcr.cont_information15,
            pcr.cont_information16,
            pcr.cont_information17,
            pcr.cont_information18,
            pcr.cont_information19,
            pcr.cont_information20,
            papf.person_type_id,
            papf.applicant_number,
            papf.date_employee_data_verified,
            papf.date_of_birth,
            papf.email_address,
            papf.employee_number,
            papf.npw_number,
            papf.expense_check_send_to_address,
            papf.known_as,
            papf.marital_status,
            hr_general.decode_lookup
                     ('MAR_STATUS'
                     ,papf.marital_status)                   marital_status_meaning,
            papf.middle_names,
            papf.nationality,
            papf.national_identifier,
            papf.previous_last_name,
            papf.registered_disabled_flag,
            hr_general.decode_lookup
                    ('REGISTERED_DISABLED'
                    ,papf.registered_disabled_flag)         registered_disabled_meaning,
            papf.sex,
            hr_general.decode_lookup
                     ('SEX'
                     ,papf.sex)                             sex_meaning,
            papf.title,
            hr_general.decode_lookup
                     ('TITLE'
                     ,papf.title)                           title_meaning,
            papf.vendor_id,
            papf.work_telephone
    FROM    per_contact_relationships pcr, per_all_people_f papf
    WHERE   pcr.person_id         = p_person_id
    AND     pcr.contact_person_id = p_contact_person_id
    AND     pcr.contact_type = 'EMRG'
    AND     not exists
             ( select 1
               from per_contact_relationships con
               where con.contact_type <> 'EMRG'
               and con.contact_person_id =pcr.contact_person_id
               and con.person_id = pcr.person_id
               and trunc(sysdate) >= decode(con.date_start,null,trunc(sysdate),trunc(con.date_start))
               and trunc(sysdate) <  decode(con.date_end,null,trunc(sysdate)+1,trunc(con.date_end))) 
    AND     papf.person_id        = p_contact_person_id
    AND     TRUNC(SYSDATE) BETWEEN papf.effective_start_date AND papf.effective_end_date;
	
	CURSOR csr_emerg_primary IS 
	SELECT pcr.contact_type, pcr.primary_contact_flag 
  FROM   per_contact_relationships pcr
	WHERE  pcr.contact_type      = 'EMRG'
	AND    pcr.person_id         = p_person_id
  AND    pcr.contact_person_id = p_contact_person_id
	AND    DATE_END IS NULL;

  l_contact_basic_details  csr_contact_basic_details%ROWTYPE;
	l_contact_type			     varchar2(50);
  l_txn_steps              xxas_hr_api_txn_steps;
	l_emergency_flag     		 varchar2(50);
	l_emergency_flag_meaning varchar2(50);
  l_primary_flag     		   varchar2(50);
	l_primary_flag_meaning   varchar2(50);

  BEGIN
  
     IF p_transaction_id IS NULL AND p_contact_person_id IS NOT NULL THEN

	    OPEN csr_emerg_primary;
	    FETCH csr_emerg_primary INTO l_contact_type,l_primary_flag;
	    CLOSE csr_emerg_primary;
	
			IF l_contact_type = 'EMRG' THEN 
	
				l_emergency_flag  := 'Y';
				l_emergency_flag_meaning  := 'Yes';
	
			ELSE
	
			  l_emergency_flag  := 'N';
			  l_emergency_flag_meaning  := 'No';
	
			END IF;

      IF l_primary_flag = 'Y' THEN
        l_primary_flag_meaning  := 'Yes';
      ELSE
        l_primary_flag_meaning  := 'No';
      END IF;

	END IF;
	
   

    IF p_transaction_id IS NULL AND p_contact_person_id IS NOT NULL THEN

      OPEN csr_contact_basic_details;
      FETCH csr_contact_basic_details INTO l_contact_basic_details;
      CLOSE csr_contact_basic_details;


      self.person_id                      :=  l_contact_basic_details.person_id;
      self.contact_person_id              :=  l_contact_basic_details.contact_person_id;
      self.contact_relationship_id        :=  l_contact_basic_details.contact_relationship_id;
      self.contact_type                   :=  l_contact_basic_details.contact_type;
      self.object_version_number          :=  l_contact_basic_details.object_version_number;
      self.first_name                     :=  l_contact_basic_details.first_name;
      self.last_name                      :=  l_contact_basic_details.last_name;
      self.business_group_id              :=  l_contact_basic_details.business_group_id;
      self.contact_type_meaning           :=  l_contact_basic_details.contact_type_meaning;
	    self.emrg_contact_flag              :=  l_emergency_flag;
      self.emrg_contact_flag_meaning   	  :=  l_emergency_flag_meaning;
      self.primary_contact_flag           :=  l_primary_flag;
      self.primary_contact_flag_meaning   :=  l_primary_flag_meaning;
      self.third_party_pay_flag           :=  l_contact_basic_details.third_party_pay_flag;
      self.bondholder_flag                :=  l_contact_basic_details.bondholder_flag;
      self.date_start                     :=  l_contact_basic_details.date_start;
      self.start_life_reason_id           :=  l_contact_basic_details.start_life_reason_id;
      self.date_end                       :=  l_contact_basic_details.date_end;
      self.end_life_reason_id             :=  l_contact_basic_details.end_life_reason_id;
      self.personal_flag                  :=  l_contact_basic_details.personal_flag;
      self.sequence_number                :=  l_contact_basic_details.sequence_number;
      self.dependent_flag                 :=  l_contact_basic_details.dependent_flag;
      self.beneficiary_flag               :=  l_contact_basic_details.beneficiary_flag;
      self.rltd_per_rsds_w_dsgntr_flag    :=  l_contact_basic_details.rltd_per_rsds_w_dsgntr_flag;
      self.cont_attribute_category        :=  l_contact_basic_details.cont_attribute_category;
      self.cont_attribute1                :=  l_contact_basic_details.cont_attribute1;
      self.cont_attribute2                :=  l_contact_basic_details.cont_attribute2;
      self.cont_attribute3                :=  l_contact_basic_details.cont_attribute3;
      self.cont_attribute4                :=  l_contact_basic_details.cont_attribute4;
      self.cont_attribute5                :=  l_contact_basic_details.cont_attribute5;
      self.cont_attribute6                :=  l_contact_basic_details.cont_attribute6;
      self.cont_attribute7                :=  l_contact_basic_details.cont_attribute7;
      self.cont_attribute8                :=  l_contact_basic_details.cont_attribute8;
      self.cont_attribute9                :=  l_contact_basic_details.cont_attribute9;
      self.cont_attribute10               :=  l_contact_basic_details.cont_attribute10;
      self.cont_attribute11               :=  l_contact_basic_details.cont_attribute11;
      self.cont_attribute12               :=  l_contact_basic_details.cont_attribute12;
      self.cont_attribute13               :=  l_contact_basic_details.cont_attribute13;
      self.cont_attribute14               :=  l_contact_basic_details.cont_attribute14;
      self.cont_attribute15               :=  l_contact_basic_details.cont_attribute15;
      self.cont_attribute16               :=  l_contact_basic_details.cont_attribute16;
      self.cont_attribute17               :=  l_contact_basic_details.cont_attribute17;
      self.cont_attribute18               :=  l_contact_basic_details.cont_attribute18;
      self.cont_attribute19               :=  l_contact_basic_details.cont_attribute19;
      self.cont_attribute20               :=  l_contact_basic_details.cont_attribute20;
      self.cont_information_category      :=  l_contact_basic_details.cont_information_category;
      self.cont_information1              :=  l_contact_basic_details.cont_information1;
      self.cont_information2              :=  l_contact_basic_details.cont_information2;
      self.cont_information3              :=  l_contact_basic_details.cont_information3;
      self.cont_information4              :=  l_contact_basic_details.cont_information4;
      self.cont_information5              :=  l_contact_basic_details.cont_information5;
      self.cont_information6              :=  l_contact_basic_details.cont_information6;
      self.cont_information7              :=  l_contact_basic_details.cont_information7;
      self.cont_information8              :=  l_contact_basic_details.cont_information8;
      self.cont_information9              :=  l_contact_basic_details.cont_information9;
      self.cont_information10             :=  l_contact_basic_details.cont_information10;
      self.cont_information11             :=  l_contact_basic_details.cont_information11;
      self.cont_information12             :=  l_contact_basic_details.cont_information12;
      self.cont_information13             :=  l_contact_basic_details.cont_information13;
      self.cont_information14             :=  l_contact_basic_details.cont_information14;
      self.cont_information15             :=  l_contact_basic_details.cont_information15;
      self.cont_information16             :=  l_contact_basic_details.cont_information16;
      self.cont_information17             :=  l_contact_basic_details.cont_information17;
      self.cont_information18             :=  l_contact_basic_details.cont_information18;
      self.cont_information19             :=  l_contact_basic_details.cont_information19;
      self.cont_information20             :=  l_contact_basic_details.cont_information20;
      self.person_type_id                 :=  l_contact_basic_details.person_type_id;
      self.applicant_number               :=  l_contact_basic_details.applicant_number;
      self.date_employee_data_verified    :=  l_contact_basic_details.date_employee_data_verified;
      self.date_of_birth                  :=  l_contact_basic_details.date_of_birth;
      self.email_address                  :=  l_contact_basic_details.email_address;
      self.employee_number                :=  l_contact_basic_details.employee_number;
      self.npw_number                     :=  l_contact_basic_details.npw_number;
      self.expense_check_send_to_address  :=  l_contact_basic_details.expense_check_send_to_address;
      self.known_as                       :=  l_contact_basic_details.known_as;
      self.marital_status                 :=  l_contact_basic_details.marital_status;
      self.marital_status_meaning         :=  l_contact_basic_details.marital_status_meaning;
      self.middle_names                   :=  l_contact_basic_details.middle_names;
      self.nationality                    :=  l_contact_basic_details.nationality;
      self.national_identifier            :=  l_contact_basic_details.national_identifier;
      self.previous_last_name             :=  l_contact_basic_details.previous_last_name;
      self.registered_disabled_flag       :=  l_contact_basic_details.registered_disabled_flag;
      self.registered_disabled_meaning    :=  l_contact_basic_details.registered_disabled_meaning;
      self.sex                            :=  l_contact_basic_details.sex;
      SELF.sex_meaning                    :=  l_contact_basic_details.sex_meaning;
      self.title                          :=  l_contact_basic_details.title;
      self.title_meaning                  :=  l_contact_basic_details.title_meaning;
      self.vendor_id                      :=  l_contact_basic_details.vendor_id;
      self.work_telephone                 :=  l_contact_basic_details.work_telephone;

    ELSIF p_transaction_id IS NOT NULL THEN

      self.transaction_id                 :=  p_transaction_id;
      self.person_id                      :=  p_person_id;

    END IF;

    RETURN;

  END;

  MEMBER FUNCTION get_xml RETURN XMLType
  IS

    l_xml                   XMLType;

    l_txn_steps             xxas_hr_api_txn_steps;

    CURSOR csr_transaction_step  IS
    SELECT hats.transaction_step_id
    FROM   hr_api_transaction_steps hats
    WHERE  hats.transaction_id  = self.transaction_id
    AND    hats.api_name IN ('HR_PROCESS_CONTACT_SS.PROCESS_CREATE_CONTACT_API'
                            ,'HR_PROCESS_CONTACT_SS.PROCESS_API');

    l_transaction_step   csr_transaction_step%ROWTYPE;

    CURSOR csr_contact_xml IS
    SELECT  XMLElement
              ("ROW",
                XMLForest
                  (self.person_id                       as person_id
                  ,self.contact_person_id               as contact_person_id
                  ,self.contact_relationship_id         as contact_relationship_id
                  ,self.contact_type                    as contact_type
                  ,self.object_version_number           as object_version_number
                  ,self.first_name                      as first_name
                  ,self.last_name                       as last_name
                  ,self.business_group_id               as business_group_id
                  ,self.contact_type_meaning            as contact_type_meaning
                  ,self.primary_contact_flag            as primary_contact_flag
                  ,self.primary_contact_flag_meaning    as primary_contact_flag_meaning
		  ,self.emrg_contact_flag         	    as emrg_contact_flag
                  ,self.emrg_contact_flag_meaning       as emrg_contact_flag_meaning
                  ,self.third_party_pay_flag            as third_party_pay_flag
                  ,self.bondholder_flag                 as bondholder_flag
                  ,self.date_start                      as date_start
                  ,self.start_life_reason_id            as start_life_reason_id
                  ,self.date_end                        as date_end
                  ,self.end_life_reason_id              as end_life_reason_id
                  ,self.personal_flag                   as personal_flag
                  ,self.sequence_number                 as sequence_number
                  ,self.dependent_flag                  as dependent_flag
                  ,self.beneficiary_flag                as beneficiary_flag
                  ,self.rltd_per_rsds_w_dsgntr_flag     as rltd_per_rsds_w_dsgntr_flag
                  ,self.cont_attribute_category         as cont_attribute_category
                  ,self.cont_attribute1                 as cont_attribute1
                  ,self.cont_attribute2                 as cont_attribute2
                  ,self.cont_attribute3                 as cont_attribute3
                  ,self.cont_attribute4                 as cont_attribute4
                  ,self.cont_attribute5                 as cont_attribute5
                  ,self.cont_attribute6                 as cont_attribute6
                  ,self.cont_attribute7                 as cont_attribute7
                  ,self.cont_attribute8                 as cont_attribute8
                  ,self.cont_attribute9                 as cont_attribute9
                  ,self.cont_attribute10                as cont_attribute10
                  ,self.cont_attribute11                as cont_attribute11
                  ,self.cont_attribute12                as cont_attribute12
                  ,self.cont_attribute13                as cont_attribute13
                  ,self.cont_attribute14                as cont_attribute14
                  ,self.cont_attribute15                as cont_attribute15
                  ,self.cont_attribute16                as cont_attribute16
                  ,self.cont_attribute17                as cont_attribute17
                  ,self.cont_attribute18                as cont_attribute18
                  ,self.cont_attribute19                as cont_attribute19
                  ,self.cont_attribute20                as cont_attribute20
                  ,self.cont_information_category       as cont_information_category
                  ,self.cont_information1               as cont_information1
                  ,self.cont_information2               as cont_information2
                  ,self.cont_information3               as cont_information3
                  ,self.cont_information4               as cont_information4
                  ,self.cont_information5               as cont_information5
                  ,self.cont_information6               as cont_information6
                  ,self.cont_information7               as cont_information7
                  ,self.cont_information8               as cont_information8
                  ,self.cont_information9               as cont_information9
                  ,self.cont_information10              as cont_information10
                  ,self.cont_information11              as cont_information11
                  ,self.cont_information12              as cont_information12
                  ,self.cont_information13              as cont_information13
                  ,self.cont_information14              as cont_information14
                  ,self.cont_information15              as cont_information15
                  ,self.cont_information16              as cont_information16
                  ,self.cont_information17              as cont_information17
                  ,self.cont_information18              as cont_information18
                  ,self.cont_information19              as cont_information19
                  ,self.cont_information20              as cont_information20
                  ,self.person_type_id                  as person_type_id
                  ,self.applicant_number                as applicant_number
                  ,self.date_employee_data_verified     as date_employee_data_verified
                  ,self.date_of_birth                   as date_of_birth
                  ,self.email_address                   as email_address
                  ,self.employee_number                 as employee_number
                  ,self.npw_number                      as npw_number
                  ,self.expense_check_send_to_address   as expense_check_send_to_address
                  ,self.known_as                        as known_as
                  ,self.marital_status                  as marital_status
                  ,self.marital_status_meaning          as marital_status_meaning
                  ,self.middle_names                    as middle_names
                  ,self.nationality                     as nationality
                  ,self.national_identifier             as national_identifier
                  ,self.previous_last_name              as previous_last_name
                  ,self.registered_disabled_flag        as registered_disabled_flag
                  ,self.registered_disabled_meaning     as registered_disabled_meaning
                  ,self.sex                             as sex
                  ,self.sex_meaning                     as sex_meaning
                  ,self.title                           as title
                  ,self.title_meaning                   as title_meaning
                  ,self.vendor_id                       as vendor_id
                  ,self.work_telephone                  as work_telephone
                  )
              )

    FROM DUAL;


  BEGIN

    IF self.transaction_id IS NULL THEN
      OPEN  csr_contact_xml;
      FETCH csr_contact_xml INTO l_xml;
      CLOSE csr_contact_xml;

    ELSE

      OPEN  csr_transaction_step;
      FETCH csr_transaction_step INTO l_transaction_step;
      CLOSE csr_transaction_step;


      l_txn_steps := xxas_hr_api_txn_steps(self.transaction_id, l_transaction_step.transaction_step_id);
      l_xml := l_txn_steps.get_xml();
    END IF;

    RETURN l_xml;

  END;

END;
/

CREATE OR REPLACE TYPE BODY xxas_per_phone_number IS

  CONSTRUCTOR FUNCTION xxas_per_phone_number
    (p_person_id            IN  NUMBER
    ,p_phone_id             IN  NUMBER DEFAULT NULL
    ,p_transaction_id       IN  NUMBER DEFAULT NULL
    ,p_transaction_step_id  IN  NUMBER DEFAULT NULL) RETURN SELF AS RESULT
  IS
    CURSOR csr_contact_phone IS
    SELECT  pp.*
    FROM    per_phones pp
    WHERE   pp.parent_id = p_person_id
    AND     pp.phone_id  = p_phone_id
    AND     pp.parent_table = 'PER_ALL_PEOPLE_F';

    l_contact_phone_rec   csr_contact_phone%ROWTYPE;

    CURSOR csr_contact_phone_pend IS
    SELECT  hats.transaction_step_id
    FROM    hr_api_transactions hat, hr_api_transaction_steps hats
    WHERE   hat.transaction_id      = p_transaction_id
    AND     hat.selected_person_id  = fnd_profile.value('PER_PERSON_ID')
    AND     hat.status              NOT IN ('D', 'N', 'W', 'ACTIVE', 'AC')
    AND     hats.transaction_id     = hat.transaction_id
    AND     hats.api_name           = 'HR_PROCESS_PHONE_NUMBERS_SS.PROCESS_API';

    l_contact_phone_pend  csr_contact_phone_pend%ROWTYPE;

  BEGIN

    IF p_transaction_step_id IS NOT NULL AND p_transaction_step_id <> -1 THEN

      self.transaction_id       := p_transaction_id;
      self.transaction_step_id  := p_transaction_step_id;
      self.attachment_entity    := 'PQH_SS_ATTACHMENT';
      self.attachment_pk1       := p_transaction_id;

    ELSE
      OPEN  csr_contact_phone;
      FETCH csr_contact_phone INTO l_contact_phone_rec;
      CLOSE csr_contact_phone;

      self.phone_id             :=  l_contact_phone_rec.phone_id;
      self.date_from            :=  l_contact_phone_rec.date_from;
      self.date_to              :=  l_contact_phone_rec.date_to;
      self.phone_type           :=  l_contact_phone_rec.phone_type;
      self.phone_type_meaning   :=  xxas_util_pkg.decode_lookup('PHONE_TYPE', l_contact_phone_rec.phone_type);
      self.phone_number         :=  l_contact_phone_rec.phone_number;
      self.parent_id            :=  l_contact_phone_rec.parent_id;
      self.person_id            :=  l_contact_phone_rec.parent_id;
      self.object_version_number:=  l_contact_phone_rec.object_version_number;
      self.attribute_category   :=  l_contact_phone_rec.attribute_category;
      self.attribute1           :=  l_contact_phone_rec.attribute1;
      self.attribute2           :=  l_contact_phone_rec.attribute2;
      self.attribute3           :=  l_contact_phone_rec.attribute3;
      self.attribute4           :=  l_contact_phone_rec.attribute4;
      self.attribute5           :=  l_contact_phone_rec.attribute5;
      self.attribute6           :=  l_contact_phone_rec.attribute6;
      self.attribute7           :=  l_contact_phone_rec.attribute7;
      self.attribute8           :=  l_contact_phone_rec.attribute8;
      self.attribute9           :=  l_contact_phone_rec.attribute9;
      self.attribute10          :=  l_contact_phone_rec.attribute10;
      self.attribute11          :=  l_contact_phone_rec.attribute11;
      self.attribute12          :=  l_contact_phone_rec.attribute12;
      self.attribute13          :=  l_contact_phone_rec.attribute13;
      self.attribute14          :=  l_contact_phone_rec.attribute14;
      self.attribute15          :=  l_contact_phone_rec.attribute15;
      self.attribute16          :=  l_contact_phone_rec.attribute16;
      self.attribute17          :=  l_contact_phone_rec.attribute17;
      self.attribute18          :=  l_contact_phone_rec.attribute18;
      self.attribute19          :=  l_contact_phone_rec.attribute19;
      self.attribute20          :=  l_contact_phone_rec.attribute20;
      self.attribute21          :=  l_contact_phone_rec.attribute21;
      self.attribute22          :=  l_contact_phone_rec.attribute22;
      self.attribute23          :=  l_contact_phone_rec.attribute23;
      self.attribute24          :=  l_contact_phone_rec.attribute24;
      self.attribute25          :=  l_contact_phone_rec.attribute25;
      self.attribute26          :=  l_contact_phone_rec.attribute26;
      self.attribute27          :=  l_contact_phone_rec.attribute27;
      self.attribute28          :=  l_contact_phone_rec.attribute28;
      self.attribute29          :=  l_contact_phone_rec.attribute29;
      self.attribute30          :=  l_contact_phone_rec.attribute30;

    END IF;

    RETURN;
  END;

  MEMBER FUNCTION get_xml RETURN XMLType
  IS
    l_xml                   XMLType;
    l_txn_steps             xxas_hr_api_txn_steps;

    CURSOR csr_contact_xml IS
    SELECT  XMLElement
              ("ROW",
                XMLForest
                  (self.phone_id             as phone_id
                  ,self.date_from            as date_from
                  ,self.date_to              as date_to
                  ,self.phone_type           as phone_type
                  ,self.phone_type_meaning   as phone_type_meaning
                  ,self.phone_number         as phone_number
                  ,self.parent_id            as parent_id
                  ,self.person_id            as person_id
                  ,self.object_version_number as object_version_number
                  ,self.attribute_category   as attribute_category
                  ,self.attribute1           as attribute1
                  ,self.attribute2           as attribute2
                  ,self.attribute3           as attribute3
                  ,self.attribute4           as attribute4
                  ,self.attribute5           as attribute5
                  ,self.attribute6           as attribute6
                  ,self.attribute7           as attribute7
                  ,self.attribute8           as attribute8
                  ,self.attribute9           as attribute9
                  ,self.attribute10          as attribute10
                  ,self.attribute11          as attribute11
                  ,self.attribute12          as attribute12
                  ,self.attribute13          as attribute13
                  ,self.attribute14          as attribute14
                  ,self.attribute15          as attribute15
                  ,self.attribute16          as attribute16
                  ,self.attribute17          as attribute17
                  ,self.attribute18          as attribute18
                  ,self.attribute19          as attribute19
                  ,self.attribute20          as attribute20
                  ,self.attribute21          as attribute21
                  ,self.attribute22          as attribute22
                  ,self.attribute23          as attribute23
                  ,self.attribute24          as attribute24
                  ,self.attribute25          as attribute25
                  ,self.attribute26          as attribute26
                  ,self.attribute27          as attribute27
                  ,self.attribute28          as attribute28
                  ,self.attribute29          as attribute29
                  ,self.attribute30          as attribute30
                  )
              )
    FROM DUAL;


  BEGIN

    IF self.transaction_step_id IS NULL THEN

      OPEN  csr_contact_xml;
      FETCH csr_contact_xml INTO l_xml;
      CLOSE csr_contact_xml;

    ELSE

      l_txn_steps := xxas_hr_api_txn_steps(self.transaction_id, self.transaction_step_id);
      l_xml := l_txn_steps.get_xml();

    END IF;

    RETURN l_xml;

  END;

END;
/

CREATE OR REPLACE TYPE BODY xxas_per_address IS

  CONSTRUCTOR FUNCTION xxas_per_address
    (p_person_id            IN  NUMBER
    ,p_address_id           IN  NUMBER DEFAULT NULL
    ,p_transaction_id       IN  NUMBER DEFAULT NULL
    ,p_transaction_step_id  IN  NUMBER DEFAULT NULL) RETURN SELF AS RESULT

  IS

    CURSOR csr_per_address IS
    SELECT  pa.*
    FROM    per_addresses pa
    WHERE   pa.person_id    = p_person_id
    AND     pa.address_id   = p_address_id;

    l_per_address   csr_per_address%ROWTYPE;
    
    CURSOR csr_lat_lon  IS
    SELECT g.*
    FROM   TABLE(sdo_util.getvertices(self.geometry)) g;
    
    l_lat_lon   csr_lat_lon%ROWTYPE;


    CURSOR csr_per_address_pend IS
    SELECT  hats.transaction_step_id
    FROM    hr_api_transactions hat, hr_api_transaction_steps hats
    WHERE   hat.transaction_id      = p_transaction_id
    AND     hat.selected_person_id  = fnd_profile.value('PER_PERSON_ID')
    AND     hat.status              NOT IN ('D', 'N', 'W', 'ACTIVE', 'AC')
    AND     hats.transaction_id     = hat.transaction_id
    AND     hats.api_name           = 'HR_PROCESS_ADDRESS_SS.PROCESS_API';

  BEGIN

    IF p_transaction_step_id IS NOT NULL AND p_transaction_step_id <> -1 THEN
      self.person_id              := p_person_id;
      self.transaction_id         := p_transaction_id;
      self.transaction_step_id    := p_transaction_step_id;
    ELSE

      OPEN  csr_per_address;
      FETCH csr_per_address INTO l_per_address;
      CLOSE csr_per_address;


      self.address_id               :=  l_per_address.address_id;
      self.business_group_id        :=  l_per_address.business_group_id;
      self.person_id                :=  l_per_address.person_id;
      self.date_from                :=  l_per_address.date_from;
      self.primary_flag             :=  l_per_address.primary_flag;
      self.style                    :=  l_per_address.style;
      self.address_line1            :=  l_per_address.address_line1;
      self.address_line2            :=  l_per_address.address_line2;
      self.address_line3            :=  l_per_address.address_line3;
      self.address_type             :=  l_per_address.address_type;
      self.country                  :=  l_per_address.country;
      self.date_to                  :=  l_per_address.date_to;
      self.postal_code              :=  l_per_address.postal_code;
      self.region_1                 :=  l_per_address.region_1;
      self.region_2                 :=  l_per_address.region_2;
      self.region_3                 :=  l_per_address.region_3;
      self.telephone_number_1       :=  l_per_address.telephone_number_1;
      self.telephone_number_2       :=  l_per_address.telephone_number_2;
      self.telephone_number_3       :=  l_per_address.telephone_number_3;
      self.town_or_city             :=  l_per_address.town_or_city;
      self.addr_attribute_category  :=  l_per_address.addr_attribute_category;
      self.addr_attribute1          :=  l_per_address.addr_attribute1;
      self.addr_attribute2          :=  l_per_address.addr_attribute2;
      self.addr_attribute3          :=  l_per_address.addr_attribute3;
      self.addr_attribute4          :=  l_per_address.addr_attribute4;
      self.addr_attribute5          :=  l_per_address.addr_attribute5;
      self.addr_attribute6          :=  l_per_address.addr_attribute6;
      self.addr_attribute7          :=  l_per_address.addr_attribute7;
      self.addr_attribute8          :=  l_per_address.addr_attribute8;
      self.addr_attribute9          :=  l_per_address.addr_attribute9;
      self.addr_attribute10         :=  l_per_address.addr_attribute10;
      self.addr_attribute11         :=  l_per_address.addr_attribute11;
      self.addr_attribute12         :=  l_per_address.addr_attribute12;
      self.addr_attribute13         :=  l_per_address.addr_attribute13;
      self.addr_attribute14         :=  l_per_address.addr_attribute14;
      self.addr_attribute15         :=  l_per_address.addr_attribute15;
      self.addr_attribute16         :=  l_per_address.addr_attribute16;
      self.addr_attribute17         :=  l_per_address.addr_attribute17;
      self.addr_attribute18         :=  l_per_address.addr_attribute18;
      self.addr_attribute19         :=  l_per_address.addr_attribute19;
      self.addr_attribute20         :=  l_per_address.addr_attribute20;
      self.last_update_date         :=  l_per_address.last_update_date;
      self.creation_date            :=  l_per_address.creation_date;
      self.object_version_number    :=  l_per_address.object_version_number;
      self.add_information13        :=  l_per_address.add_information13;
      self.add_information14        :=  l_per_address.add_information14;
      self.add_information15        :=  l_per_address.add_information15;
      self.add_information16        :=  l_per_address.add_information16;
      self.add_information17        :=  l_per_address.add_information17;
      self.add_information18        :=  l_per_address.add_information18;
      self.add_information19        :=  l_per_address.add_information19;
      self.add_information20        :=  l_per_address.add_information20;
      self.geometry                 :=  l_per_address.geometry;
      
      OPEN    csr_lat_lon;
      FETCH   csr_lat_lon INTO l_lat_lon;
      CLOSE   csr_lat_lon;
      
      self.latitude                 :=  l_lat_lon.y;
      self.longitude                :=  l_lat_lon.x;
      self.comments                 :=  l_per_address.comments;


    END IF;

    RETURN;

  END;
  
  MEMBER FUNCTION get_xml RETURN XMLType
  IS
  
    l_xml                   XMLType;
    l_txn_steps             xxas_hr_api_txn_steps;
    
    CURSOR csr_address_xml IS
    SELECT  XMLElement
              ("ROW",
                XMLForest
                  (self.address_id               as address_id
                  ,self.business_group_id        as business_group_id
                  ,self.person_id                as person_id
                  ,self.date_from                as date_from
                  ,self.primary_flag             as primary_flag
                  ,self.style                    as style
                  ,self.address_line1            as address_line1
                  ,self.address_line2            as address_line2
                  ,self.address_line3            as address_line3
                  ,self.address_type             as address_type
                  ,self.country                  as country
                  ,self.date_to                  as date_to
                  ,self.postal_code              as postal_code
                  ,self.region_1                 as region_1
                  ,self.region_2                 as region_2
                  ,self.region_3                 as region_3
                  ,self.telephone_number_1       as telephone_number_1
                  ,self.telephone_number_2       as telephone_number_2
                  ,self.telephone_number_3       as telephone_number_3
                  ,self.town_or_city             as town_or_city
                  ,self.addr_attribute_category  as addr_attribute_category
                  ,self.addr_attribute1          as addr_attribute1
                  ,self.addr_attribute2          as addr_attribute2
                  ,self.addr_attribute3          as addr_attribute3
                  ,self.addr_attribute4          as addr_attribute4
                  ,self.addr_attribute5          as addr_attribute5
                  ,self.addr_attribute6          as addr_attribute6
                  ,self.addr_attribute7          as addr_attribute7
                  ,self.addr_attribute8          as addr_attribute8
                  ,self.addr_attribute9          as addr_attribute9
                  ,self.addr_attribute10         as addr_attribute10
                  ,self.addr_attribute11         as addr_attribute11
                  ,self.addr_attribute12         as addr_attribute12
                  ,self.addr_attribute13         as addr_attribute13
                  ,self.addr_attribute14         as addr_attribute14
                  ,self.addr_attribute15         as addr_attribute15
                  ,self.addr_attribute16         as addr_attribute16
                  ,self.addr_attribute17         as addr_attribute17
                  ,self.addr_attribute18         as addr_attribute18
                  ,self.addr_attribute19         as addr_attribute19
                  ,self.addr_attribute20         as addr_attribute20
                  ,self.last_update_date         as last_update_date
                  ,self.creation_date            as creation_date
                  ,self.object_version_number    as object_version_number
                  ,self.add_information13        as add_information13
                  ,self.add_information14        as add_information14
                  ,self.add_information15        as add_information15
                  ,self.add_information16        as add_information16
                  ,self.add_information17        as add_information17
                  ,self.add_information18        as add_information18
                  ,self.add_information19        as add_information19
                  ,self.add_information20        as add_information20
                  ,self.latitude                 as latitude
                  ,self.longitude                as longitude
                  ,self.comments                 as comments
                  )
              )
    FROM DUAL;    
  
  BEGIN
  
    IF self.transaction_step_id IS NULL THEN
    
      OPEN  csr_address_xml;
      FETCH csr_address_xml INTO l_xml; 
      CLOSE csr_address_xml;
  
    ELSE
    
      l_txn_steps := xxas_hr_api_txn_steps(self.transaction_id, self.transaction_step_id);
      l_xml := l_txn_steps.get_xml();    
    
    END IF;
    
    RETURN l_xml;
  
  END;
END;
/

CREATE OR REPLACE TYPE BODY xxas_emp_contact IS

  MEMBER FUNCTION get_addresses_tbl
    (p_person_id            IN NUMBER
    ,p_contact_person_id    IN NUMBER DEFAULT NULL
    ,p_transaction_id       IN NUMBER DEFAULT NULL) RETURN xxas_per_addresses_tbl
  IS
    
    CURSOR csr_contact_addresses IS
    SELECT  pa.*
    FROM    per_addresses pa
    WHERE   pa.person_id = p_contact_person_id;
    
    CURSOR csr_contact_addresses_pend IS
    SELECT  NULL address_id,
            hats.transaction_step_id
    FROM    hr_api_transactions hat,
            hr_api_transaction_steps hats,
            hr_api_transaction_values hatv
    WHERE   hat.transaction_id         = p_transaction_id
    --AND     hat.selected_person_id     = fnd_profile.value('PER_PERSON_ID')
    AND     hat.status                 NOT IN ('D', 'N', 'W', 'ACTIVE', 'AC')
    AND     hats.transaction_id        = hat.transaction_id
    AND     hats.api_name              = 'HR_PROCESS_ADDRESS_SS.PROCESS_API'
    AND     hats.transaction_step_id   = hatv.transaction_step_id
    AND     hatv.name                  = 'P_ADDRESS_ID'
    AND     hatv.number_value         IS NULL

    UNION ALL
    SELECT  hatv.number_value address_id,
            hats.transaction_step_id
    FROM    hr_api_transactions hat,
            hr_api_transaction_steps hats,
            hr_api_transaction_values hatv
    WHERE   hat.transaction_id         = p_transaction_id
    --AND     hat.selected_person_id     = fnd_profile.value('PER_PERSON_ID')
    AND     hat.status                 NOT IN ('D', 'N', 'W', 'ACTIVE', 'AC')
    AND     hats.transaction_id        = hat.transaction_id
    AND     hats.api_name              = 'HR_PROCESS_ADDRESS_SS.PROCESS_API'
    AND     hats.transaction_step_id   = hatv.transaction_step_id
    AND     hatv.name                  = 'P_ADDRESS_ID'
    AND     hatv.number_value         IS NOT NULL;    
    
    TYPE address_ids_r IS RECORD
       (address_id             NUMBER
       ,transaction_step_id    NUMBER);

    TYPE address_ids_t IS TABLE OF address_ids_r INDEX BY BINARY_INTEGER;    
    
    l_per_addresses_tbl xxas_per_addresses_tbl := xxas_per_addresses_tbl();
    l_address_ids       address_ids_t;
    l_address_count     NUMBER := 1;
    
  BEGIN
  
    FOR l_rec IN csr_contact_addresses LOOP
      l_address_ids(l_address_count).address_id            := l_rec.address_id;
      l_address_ids(l_address_count).transaction_step_id := -1;

      l_address_count := l_address_count + 1;      
    END LOOP;
    
    
    FOR l_rec IN csr_contact_addresses_pend LOOP
      IF l_rec.address_id IS NOT NULL THEN
        FOR i IN 1..l_address_ids.COUNT LOOP
          IF l_address_ids(i).address_id = l_rec.address_id THEN
            l_address_ids(i).transaction_step_id := l_rec.transaction_step_id;
          END IF;
        END LOOP;
      ELSE
        l_address_ids(l_address_count).address_id := -1;
        l_address_ids(l_address_count).transaction_step_id := l_rec.transaction_step_id;

        l_address_count := l_address_count + 1;
      END IF;
    END LOOP;    
    
    
    FOR i IN 1..l_address_ids.COUNT LOOP
      l_per_addresses_tbl.EXTEND;
      l_per_addresses_tbl(l_per_addresses_tbl.count)
                                            := xxas_per_address
                                                (p_contact_person_id, l_address_ids(i).address_id, p_transaction_id, l_address_ids(i).transaction_step_id);

    END LOOP;    
    
    RETURN l_per_addresses_tbl;
  END;
  
  MEMBER FUNCTION get_addresses_xml RETURN XMLType
  IS
  
    l_address_clob  CLOB;
    l_temp        CLOB;
    l_xml         XMLType;

  BEGIN

    dbms_lob.createtemporary(l_address_clob, true);
    dbms_lob.createtemporary(l_temp, true);
--<CONTACT_PHONE_NUMBERS json:force-array="true" xmlns:json="http://json.org/">abc</CONTACT_PHONE_NUMBERS>
    l_address_clob := TO_CLOB('<CONTACT_ADDRESSES json:force-array="true" xmlns:json="http://json.org/">');

    FOR i IN 1..self.contact_addresses_tbl.COUNT LOOP
      l_temp := self.contact_addresses_tbl(i).get_xml().getClobVal();
      dbms_lob.append(l_address_clob,l_temp);
    END LOOP;

    dbms_lob.append(l_address_clob,TO_CLOB('</CONTACT_ADDRESSES>'));
    
    l_xml := XMLType(l_address_clob);

    dbms_lob.freetemporary(l_address_clob);
    dbms_lob.freetemporary(l_temp);

    RETURN l_xml;
  
  END;

  CONSTRUCTOR FUNCTION xxas_emp_contact
    (p_person_id              IN NUMBER
    ,p_contact_person_id      IN NUMBER DEFAULT NULL
    ,p_transaction_id         IN NUMBER DEFAULT NULL) RETURN SELF AS RESULT
  IS

    TYPE phone_ids_r IS RECORD
       (phone_id               NUMBER
       ,transaction_step_id    NUMBER);

    TYPE phone_ids_t IS TABLE OF phone_ids_r INDEX BY BINARY_INTEGER;

    l_phone_rec      NUMBER;
    l_phone_ids      phone_ids_t;
    l_phone_count    NUMBER := 1;

    CURSOR csr_contact_phones IS
    SELECT  pp.*
    FROM    per_phones pp
    WHERE   pp.parent_id    = p_contact_person_id
    AND     pp.parent_table = 'PER_ALL_PEOPLE_F'
    AND     TRUNC(SYSDATE) >= pp.date_from
    AND     TRUNC(SYSDATE) <= NVL(pp.date_to,TO_DATE('31-12-4712','DD-MM-YYYY'));

    CURSOR csr_contact_phones_pend IS
    SELECT  NULL phone_id,
            hats.transaction_step_id
    FROM    hr_api_transactions hat,
            hr_api_transaction_steps hats,
            hr_api_transaction_values hatv
    WHERE   hat.transaction_id         = p_transaction_id
    --AND     hat.selected_person_id     = fnd_profile.value('PER_PERSON_ID')
    AND     hat.status                 NOT IN ('D', 'N', 'W', 'ACTIVE', 'AC')
    AND     hats.transaction_id        = hat.transaction_id
    AND     hats.api_name              = 'HR_PROCESS_PHONE_NUMBERS_SS.PROCESS_API'
    AND     hats.transaction_step_id   = hatv.transaction_step_id
    AND     hatv.name                  = 'P_PHONE_ID'
    AND     hatv.number_value         IS NULL

    UNION ALL
    SELECT  hatv.number_value phone_id,
            hats.transaction_step_id
    FROM    hr_api_transactions hat,
            hr_api_transaction_steps hats,
            hr_api_transaction_values hatv
    WHERE   hat.transaction_id         = p_transaction_id
    --AND     hat.selected_person_id     = fnd_profile.value('PER_PERSON_ID')
    AND     hat.status                 NOT IN ('D', 'N', 'W', 'ACTIVE', 'AC')
    AND     hats.transaction_id        = hat.transaction_id
    AND     hats.api_name              = 'HR_PROCESS_PHONE_NUMBERS_SS.PROCESS_API'
    AND     hats.transaction_step_id   = hatv.transaction_step_id
    AND     hatv.name                  = 'P_PHONE_ID'
    AND     hatv.number_value         IS NOT NULL;

  BEGIN
    self.contact_basic_details  := xxas_emp_contact_basic_details(p_person_id, p_contact_person_id, p_transaction_id);

    self.contact_phone_numbers_tbl := xxas_per_phn_numbers_tbl();
    self.contact_addresses_tbl     := xxas_per_addresses_tbl();

    FOR l_rec IN csr_contact_phones LOOP
      l_phone_ids(l_phone_count).phone_id            := l_rec.phone_id;
      l_phone_ids(l_phone_count).transaction_step_id := -1;

      l_phone_count := l_phone_count + 1;
    END LOOP;

    FOR l_rec IN csr_contact_phones_pend LOOP
      IF l_rec.phone_id IS NOT NULL THEN
        FOR i IN 1..l_phone_ids.COUNT LOOP
          IF l_phone_ids(i).phone_id = l_rec.phone_id THEN
            l_phone_ids(i).transaction_step_id := l_rec.transaction_step_id;
          END IF;
        END LOOP;
      ELSE
        l_phone_ids(l_phone_count).phone_id := -1;
        l_phone_ids(l_phone_count).transaction_step_id := l_rec.transaction_step_id;

        l_phone_count := l_phone_count + 1;
      END IF;
    END LOOP;

    FOR i IN 1..l_phone_ids.COUNT LOOP
      self.contact_phone_numbers_tbl.EXTEND;
      self.contact_phone_numbers_tbl(self.contact_phone_numbers_tbl.count)
                                            := xxas_per_phone_number
                                                (p_contact_person_id, l_phone_ids(i).phone_id, p_transaction_id, l_phone_ids(i).transaction_step_id);

    END LOOP;
    
    self.contact_addresses_tbl  := get_addresses_tbl(p_person_id, p_contact_person_id, p_transaction_id);
    
    RETURN;
  END;
  

  MEMBER FUNCTION get_phones_xml RETURN XMLType
  IS

    l_phone_clob  CLOB;
    l_temp        CLOB;
    l_xml         XMLType;

  BEGIN

    dbms_lob.createtemporary(l_phone_clob, true);
    dbms_lob.createtemporary(l_temp, true);
--<CONTACT_PHONE_NUMBERS json:force-array="true" xmlns:json="http://json.org/">abc</CONTACT_PHONE_NUMBERS>
    l_phone_clob := TO_CLOB('<CONTACT_PHONE_NUMBERS json:force-array="true" xmlns:json="http://json.org/">');

    FOR i IN 1..self.contact_phone_numbers_tbl.COUNT LOOP
      l_temp := self.contact_phone_numbers_tbl(i).get_xml().getClobVal();
      dbms_lob.append(l_phone_clob,l_temp);
    END LOOP;

    dbms_lob.append(l_phone_clob,TO_CLOB('</CONTACT_PHONE_NUMBERS>'));
    l_xml := XMLType(l_phone_clob);

    dbms_lob.freetemporary(l_phone_clob);
    dbms_lob.freetemporary(l_temp);

    RETURN l_xml;
  END get_phones_xml;



  MEMBER FUNCTION get_xml RETURN XMLType
  IS
    l_xml XMLType;

    CURSOR csr_contact_xml IS
    SELECT XMLElement
            ("ROW"
            ,self.contact_basic_details.get_xml().EXTRACT('ROW/*')
            ,self.get_phones_xml()
            ,self.get_addresses_xml()
            )
    FROM DUAL;

  BEGIN

    OPEN  csr_contact_xml;
    FETCH csr_contact_xml INTO l_xml;
    CLOSE csr_contact_xml;

    RETURN l_xml;
  END;


END;
/

COMMIT;
EXIT;