/* $Id$ */
/*============================================================================*
 |                 Copyright (c) 2014 Applaud Solutions UK Ltd                |
 |                             All rights reserved                            |
 *===========================================================================*/

SET VERIFY OFF
SET FEEDBACK OFF
SET SCAN OFF
WHENEVER OSERROR  EXIT FAILURE ROLLBACK
WHENEVER SQLERROR EXIT FAILURE ROLLBACK

DECLARE

  --
  -- Local constants and variables
  --
  l_sql varchar2(32000);

BEGIN

  --
  -- Register Query Menu service
  --
  l_sql :=
q'[ SELECT xxas_com_srv_mgr_pkg.set_override_xml
             (XMLElement
               ("Output"
               ,XMLAttributes
                 ('SUCCESS' "rsltCode"
                 ,'Success' "rsltMsg")
               ,XMLElement
                 ("Menu"
                 ,XMLAttributes
                  (xxas_emp_menu_pkg.menu_name_to_id(fnd_profile.value('XXAS_EMP_REG_VIEWS_MENU')) "id"
                  ,fnd_profile.value('XXAS_EMP_REG_VIEWS_MENU') "code")
                 ,xxas_emp_menu_pkg.get_emp_menu_entries_xml_old
                  (xxas_emp_menu_pkg.menu_name_to_id(fnd_profile.value('XXAS_EMP_REG_VIEWS_MENU'))
                  ,:pObjectName
                  ,:pPrimaryKey1Value,:pPrimaryKey1Value2,:pPrimaryKey1Value3,:pPrimaryKey1Value4,:pPrimaryKey1Value5
                  ,:pObjectName2
                  ,:pPrimaryKey2Value1,:pPrimaryKey2Value2,:pPrimaryKey2Value3,:pPrimaryKey2Value4,:pPrimaryKey2Value5
                  ,:pObjectName3
                  ,:pPrimaryKey3Value1,:pPrimaryKey3Value2,:pPrimaryKey3Value3,:pPrimaryKey3Value4,:pPrimaryKey3Value5
                  ,:pObjectName4
                  ,:pPrimaryKey4Value1,:pPrimaryKey4Value2,:pPrimaryKey4Value3,:pPrimaryKey4Value4,:pPrimaryKey4Value5
                  ,:pObjectName5
                  ,:pPrimaryKey5Value1,:pPrimaryKey5Value2,:pPrimaryKey5Value3,:pPrimaryKey5Value4,:pPrimaryKey5Value5)
                 )
               )
             ) "data"
  FROM   dual
  ]';

  xxas_com_sr_pkg.seed_query_service
    (p_service_name      => 'QueryMenu'
    ,p_securing_function => 'XXAS_SRV_Q_EMP_VIEWS_PERM'
    ,p_sql               => l_sql
    ,p_parameters        => xxas_com_sr_param_varray
                              (xxas_com_sr_param_type('pObjectName'       , xxas_com_sr_pkg.g_VARCHAR2)
                              ,xxas_com_sr_param_type('pPrimaryKey1Value' , xxas_com_sr_pkg.g_VARCHAR2)
                              ,xxas_com_sr_param_type('pPrimaryKey1Value2', xxas_com_sr_pkg.g_VARCHAR2)
                              ,xxas_com_sr_param_type('pPrimaryKey1Value3', xxas_com_sr_pkg.g_VARCHAR2)
                              ,xxas_com_sr_param_type('pPrimaryKey1Value4', xxas_com_sr_pkg.g_VARCHAR2)
                              ,xxas_com_sr_param_type('pPrimaryKey1Value5', xxas_com_sr_pkg.g_VARCHAR2)
                              ,xxas_com_sr_param_type('pObjectName2'      , xxas_com_sr_pkg.g_VARCHAR2)
                              ,xxas_com_sr_param_type('pPrimaryKey2Value1', xxas_com_sr_pkg.g_VARCHAR2)
                              ,xxas_com_sr_param_type('pPrimaryKey2Value2', xxas_com_sr_pkg.g_VARCHAR2)
                              ,xxas_com_sr_param_type('pPrimaryKey2Value3', xxas_com_sr_pkg.g_VARCHAR2)
                              ,xxas_com_sr_param_type('pPrimaryKey2Value4', xxas_com_sr_pkg.g_VARCHAR2)
                              ,xxas_com_sr_param_type('pPrimaryKey2Value5', xxas_com_sr_pkg.g_VARCHAR2)
                              ,xxas_com_sr_param_type('pObjectName3'      , xxas_com_sr_pkg.g_VARCHAR2)
                              ,xxas_com_sr_param_type('pPrimaryKey3Value1', xxas_com_sr_pkg.g_VARCHAR2)
                              ,xxas_com_sr_param_type('pPrimaryKey3Value2', xxas_com_sr_pkg.g_VARCHAR2)
                              ,xxas_com_sr_param_type('pPrimaryKey3Value3', xxas_com_sr_pkg.g_VARCHAR2)
                              ,xxas_com_sr_param_type('pPrimaryKey3Value4', xxas_com_sr_pkg.g_VARCHAR2)
                              ,xxas_com_sr_param_type('pPrimaryKey3Value5', xxas_com_sr_pkg.g_VARCHAR2)
                              ,xxas_com_sr_param_type('pObjectName4'      , xxas_com_sr_pkg.g_VARCHAR2)
                              ,xxas_com_sr_param_type('pPrimaryKey4Value1', xxas_com_sr_pkg.g_VARCHAR2)
                              ,xxas_com_sr_param_type('pPrimaryKey4Value2', xxas_com_sr_pkg.g_VARCHAR2)
                              ,xxas_com_sr_param_type('pPrimaryKey4Value3', xxas_com_sr_pkg.g_VARCHAR2)
                              ,xxas_com_sr_param_type('pPrimaryKey4Value4', xxas_com_sr_pkg.g_VARCHAR2)
                              ,xxas_com_sr_param_type('pPrimaryKey4Value5', xxas_com_sr_pkg.g_VARCHAR2)
                              ,xxas_com_sr_param_type('pObjectName5'      , xxas_com_sr_pkg.g_VARCHAR2)
                              ,xxas_com_sr_param_type('pPrimaryKey5Value1', xxas_com_sr_pkg.g_VARCHAR2)
                              ,xxas_com_sr_param_type('pPrimaryKey5Value2', xxas_com_sr_pkg.g_VARCHAR2)
                              ,xxas_com_sr_param_type('pPrimaryKey5Value3', xxas_com_sr_pkg.g_VARCHAR2)
                              ,xxas_com_sr_param_type('pPrimaryKey5Value4', xxas_com_sr_pkg.g_VARCHAR2)
                              ,xxas_com_sr_param_type('pPrimaryKey5Value5', xxas_com_sr_pkg.g_VARCHAR2)));

END;
/
COMMIT;
EXIT;