/* $Id$ */
/*============================================================================*
 |                 Copyright (c) 2013 Applaud Solutions UK Ltd                |
 |                             All rights reserved                            |
 *===========================================================================*/

SET VERIFY OFF
SET FEEDBACK OFF
SET SCAN OFF
WHENEVER OSERROR  EXIT FAILURE ROLLBACK
WHENEVER SQLERROR EXIT FAILURE ROLLBACK

DECLARE

  --
  -- Local constants and variables
  --
  l_sql varchar2(32000);

BEGIN

  --
  -- Register Query Payslip Details
  --
  l_sql :=
'          SELECT xxas_payslip_pkg.get_payslip_details_xml(:pAssignmentId, :pPayslipId, :pTemplate, :pViewName) payslip_details
           FROM dual ';

  xxas_com_sr_pkg.seed_query_service
    (p_service_name        => 'QueryPayslipDetails'
    ,p_securing_function   => 'XXAS_SRV_Q_PAYSLIP_DET_PERM'
    ,p_sql                 => l_sql
    ,p_use_iso_date_format => false
    ,p_parameters          => xxas_com_sr_param_varray
                                (xxas_com_sr_param_type('pAssignmentId', xxas_com_sr_pkg.g_NUMBER)
                                ,xxas_com_sr_param_type('pPayslipId'   , xxas_com_sr_pkg.g_NUMBER)
                                ,xxas_com_sr_param_type('pTemplate'    , xxas_com_sr_pkg.g_VARCHAR2)
                                ,xxas_com_sr_param_type('pViewName'    , xxas_com_sr_pkg.g_VARCHAR2)));

END;
/
COMMIT;
EXIT;
