/* $Id$ */
/*============================================================================*
 |                 Copyright (c) 2013 Applaud Solutions UK Ltd                |
 |                             All rights reserved                            |
 *===========================================================================*/

SET VERIFY OFF
SET FEEDBACK OFF
SET SCAN OFF
WHENEVER OSERROR  EXIT FAILURE ROLLBACK
WHENEVER SQLERROR EXIT FAILURE ROLLBACK



DECLARE 

  e_dir_exists EXCEPTION;
  PRAGMA EXCEPTION_INIT(e_dir_exists, -31003);

  e_does_not_exists EXCEPTION;
  PRAGMA EXCEPTION_INIT(e_does_not_exists , -31001);

  result boolean;
  
BEGIN

  BEGIN

    result := DBMS_XDB.createfolder('/public/xxas/');
    result := DBMS_XDB.createfolder('/public/xxas/emp/');
    result := DBMS_XDB.createfolder('/public/xxas/emp/view/');

  EXCEPTION
    WHEN e_dir_exists THEN
      NULL;
  END;

  
  BEGIN

    DBMS_XDB.DeleteResource('/public/xxas/emp/view/applicantqualification.xml');

  EXCEPTION
    WHEN e_does_not_exists THEN
      NULL;
  END;

  
  result := DBMS_XDB.createresource('/public/xxas/emp/view/applicantqualification.xml',
'<View title="Applicant qualification" defaultFormHandler="xxas_applicant_pkg.save_application_form">

  <CreateFields>
    <TextInput id="ESTABLISHMENT" label="Establishment"/>
    <TextInput id="ADDRESS" label="Location"/>
    <Date id="START_DATE" label="Start Date"/>
    <Date id="END_DATE" label="End Date"/>
    <TextInput id="QUALIFICATION_NAME" label="Degree"/>
    <TextInput id="TITLE" label="Major Subject"/>
    <Date id="AWARDED_DATE" label="Date Received"/>				
    <TextInput id="PEA_ATTRIBUTE1_MEANING" label="Degree Level"/>
    <TextInput id="PEA_ATTRIBUTE2_MEANING" label="Major"/>
    <TextInput id="PEA_ATTRIBUTE3_MEANING" label="Minor"/>
    <TextInput id="PEA_ATTRIBUTE4_MEANING" label="Location"/>
    <TextInput id="PEA_ATTRIBUTE5_MEANING" label="Grade Point Average"/>		
    <TextInput id="PEA_ATTRIBUTE6_MEANING" label="Credits Earned"/>
    <Date id="PEA_ATTRIBUTE7_MEANING" label="Graduation Date"/>	

  </CreateFields>

</View>' ); 
xxas_forms_pkg.update_forms_resource('/public/xxas/emp/view/applicantqualification.xml');
END;
/
COMMIT;
EXIT;
