/* $Id$ */
/*============================================================================*
 |                 Copyright (c) 2013 Applaud Solutions UK Ltd                |
 |                             All rights reserved                            |
 *===========================================================================*/

SET VERIFY OFF
SET FEEDBACK OFF
SET SCAN OFF
WHENEVER OSERROR  EXIT FAILURE ROLLBACK
WHENEVER SQLERROR EXIT FAILURE ROLLBACK



DECLARE 

  e_dir_exists EXCEPTION;
  PRAGMA EXCEPTION_INIT(e_dir_exists, -31003);

  e_does_not_exists EXCEPTION;
  PRAGMA EXCEPTION_INIT(e_does_not_exists , -31001);

  result boolean;
  
BEGIN

  BEGIN

    result := DBMS_XDB.createfolder('/public/xxas/');
    result := DBMS_XDB.createfolder('/public/xxas/emp/');
    result := DBMS_XDB.createfolder('/public/xxas/emp/view/');

  EXCEPTION
    WHEN e_dir_exists THEN
      NULL;
  END;

  
  BEGIN

    DBMS_XDB.DeleteResource('/public/xxas/emp/view/personsit.xml');

  EXCEPTION
    WHEN e_does_not_exists THEN
      NULL;
  END;

  
  result := DBMS_XDB.createresource('/public/xxas/emp/view/personsit.xml',
'<View title="Person SIT" defaultFormHandler="xxas_person_sit_pkg">

  <CreateFields>
    
      <Date id="DATE_FROM" label="{message.XXAS_EMP_DATE_FROM}" enabled="true" required="true"/>
      <Date id="DATE_TO" label="{message.XXAS_EMP_DATE_TO}" enabled="true" required="false"/>

      <Flexfield applicationId ="800" flexCode="PEA" flexStructureCode="${param.pFlexStructureCode}" />
      
      <TextInput id="COMMENTS_TO_APPROVER" label="{message.XXAS_RB_TCM_APPR_CMNTS}" enabled="true" required="false"/>
      
      <Attachment id="ATTACHMENTS" label="{message.XXAS_RB_EMP_ATTACHMENTS}" enabled="true" required="false" entityName="PQH_SS_ATTACHMENT"
                  pk1Field="INSTANCE_PK2_VALUE" categoryCode="MISC"/>
    
  </CreateFields>

  <EditFields>
      <Date id="DATE_FROM" label="{message.XXAS_EMP_DATE_FROM}" enabled="true" required="true"/>
      <Date id="DATE_TO" label="{message.XXAS_EMP_DATE_TO}" enabled="true" required="false"/>

      <Flexfield applicationId ="800" flexCode="PEA" flexStructureCode="${param.pFlexStructureCode}" />

      <TextInput id="COMMENTS_TO_APPROVER" label="{message.XXAS_RB_TCM_APPR_CMNTS}" enabled="true" required="false"/>
      
      <Attachment id="ATTACHMENTS" label="{message.XXAS_RB_EMP_ATTACHMENTS}" enabled="true" required="false" entityName="PQH_SS_ATTACHMENT"
                  pk1Field="INSTANCE_PK2_VALUE" categoryCode="MISC"/>
  </EditFields>

</View>' ); 
xxas_forms_pkg.update_forms_resource('/public/xxas/emp/view/personsit.xml');
END;
/
COMMIT;
EXIT;
