/* $Id$ */
/*============================================================================*
 |                 Copyright (c) 2012 Applaud Solutions UK Ltd                |
 |                             All rights reserved                            |
 *===========================================================================*/

SET VERIFY OFF
SET FEEDBACK OFF
WHENEVER OSERROR  EXIT FAILURE ROLLBACK
WHENEVER SQLERROR EXIT FAILURE ROLLBACK

CREATE OR REPLACE VIEW xxas_leave_of_absence_v 
AS
SELECT paa.absence_attendance_id
,      paa.object_version_number
,      paa.business_group_id
,      paa.absence_attendance_type_id            absence_type_id
,      paat.name                                 absence_type
,      paat.absence_category                     absence_category_code
,      fcl.meaning                               absence_category
,      paa.abs_attendance_reason_id
,      (SELECT rea.meaning     
        FROM   per_abs_attendance_reasons paar
        ,      hr_lookups                 rea
        WHERE  paa.abs_attendance_reason_id   = paar.abs_attendance_reason_id
        AND    paar.name                      = rea.lookup_code
        AND    rea.lookup_type                = 'ABSENCE_REASON') absence_reason 
,      paa.person_id 
,      paa.authorising_person_id
,      paa.replacement_person_id
,      paa.period_of_incapacity_id
,      paa.absence_days
,      paa.absence_hours
,      paa.date_end
,      paa.date_notification
,      paa.date_projected_end
,      paa.date_projected_start
,      paa.date_start
,      paa.occurrence
,      paa.ssp1_issued 
,      paa.time_end
,      paa.time_projected_end
,      paa.time_projected_start
,      paa.time_start
,      paa.attribute_category
,      paa.attribute1
,      xxas_com_vset_pkg.decode_descr_vset_value
         ('800'
         ,'PER_ABSENCE_ATTENDANCES'
         ,paa.attribute_category
         ,'ATTRIBUTE1'
         ,paa.attribute1)                        attribute1_meaning 
,      paa.attribute2
,      xxas_com_vset_pkg.decode_descr_vset_value
         ('800'
         ,'PER_ABSENCE_ATTENDANCES'
         ,paa.attribute_category
         ,'ATTRIBUTE2'
         ,paa.attribute2)                        attribute2_meaning 
,      paa.attribute3
,      xxas_com_vset_pkg.decode_descr_vset_value
         ('800'
         ,'PER_ABSENCE_ATTENDANCES'
         ,paa.attribute_category
         ,'ATTRIBUTE3'
         ,paa.attribute3)                        attribute3_meaning 
,      paa.attribute4
,      xxas_com_vset_pkg.decode_descr_vset_value
         ('800'
         ,'PER_ABSENCE_ATTENDANCES'
         ,paa.attribute_category
         ,'ATTRIBUTE4'
         ,paa.attribute4)                        attribute4_meaning 
,      paa.attribute5
,      xxas_com_vset_pkg.decode_descr_vset_value
         ('800'
         ,'PER_ABSENCE_ATTENDANCES'
         ,paa.attribute_category
         ,'ATTRIBUTE5'
         ,paa.attribute5)                        attribute5_meaning 
,      paa.attribute6
,      xxas_com_vset_pkg.decode_descr_vset_value
         ('800'
         ,'PER_ABSENCE_ATTENDANCES'
         ,paa.attribute_category
         ,'ATTRIBUTE6'
         ,paa.attribute6)                        attribute6_meaning 
,      paa.attribute7
,      xxas_com_vset_pkg.decode_descr_vset_value
         ('800'
         ,'PER_ABSENCE_ATTENDANCES'
         ,paa.attribute_category
         ,'ATTRIBUTE7'
         ,paa.attribute7)                        attribute7_meaning 
,      paa.attribute8
,      xxas_com_vset_pkg.decode_descr_vset_value
         ('800'
         ,'PER_ABSENCE_ATTENDANCES'
         ,paa.attribute_category
         ,'ATTRIBUTE8'
         ,paa.attribute8)                        attribute8_meaning 
,      paa.attribute9
,      xxas_com_vset_pkg.decode_descr_vset_value
         ('800'
         ,'PER_ABSENCE_ATTENDANCES'
         ,paa.attribute_category
         ,'ATTRIBUTE9'
         ,paa.attribute9)                        attribute9_meaning 
,      paa.attribute10
,      xxas_com_vset_pkg.decode_descr_vset_value
         ('800'
         ,'PER_ABSENCE_ATTENDANCES'
         ,paa.attribute_category
         ,'ATTRIBUTE10'
         ,paa.attribute10)                      attribute10_meaning 
,      paa.attribute11
,      xxas_com_vset_pkg.decode_descr_vset_value
         ('800'
         ,'PER_ABSENCE_ATTENDANCES'
         ,paa.attribute_category
         ,'ATTRIBUTE11'
         ,paa.attribute11)                      attribute11_meaning 
,      paa.attribute12
,      xxas_com_vset_pkg.decode_descr_vset_value
         ('800'
         ,'PER_ABSENCE_ATTENDANCES'
         ,paa.attribute_category
         ,'ATTRIBUTE12'
         ,paa.attribute12)                       attribute12_meaning 
,      paa.attribute13
,      xxas_com_vset_pkg.decode_descr_vset_value
         ('800'
         ,'PER_ABSENCE_ATTENDANCES'
         ,paa.attribute_category
         ,'ATTRIBUTE13'
         ,paa.attribute13)                       attribute13_meaning 
,      paa.attribute14
,      xxas_com_vset_pkg.decode_descr_vset_value
         ('800'
         ,'PER_ABSENCE_ATTENDANCES'
         ,paa.attribute_category
         ,'ATTRIBUTE14'
         ,paa.attribute14)                       attribute14_meaning 
,      paa.attribute15
,      xxas_com_vset_pkg.decode_descr_vset_value
         ('800'
         ,'PER_ABSENCE_ATTENDANCES'
         ,paa.attribute_category
         ,'ATTRIBUTE15'
         ,paa.attribute15)                       attribute15_meaning 
,      paa.attribute16
,      xxas_com_vset_pkg.decode_descr_vset_value
         ('800'
         ,'PER_ABSENCE_ATTENDANCES'
         ,paa.attribute_category
         ,'ATTRIBUTE16'
         ,paa.attribute16)                       attribute16_meaning 
,      paa.attribute17
,      xxas_com_vset_pkg.decode_descr_vset_value
         ('800'
         ,'PER_ABSENCE_ATTENDANCES'
         ,paa.attribute_category
         ,'ATTRIBUTE17'
         ,paa.attribute17)                       attribute17_meaning 
,      paa.attribute18
,      xxas_com_vset_pkg.decode_descr_vset_value
         ('800'
         ,'PER_ABSENCE_ATTENDANCES'
         ,paa.attribute_category
         ,'ATTRIBUTE18'
         ,paa.attribute18)                       attribute18_meaning 
,      paa.attribute19
,      xxas_com_vset_pkg.decode_descr_vset_value
         ('800'
         ,'PER_ABSENCE_ATTENDANCES'
         ,paa.attribute_category
         ,'ATTRIBUTE19'
         ,paa.attribute19)                       attribute19_meaning 
,      paa.attribute20
,      xxas_com_vset_pkg.decode_descr_vset_value
         ('800'
         ,'PER_ABSENCE_ATTENDANCES'
         ,paa.attribute_category
         ,'ATTRIBUTE20'
         ,paa.attribute20)                       attribute20_meaning 
,      paa.last_update_date
,      paa.last_updated_by
,      paa.last_update_login
,      paa.created_by
,      paa.creation_date
,      paa.maternity_id
,      paa.sickness_start_date
,      paa.sickness_end_date
,      paa.pregnancy_related_illness 
,      paa.reason_for_notification_delay 
,      paa.accept_late_notification_flag
,      paa.linked_absence_id
,      paa.abs_information_category
,      paa.abs_information1
,      xxas_com_vset_pkg.decode_descr_vset_value
         ('800'
         ,'PER_ABS_DEVELOPER_DF'
         ,paa.abs_information_category
         ,'ABS_INFORMATION1'
         ,paa.abs_information1)                  abs_information1_meaning 
,      paa.abs_information2
,      xxas_com_vset_pkg.decode_descr_vset_value
         ('800'
         ,'PER_ABS_DEVELOPER_DF'
         ,paa.abs_information_category
         ,'ABS_INFORMATION2'
         ,paa.abs_information2)                  abs_information2_meaning
,      paa.abs_information3
,      xxas_com_vset_pkg.decode_descr_vset_value
         ('800'
         ,'PER_ABS_DEVELOPER_DF'
         ,paa.abs_information_category
         ,'ABS_INFORMATION3'
         ,paa.abs_information3)                  abs_information3_meaning
,      paa.abs_information4
,      xxas_com_vset_pkg.decode_descr_vset_value
         ('800'
         ,'PER_ABS_DEVELOPER_DF'
         ,paa.abs_information_category
         ,'ABS_INFORMATION4'
         ,paa.abs_information4)                  abs_information4_meaning
,      paa.abs_information5
,      xxas_com_vset_pkg.decode_descr_vset_value
         ('800'
         ,'PER_ABS_DEVELOPER_DF'
         ,paa.abs_information_category
         ,'ABS_INFORMATION5'
         ,paa.abs_information5)                  abs_information5_meaning
,      paa.abs_information6
,      xxas_com_vset_pkg.decode_descr_vset_value
         ('800'
         ,'PER_ABS_DEVELOPER_DF'
         ,paa.abs_information_category
         ,'ABS_INFORMATION6'
         ,paa.abs_information6)                  abs_information6_meaning
,      paa.abs_information7
,      xxas_com_vset_pkg.decode_descr_vset_value
         ('800'
         ,'PER_ABS_DEVELOPER_DF'
         ,paa.abs_information_category
         ,'ABS_INFORMATION7'
         ,paa.abs_information7)                  abs_information7_meaning
,      paa.abs_information8
,      xxas_com_vset_pkg.decode_descr_vset_value
         ('800'
         ,'PER_ABS_DEVELOPER_DF'
         ,paa.abs_information_category
         ,'ABS_INFORMATION8'
         ,paa.abs_information8)                  abs_information8_meaning
,      paa.abs_information9
,      xxas_com_vset_pkg.decode_descr_vset_value
         ('800'
         ,'PER_ABS_DEVELOPER_DF'
         ,paa.abs_information_category
         ,'ABS_INFORMATION9'
         ,paa.abs_information9)                  abs_information9_meaning
,      paa.abs_information10
,      xxas_com_vset_pkg.decode_descr_vset_value
         ('800'
         ,'PER_ABS_DEVELOPER_DF'
         ,paa.abs_information_category
         ,'ABS_INFORMATION10'
         ,paa.abs_information10)                 abs_information10_meaning
,      paa.abs_information11
,      xxas_com_vset_pkg.decode_descr_vset_value
         ('800'
         ,'PER_ABS_DEVELOPER_DF'
         ,paa.abs_information_category
         ,'ABS_INFORMATION11'
         ,paa.abs_information11)                 abs_information11_meaning
,      paa.abs_information12
,      xxas_com_vset_pkg.decode_descr_vset_value
         ('800'
         ,'PER_ABS_DEVELOPER_DF'
         ,paa.abs_information_category
         ,'ABS_INFORMATION12'
         ,paa.abs_information12)                 abs_information12_meaning
,      paa.abs_information13
,      xxas_com_vset_pkg.decode_descr_vset_value
         ('800'
         ,'PER_ABS_DEVELOPER_DF'
         ,paa.abs_information_category
         ,'ABS_INFORMATION13'
         ,paa.abs_information13)                 abs_information13_meaning
,      paa.abs_information14
,      xxas_com_vset_pkg.decode_descr_vset_value
         ('800'
         ,'PER_ABS_DEVELOPER_DF'
         ,paa.abs_information_category
         ,'ABS_INFORMATION14'
         ,paa.abs_information14)                 abs_information14_meaning
,      paa.abs_information15
,      xxas_com_vset_pkg.decode_descr_vset_value
         ('800'
         ,'PER_ABS_DEVELOPER_DF'
         ,paa.abs_information_category
         ,'ABS_INFORMATION15'
         ,paa.abs_information15)                 abs_information15_meaning
,      paa.abs_information16
,      xxas_com_vset_pkg.decode_descr_vset_value
         ('800'
         ,'PER_ABS_DEVELOPER_DF'
         ,paa.abs_information_category
         ,'ABS_INFORMATION16'
         ,paa.abs_information16)                 abs_information16_meaning
,      paa.abs_information17
,      xxas_com_vset_pkg.decode_descr_vset_value
         ('800'
         ,'PER_ABS_DEVELOPER_DF'
         ,paa.abs_information_category
         ,'ABS_INFORMATION17'
         ,paa.abs_information17)                 abs_information17_meaning
,      paa.abs_information18
,      xxas_com_vset_pkg.decode_descr_vset_value
         ('800'
         ,'PER_ABS_DEVELOPER_DF'
         ,paa.abs_information_category
         ,'ABS_INFORMATION18'
         ,paa.abs_information18)                 abs_information18_meaning
,      paa.abs_information19
,      xxas_com_vset_pkg.decode_descr_vset_value
         ('800'
         ,'PER_ABS_DEVELOPER_DF'
         ,paa.abs_information_category
         ,'ABS_INFORMATION19'
         ,paa.abs_information19)                 abs_information19_meaning
,      paa.abs_information20
,      xxas_com_vset_pkg.decode_descr_vset_value
         ('800'
         ,'PER_ABS_DEVELOPER_DF'
         ,paa.abs_information_category
         ,'ABS_INFORMATION20'
         ,paa.abs_information20)                 abs_information20_meaning
,      paa.abs_information21
,      xxas_com_vset_pkg.decode_descr_vset_value
         ('800'
         ,'PER_ABS_DEVELOPER_DF'
         ,paa.abs_information_category
         ,'ABS_INFORMATION21'
         ,paa.abs_information21)                 abs_information21_meaning
,      paa.abs_information22
,      xxas_com_vset_pkg.decode_descr_vset_value
         ('800'
         ,'PER_ABS_DEVELOPER_DF'
         ,paa.abs_information_category
         ,'ABS_INFORMATION22'
         ,paa.abs_information22)                 abs_information22_meaning
,      paa.abs_information23
,      xxas_com_vset_pkg.decode_descr_vset_value
         ('800'
         ,'PER_ABS_DEVELOPER_DF'
         ,paa.abs_information_category
         ,'ABS_INFORMATION23'
         ,paa.abs_information23)                 abs_information23_meaning
,      paa.abs_information24
,      xxas_com_vset_pkg.decode_descr_vset_value
         ('800'
         ,'PER_ABS_DEVELOPER_DF'
         ,paa.abs_information_category
         ,'ABS_INFORMATION24'
         ,paa.abs_information24)                 abs_information24_meaning
,      paa.abs_information25
,      xxas_com_vset_pkg.decode_descr_vset_value
         ('800'
         ,'PER_ABS_DEVELOPER_DF'
         ,paa.abs_information_category
         ,'ABS_INFORMATION25'
         ,paa.abs_information25)                 abs_information25_meaning
,      paa.abs_information26
,      xxas_com_vset_pkg.decode_descr_vset_value
         ('800'
         ,'PER_ABS_DEVELOPER_DF'
         ,paa.abs_information_category
         ,'ABS_INFORMATION26'
         ,paa.abs_information26)                 abs_information26_meaning
,      paa.abs_information27
,      xxas_com_vset_pkg.decode_descr_vset_value
         ('800'
         ,'PER_ABS_DEVELOPER_DF'
         ,paa.abs_information_category
         ,'ABS_INFORMATION27'
         ,paa.abs_information27)                 abs_information27_meaning
,      paa.abs_information28
,      xxas_com_vset_pkg.decode_descr_vset_value
         ('800'
         ,'PER_ABS_DEVELOPER_DF'
         ,paa.abs_information_category
         ,'ABS_INFORMATION28'
         ,paa.abs_information28)                 abs_information28_meaning
,      paa.abs_information29
,      xxas_com_vset_pkg.decode_descr_vset_value
         ('800'
         ,'PER_ABS_DEVELOPER_DF'
         ,paa.abs_information_category
         ,'ABS_INFORMATION29'
         ,paa.abs_information29)                 abs_information29_meaning
,      paa.abs_information30
,      xxas_com_vset_pkg.decode_descr_vset_value
         ('800'
         ,'PER_ABS_DEVELOPER_DF'
         ,paa.abs_information_category
         ,'ABS_INFORMATION30'
         ,paa.abs_information30)                 abs_information30_meaning
,      paa.batch_id
,      xxas_util_pkg.long_to_varchar2
           ('PER_ABSENCE_ATTENDANCES'
		   ,'COMMENTS' 
		   , paa.rowid)                          comments    
,      paa.absence_case_id
,      paa.approval_status
,      paa.confirmed_until
,      paa.source
,      paa.advance_pay
,      pend.transaction_id
,      pend.transaction_step_id
,      pend.transaction_type
,      pend.hr_api_status_code
,      pend.workflow_status_code
,      xxas_selfservice_workflow_pkg.decode_status(pend.workflow_status_code) workflow_status_meaning   
,      CASE WHEN pend.transaction_id IS NOT NULL
            THEN xxas_hr_api_transaction_pkg.number_value
                   (paa.person_id
                   ,pend.api_name
                   ,pend.transaction_step_id
                   ,'P_OBJECT_VERSION_NUMBER')
       END                                       object_version_number_p
,      CASE WHEN pend.transaction_id IS NOT NULL
            THEN xxas_hr_api_transaction_pkg.number_value
                   (paa.person_id
                   ,pend.api_name
                   ,pend.transaction_step_id
                   ,'P_BUSINESS_GROUP_ID')
       END                                       business_group_id_p
,      CASE WHEN pend.transaction_id IS NOT NULL
            THEN xxas_hr_api_transaction_pkg.number_value
                   (paa.person_id
                   ,pend.api_name
                   ,pend.transaction_step_id
                   ,'P_ABSENCE_ATTENDANCE_TYPE_ID')
       END                                       absence_type_id_p
,      pend.absence_type_p
,      pend.absence_category_code_p
,      pend.absence_category_p
,      CASE WHEN pend.transaction_id IS NOT NULL
            THEN xxas_hr_api_transaction_pkg.number_value
                   (paa.person_id
                   ,pend.api_name
                   ,pend.transaction_step_id
                   ,'P_ABS_ATTENDANCE_REASON_ID')
       END                                       abs_attendance_reason_id_p
,      CASE WHEN pend.transaction_id IS NOT NULL
            THEN (SELECT rea.meaning     
                  FROM   per_abs_attendance_reasons paar
                  ,      hr_lookups                 rea
                  WHERE  paar.abs_attendance_reason_id = xxas_hr_api_transaction_pkg.number_value
                                                          (paa.person_id
                                                          ,pend.api_name
                                                          ,pend.transaction_step_id
                                                          ,'P_ABS_ATTENDANCE_REASON_ID')
                  AND    paar.name                     = rea.lookup_code
                  AND    rea.lookup_type               = 'ABSENCE_REASON')
       END                                       abs_attendance_reason_p
,      CASE WHEN pend.transaction_id IS NOT NULL
            THEN xxas_hr_api_transaction_pkg.number_value
                   (paa.person_id
                   ,pend.api_name
                   ,pend.transaction_step_id
                   ,'P_ABSENCE_DAYS')
       END                                       absence_days_p
,      CASE WHEN pend.transaction_id IS NOT NULL
            THEN xxas_hr_api_transaction_pkg.number_value
                   (paa.person_id
                   ,pend.api_name
                   ,pend.transaction_step_id
                   ,'P_ABSENCE_HOURS')
       END                                       absence_hours_p
,      CASE WHEN pend.transaction_id IS NOT NULL
            THEN xxas_hr_api_transaction_pkg.date_value
                   (paa.person_id
                   ,pend.api_name
                   ,pend.transaction_step_id
                   ,'P_DATE_END')
       END                                       date_end_p
,      CASE WHEN pend.transaction_id IS NOT NULL
            THEN xxas_hr_api_transaction_pkg.date_value
                   (paa.person_id
                   ,pend.api_name
                   ,pend.transaction_step_id
                   ,'P_DATE_NOTIFICATION')
       END                                       date_notification_p
,      CASE WHEN pend.transaction_id IS NOT NULL
            THEN xxas_hr_api_transaction_pkg.date_value
                   (paa.person_id
                   ,pend.api_name
                   ,pend.transaction_step_id
                   ,'P_DATE_PROJECTED_END')
       END                                       date_projected_end_p
,      CASE WHEN pend.transaction_id IS NOT NULL
            THEN xxas_hr_api_transaction_pkg.date_value
                   (paa.person_id
                   ,pend.api_name
                   ,pend.transaction_step_id
                   ,'P_DATE_PROJECTED_START')
       END                                       date_projected_start_p
,      CASE WHEN pend.transaction_id IS NOT NULL
            THEN xxas_hr_api_transaction_pkg.date_value
                   (paa.person_id
                   ,pend.api_name
                   ,pend.transaction_step_id
                   ,'P_DATE_START')
       END                                       date_start_p
,      CASE WHEN pend.transaction_id IS NOT NULL
            THEN xxas_hr_api_transaction_pkg.varchar2_value
                   (paa.person_id
                   ,pend.api_name
                   ,pend.transaction_step_id
                   ,'P_TIME_END')
       END                                       time_end_p
,      CASE WHEN pend.transaction_id IS NOT NULL
            THEN xxas_hr_api_transaction_pkg.varchar2_value
                   (paa.person_id
                   ,pend.api_name
                   ,pend.transaction_step_id
                   ,'P_TIME_PROJECTED_END')
       END                                       time_projected_end_p
,      CASE WHEN pend.transaction_id IS NOT NULL
            THEN xxas_hr_api_transaction_pkg.varchar2_value
                   (paa.person_id
                   ,pend.api_name
                   ,pend.transaction_step_id
                   ,'P_TIME_PROJECTED_START')
       END                                       time_projected_start_p
,      CASE WHEN pend.transaction_id IS NOT NULL
            THEN xxas_hr_api_transaction_pkg.varchar2_value
                   (paa.person_id
                   ,pend.api_name
                   ,pend.transaction_step_id
                   ,'P_TIME_START')
       END                                       time_start_p
,      CASE WHEN pend.transaction_id IS NOT NULL
            THEN xxas_hr_api_transaction_pkg.varchar2_value
                   (paa.person_id
                   ,pend.api_name
                   ,pend.transaction_step_id
                   ,'P_ATTRIBUTE_CATEGORY')
       END                                       attribute_category_p
,      CASE WHEN pend.transaction_id IS NOT NULL
            THEN xxas_hr_api_transaction_pkg.varchar2_value
                   (paa.person_id
                   ,pend.api_name
                   ,pend.transaction_step_id
                   ,'P_ATTRIBUTE1')
       END                                       attribute1_p
,      CASE WHEN pend.transaction_id IS NOT NULL
            THEN xxas_com_vset_pkg.decode_descr_vset_value
                   ('800'
                   ,'PER_ABSENCE_ATTENDANCES'
                   ,paa.attribute_category
                   ,'ATTRIBUTE1'
                   ,xxas_hr_api_transaction_pkg.varchar2_value
                      (paa.person_id
                      ,pend.api_name
                      ,pend.transaction_step_id
                      ,'P_ATTRIBUTE1'))
       END                                       attribute1_meaning_p 
,      CASE WHEN pend.transaction_id IS NOT NULL
            THEN xxas_hr_api_transaction_pkg.varchar2_value
                   (paa.person_id
                   ,pend.api_name
                   ,pend.transaction_step_id
                   ,'P_ATTRIBUTE2')
       END                                       attribute2_p
,      CASE WHEN pend.transaction_id IS NOT NULL
            THEN xxas_com_vset_pkg.decode_descr_vset_value
                   ('800'
                   ,'PER_ABSENCE_ATTENDANCES'
                   ,paa.attribute_category
                   ,'ATTRIBUTE2'
                   ,xxas_hr_api_transaction_pkg.varchar2_value
                      (paa.person_id
                      ,pend.api_name
                      ,pend.transaction_step_id
                      ,'P_ATTRIBUTE2'))
       END                                       attribute2_meaning_p 
,      CASE WHEN pend.transaction_id IS NOT NULL
            THEN xxas_hr_api_transaction_pkg.varchar2_value
                   (paa.person_id
                   ,pend.api_name
                   ,pend.transaction_step_id
                   ,'P_ATTRIBUTE3')
       END                                       attribute3_p
,      CASE WHEN pend.transaction_id IS NOT NULL
            THEN xxas_com_vset_pkg.decode_descr_vset_value
                   ('800'
                   ,'PER_ABSENCE_ATTENDANCES'
                   ,paa.attribute_category
                   ,'ATTRIBUTE3'
                   ,xxas_hr_api_transaction_pkg.varchar2_value
                      (paa.person_id
                      ,pend.api_name
                      ,pend.transaction_step_id
                      ,'P_ATTRIBUTE3'))
       END                                       attribute3_meaning_p 
,      CASE WHEN pend.transaction_id IS NOT NULL
            THEN xxas_hr_api_transaction_pkg.varchar2_value
                   (paa.person_id
                   ,pend.api_name
                   ,pend.transaction_step_id
                   ,'P_ATTRIBUTE4')
       END                                       attribute4_p
,      CASE WHEN pend.transaction_id IS NOT NULL
            THEN xxas_com_vset_pkg.decode_descr_vset_value
                   ('800'
                   ,'PER_ABSENCE_ATTENDANCES'
                   ,paa.attribute_category
                   ,'ATTRIBUTE4'
                   ,xxas_hr_api_transaction_pkg.varchar2_value
                      (paa.person_id
                      ,pend.api_name
                      ,pend.transaction_step_id
                      ,'P_ATTRIBUTE4'))
       END                                       attribute4_meaning_p 
,      CASE WHEN pend.transaction_id IS NOT NULL
            THEN xxas_hr_api_transaction_pkg.varchar2_value
                   (paa.person_id
                   ,pend.api_name
                   ,pend.transaction_step_id
                   ,'P_ATTRIBUTE5')
       END                                       attribute5_p
,      CASE WHEN pend.transaction_id IS NOT NULL
            THEN xxas_com_vset_pkg.decode_descr_vset_value
                   ('800'
                   ,'PER_ABSENCE_ATTENDANCES'
                   ,paa.attribute_category
                   ,'ATTRIBUTE5'
                   ,xxas_hr_api_transaction_pkg.varchar2_value
                      (paa.person_id
                      ,pend.api_name
                      ,pend.transaction_step_id
                      ,'P_ATTRIBUTE5'))
       END                                       attribute5_meaning_p 
,      CASE WHEN pend.transaction_id IS NOT NULL
            THEN xxas_hr_api_transaction_pkg.varchar2_value
                   (paa.person_id
                   ,pend.api_name
                   ,pend.transaction_step_id
                   ,'P_ATTRIBUTE6')
       END                                       attribute6_p
,      CASE WHEN pend.transaction_id IS NOT NULL
            THEN xxas_com_vset_pkg.decode_descr_vset_value
                   ('800'
                   ,'PER_ABSENCE_ATTENDANCES'
                   ,paa.attribute_category
                   ,'ATTRIBUTE6'
                   ,xxas_hr_api_transaction_pkg.varchar2_value
                      (paa.person_id
                      ,pend.api_name
                      ,pend.transaction_step_id
                      ,'P_ATTRIBUTE6'))
       END                                       attribute6_meaning_p 
,      CASE WHEN pend.transaction_id IS NOT NULL
            THEN xxas_hr_api_transaction_pkg.varchar2_value
                   (paa.person_id
                   ,pend.api_name
                   ,pend.transaction_step_id
                   ,'P_ATTRIBUTE7')
       END                                       attribute7_p
,      CASE WHEN pend.transaction_id IS NOT NULL
            THEN xxas_com_vset_pkg.decode_descr_vset_value
                   ('800'
                   ,'PER_ABSENCE_ATTENDANCES'
                   ,paa.attribute_category
                   ,'ATTRIBUTE7'
                   ,xxas_hr_api_transaction_pkg.varchar2_value
                      (paa.person_id
                      ,pend.api_name
                      ,pend.transaction_step_id
                      ,'P_ATTRIBUTE7'))
       END                                       attribute7_meaning_p 
,      CASE WHEN pend.transaction_id IS NOT NULL
            THEN xxas_hr_api_transaction_pkg.varchar2_value
                   (paa.person_id
                   ,pend.api_name
                   ,pend.transaction_step_id
                   ,'P_ATTRIBUTE8')
       END                                       attribute8_p
,      CASE WHEN pend.transaction_id IS NOT NULL
            THEN xxas_com_vset_pkg.decode_descr_vset_value
                   ('800'
                   ,'PER_ABSENCE_ATTENDANCES'
                   ,paa.attribute_category
                   ,'ATTRIBUTE8'
                   ,xxas_hr_api_transaction_pkg.varchar2_value
                      (paa.person_id
                      ,pend.api_name
                      ,pend.transaction_step_id
                      ,'P_ATTRIBUTE8'))
       END                                       attribute8_meaning_p 
,      CASE WHEN pend.transaction_id IS NOT NULL
            THEN xxas_hr_api_transaction_pkg.varchar2_value
                   (paa.person_id
                   ,pend.api_name
                   ,pend.transaction_step_id
                   ,'P_ATTRIBUTE9')
       END                                       attribute9_p
,      CASE WHEN pend.transaction_id IS NOT NULL
            THEN xxas_com_vset_pkg.decode_descr_vset_value
                   ('800'
                   ,'PER_ABSENCE_ATTENDANCES'
                   ,paa.attribute_category
                   ,'ATTRIBUTE9'
                   ,xxas_hr_api_transaction_pkg.varchar2_value
                      (paa.person_id
                      ,pend.api_name
                      ,pend.transaction_step_id
                      ,'P_ATTRIBUTE9'))
       END                                       attribute9_meaning_p 
,      CASE WHEN pend.transaction_id IS NOT NULL
            THEN xxas_hr_api_transaction_pkg.varchar2_value
                   (paa.person_id
                   ,pend.api_name
                   ,pend.transaction_step_id
                   ,'P_ATTRIBUTE10')
       END                                       attribute10_p
,      CASE WHEN pend.transaction_id IS NOT NULL
            THEN xxas_com_vset_pkg.decode_descr_vset_value
                   ('800'
                   ,'PER_ABSENCE_ATTENDANCES'
                   ,paa.attribute_category
                   ,'ATTRIBUTE10'
                   ,xxas_hr_api_transaction_pkg.varchar2_value
                      (paa.person_id
                      ,pend.api_name
                      ,pend.transaction_step_id
                      ,'P_ATTRIBUTE10'))
       END                                       attribute10_meaning_p 
,      CASE WHEN pend.transaction_id IS NOT NULL
            THEN xxas_hr_api_transaction_pkg.varchar2_value
                   (paa.person_id
                   ,pend.api_name
                   ,pend.transaction_step_id
                   ,'P_ATTRIBUTE11')
       END                                       attribute11_p
,      CASE WHEN pend.transaction_id IS NOT NULL
            THEN xxas_com_vset_pkg.decode_descr_vset_value
                   ('800'
                   ,'PER_ABSENCE_ATTENDANCES'
                   ,paa.attribute_category
                   ,'ATTRIBUTE11'
                   ,xxas_hr_api_transaction_pkg.varchar2_value
                      (paa.person_id
                      ,pend.api_name
                      ,pend.transaction_step_id
                      ,'P_ATTRIBUTE11'))
       END                                       attribute11_meaning_p 
,      CASE WHEN pend.transaction_id IS NOT NULL
            THEN xxas_hr_api_transaction_pkg.varchar2_value
                   (paa.person_id
                   ,pend.api_name
                   ,pend.transaction_step_id
                   ,'P_ATTRIBUTE12')
       END                                       attribute12_p
,      CASE WHEN pend.transaction_id IS NOT NULL
            THEN xxas_com_vset_pkg.decode_descr_vset_value
                   ('800'
                   ,'PER_ABSENCE_ATTENDANCES'
                   ,paa.attribute_category
                   ,'ATTRIBUTE12'
                   ,xxas_hr_api_transaction_pkg.varchar2_value
                      (paa.person_id
                      ,pend.api_name
                      ,pend.transaction_step_id
                      ,'P_ATTRIBUTE12'))
       END                                       attribute12_meaning_p 
,      CASE WHEN pend.transaction_id IS NOT NULL
            THEN xxas_hr_api_transaction_pkg.varchar2_value
                   (paa.person_id
                   ,pend.api_name
                   ,pend.transaction_step_id
                   ,'P_ATTRIBUTE13')
       END                                       attribute13_p
,      CASE WHEN pend.transaction_id IS NOT NULL
            THEN xxas_com_vset_pkg.decode_descr_vset_value
                   ('800'
                   ,'PER_ABSENCE_ATTENDANCES'
                   ,paa.attribute_category
                   ,'ATTRIBUTE13'
                   ,xxas_hr_api_transaction_pkg.varchar2_value
                      (paa.person_id
                      ,pend.api_name
                      ,pend.transaction_step_id
                      ,'P_ATTRIBUTE13'))
       END                                       attribute13_meaning_p 
,      CASE WHEN pend.transaction_id IS NOT NULL
            THEN xxas_hr_api_transaction_pkg.varchar2_value
                   (paa.person_id
                   ,pend.api_name
                   ,pend.transaction_step_id
                   ,'P_ATTRIBUTE14')
       END                                       attribute14_p
,      CASE WHEN pend.transaction_id IS NOT NULL
            THEN xxas_com_vset_pkg.decode_descr_vset_value
                   ('800'
                   ,'PER_ABSENCE_ATTENDANCES'
                   ,paa.attribute_category
                   ,'ATTRIBUTE14'
                   ,xxas_hr_api_transaction_pkg.varchar2_value
                      (paa.person_id
                      ,pend.api_name
                      ,pend.transaction_step_id
                      ,'P_ATTRIBUTE14'))
       END                                       attribute14_meaning_p 
,      CASE WHEN pend.transaction_id IS NOT NULL
            THEN xxas_hr_api_transaction_pkg.varchar2_value
                   (paa.person_id
                   ,pend.api_name
                   ,pend.transaction_step_id
                   ,'P_ATTRIBUTE15')
       END                                       attribute15_p
,      CASE WHEN pend.transaction_id IS NOT NULL
            THEN xxas_com_vset_pkg.decode_descr_vset_value
                   ('800'
                   ,'PER_ABSENCE_ATTENDANCES'
                   ,paa.attribute_category
                   ,'ATTRIBUTE15'
                   ,xxas_hr_api_transaction_pkg.varchar2_value
                      (paa.person_id
                      ,pend.api_name
                      ,pend.transaction_step_id
                      ,'P_ATTRIBUTE15'))
       END                                       attribute15_meaning_p 
,      CASE WHEN pend.transaction_id IS NOT NULL
            THEN xxas_hr_api_transaction_pkg.varchar2_value
                   (paa.person_id
                   ,pend.api_name
                   ,pend.transaction_step_id
                   ,'P_ATTRIBUTE16')
       END                                       attribute16_p
,      CASE WHEN pend.transaction_id IS NOT NULL
            THEN xxas_com_vset_pkg.decode_descr_vset_value
                   ('800'
                   ,'PER_ABSENCE_ATTENDANCES'
                   ,paa.attribute_category
                   ,'ATTRIBUTE16'
                   ,xxas_hr_api_transaction_pkg.varchar2_value
                      (paa.person_id
                      ,pend.api_name
                      ,pend.transaction_step_id
                      ,'P_ATTRIBUTE16'))
       END                                       attribute16_meaning_p 
,      CASE WHEN pend.transaction_id IS NOT NULL
            THEN xxas_hr_api_transaction_pkg.varchar2_value
                   (paa.person_id
                   ,pend.api_name
                   ,pend.transaction_step_id
                   ,'P_ATTRIBUTE17')
       END                                       attribute17_p
,      CASE WHEN pend.transaction_id IS NOT NULL
            THEN xxas_com_vset_pkg.decode_descr_vset_value
                   ('800'
                   ,'PER_ABSENCE_ATTENDANCES'
                   ,paa.attribute_category
                   ,'ATTRIBUTE17'
                   ,xxas_hr_api_transaction_pkg.varchar2_value
                      (paa.person_id
                      ,pend.api_name
                      ,pend.transaction_step_id
                      ,'P_ATTRIBUTE17'))
       END                                       attribute17_meaning_p 
,      CASE WHEN pend.transaction_id IS NOT NULL
            THEN xxas_hr_api_transaction_pkg.varchar2_value
                   (paa.person_id
                   ,pend.api_name
                   ,pend.transaction_step_id
                   ,'P_ATTRIBUTE18')
       END                                       attribute18_p
,      CASE WHEN pend.transaction_id IS NOT NULL
            THEN xxas_com_vset_pkg.decode_descr_vset_value
                   ('800'
                   ,'PER_ABSENCE_ATTENDANCES'
                   ,paa.attribute_category
                   ,'ATTRIBUTE18'
                   ,xxas_hr_api_transaction_pkg.varchar2_value
                      (paa.person_id
                      ,pend.api_name
                      ,pend.transaction_step_id
                      ,'P_ATTRIBUTE18'))
       END                                       attribute18_meaning_p 
,      CASE WHEN pend.transaction_id IS NOT NULL
            THEN xxas_hr_api_transaction_pkg.varchar2_value
                   (paa.person_id
                   ,pend.api_name
                   ,pend.transaction_step_id
                   ,'P_ATTRIBUTE19')
       END                                       attribute19_p
,      CASE WHEN pend.transaction_id IS NOT NULL
            THEN xxas_com_vset_pkg.decode_descr_vset_value
                   ('800'
                   ,'PER_ABSENCE_ATTENDANCES'
                   ,paa.attribute_category
                   ,'ATTRIBUTE19'
                   ,xxas_hr_api_transaction_pkg.varchar2_value
                      (paa.person_id
                      ,pend.api_name
                      ,pend.transaction_step_id
                      ,'P_ATTRIBUTE19'))
       END                                       attribute19_meaning_p 
,      CASE WHEN pend.transaction_id IS NOT NULL
            THEN xxas_hr_api_transaction_pkg.varchar2_value
                   (paa.person_id
                   ,pend.api_name
                   ,pend.transaction_step_id
                   ,'P_ATTRIBUTE20')
       END                                       attribute20_p
,      CASE WHEN pend.transaction_id IS NOT NULL
            THEN xxas_com_vset_pkg.decode_descr_vset_value
                   ('800'
                   ,'PER_ABSENCE_ATTENDANCES'
                   ,paa.attribute_category
                   ,'ATTRIBUTE20'
                   ,xxas_hr_api_transaction_pkg.varchar2_value
                      (paa.person_id
                      ,pend.api_name
                      ,pend.transaction_step_id
                      ,'P_ATTRIBUTE20'))
       END                                       attribute20_meaning_p 
,      CASE WHEN pend.transaction_id IS NOT NULL
            THEN xxas_hr_api_transaction_pkg.varchar2_value
                   (paa.person_id
                   ,pend.api_name
                   ,pend.transaction_step_id
                   ,'P_ABS_INFORMATION_CATEGORY')
       END                                       abs_information_category_p
,      CASE WHEN pend.transaction_id IS NOT NULL
            THEN xxas_hr_api_transaction_pkg.varchar2_value
                   (paa.person_id
                   ,pend.api_name
                   ,pend.transaction_step_id
                   ,'P_ABS_INFORMATION1')
       END                                       abs_information1_p
,      CASE WHEN pend.transaction_id IS NOT NULL
            THEN xxas_com_vset_pkg.decode_descr_vset_value
                   ('800'
                   ,'PER_ABS_DEVELOPER_DF'
                   ,paa.abs_information_category
                   ,'ABS_INFORMATION1'
                   ,xxas_hr_api_transaction_pkg.varchar2_value
                      (paa.person_id
                      ,pend.api_name
                      ,pend.transaction_step_id
                      ,'P_ABS_INFORMATION1'))
       END                                       abs_information1_meaning_p 
,      CASE WHEN pend.transaction_id IS NOT NULL
            THEN xxas_hr_api_transaction_pkg.varchar2_value
                   (paa.person_id
                   ,pend.api_name
                   ,pend.transaction_step_id
                   ,'P_ABS_INFORMATION2')
       END                                       abs_information2_p
,      CASE WHEN pend.transaction_id IS NOT NULL
            THEN xxas_com_vset_pkg.decode_descr_vset_value
                   ('800'
                   ,'PER_ABS_DEVELOPER_DF'
                   ,paa.abs_information_category
                   ,'ABS_INFORMATION2'
                   ,xxas_hr_api_transaction_pkg.varchar2_value
                      (paa.person_id
                      ,pend.api_name
                      ,pend.transaction_step_id
                      ,'P_ABS_INFORMATION2'))
       END                                       abs_information2_meaning_p 
,      CASE WHEN pend.transaction_id IS NOT NULL
            THEN xxas_hr_api_transaction_pkg.varchar2_value
                   (paa.person_id
                   ,pend.api_name
                   ,pend.transaction_step_id
                   ,'P_ABS_INFORMATION3')
       END                                       abs_information3_p
,      CASE WHEN pend.transaction_id IS NOT NULL
            THEN xxas_com_vset_pkg.decode_descr_vset_value
                   ('800'
                   ,'PER_ABS_DEVELOPER_DF'
                   ,paa.abs_information_category
                   ,'ABS_INFORMATION3'
                   ,xxas_hr_api_transaction_pkg.varchar2_value
                      (paa.person_id
                      ,pend.api_name
                      ,pend.transaction_step_id
                      ,'P_ABS_INFORMATION3'))
       END                                       abs_information3_meaning_p 
,      CASE WHEN pend.transaction_id IS NOT NULL
            THEN xxas_hr_api_transaction_pkg.varchar2_value
                   (paa.person_id
                   ,pend.api_name
                   ,pend.transaction_step_id
                   ,'P_ABS_INFORMATION4')
       END                                       abs_information4_p
,      CASE WHEN pend.transaction_id IS NOT NULL
            THEN xxas_com_vset_pkg.decode_descr_vset_value
                   ('800'
                   ,'PER_ABS_DEVELOPER_DF'
                   ,paa.abs_information_category
                   ,'ABS_INFORMATION4'
                   ,xxas_hr_api_transaction_pkg.varchar2_value
                      (paa.person_id
                      ,pend.api_name
                      ,pend.transaction_step_id
                      ,'P_ABS_INFORMATION4'))
       END                                       abs_information4_meaning_p 
,      CASE WHEN pend.transaction_id IS NOT NULL
            THEN xxas_hr_api_transaction_pkg.varchar2_value
                   (paa.person_id
                   ,pend.api_name
                   ,pend.transaction_step_id
                   ,'P_ABS_INFORMATION5')
       END                                       abs_information5_p
,      CASE WHEN pend.transaction_id IS NOT NULL
            THEN xxas_com_vset_pkg.decode_descr_vset_value
                   ('800'
                   ,'PER_ABS_DEVELOPER_DF'
                   ,paa.abs_information_category
                   ,'ABS_INFORMATION5'
                   ,xxas_hr_api_transaction_pkg.varchar2_value
                      (paa.person_id
                      ,pend.api_name
                      ,pend.transaction_step_id
                      ,'P_ABS_INFORMATION5'))
       END                                       abs_information5_meaning_p 
,      CASE WHEN pend.transaction_id IS NOT NULL
            THEN xxas_hr_api_transaction_pkg.varchar2_value
                   (paa.person_id
                   ,pend.api_name
                   ,pend.transaction_step_id
                   ,'P_ABS_INFORMATION6')
       END                                       abs_information6_p
,      CASE WHEN pend.transaction_id IS NOT NULL
            THEN xxas_com_vset_pkg.decode_descr_vset_value
                   ('800'
                   ,'PER_ABS_DEVELOPER_DF'
                   ,paa.abs_information_category
                   ,'ABS_INFORMATION6'
                   ,xxas_hr_api_transaction_pkg.varchar2_value
                      (paa.person_id
                      ,pend.api_name
                      ,pend.transaction_step_id
                      ,'P_ABS_INFORMATION6'))
       END                                       abs_information6_meaning_p 
,      CASE WHEN pend.transaction_id IS NOT NULL
            THEN xxas_hr_api_transaction_pkg.varchar2_value
                   (paa.person_id
                   ,pend.api_name
                   ,pend.transaction_step_id
                   ,'P_ABS_INFORMATION7')
       END                                       abs_information7_p
,      CASE WHEN pend.transaction_id IS NOT NULL
            THEN xxas_com_vset_pkg.decode_descr_vset_value
                   ('800'
                   ,'PER_ABS_DEVELOPER_DF'
                   ,paa.abs_information_category
                   ,'ABS_INFORMATION7'
                   ,xxas_hr_api_transaction_pkg.varchar2_value
                      (paa.person_id
                      ,pend.api_name
                      ,pend.transaction_step_id
                      ,'P_ABS_INFORMATION7'))
       END                                       abs_information7_meaning_p 
,      CASE WHEN pend.transaction_id IS NOT NULL
            THEN xxas_hr_api_transaction_pkg.varchar2_value
                   (paa.person_id
                   ,pend.api_name
                   ,pend.transaction_step_id
                   ,'P_ABS_INFORMATION8')
       END                                       abs_information8_p
,      CASE WHEN pend.transaction_id IS NOT NULL
            THEN xxas_com_vset_pkg.decode_descr_vset_value
                   ('800'
                   ,'PER_ABS_DEVELOPER_DF'
                   ,paa.abs_information_category
                   ,'ABS_INFORMATION8'
                   ,xxas_hr_api_transaction_pkg.varchar2_value
                      (paa.person_id
                      ,pend.api_name
                      ,pend.transaction_step_id
                      ,'P_ABS_INFORMATION8'))
       END                                       abs_information8_meaning_p 
,      CASE WHEN pend.transaction_id IS NOT NULL
            THEN xxas_hr_api_transaction_pkg.varchar2_value
                   (paa.person_id
                   ,pend.api_name
                   ,pend.transaction_step_id
                   ,'P_ABS_INFORMATION9')
       END                                       abs_information9_p
,      CASE WHEN pend.transaction_id IS NOT NULL
            THEN xxas_com_vset_pkg.decode_descr_vset_value
                   ('800'
                   ,'PER_ABS_DEVELOPER_DF'
                   ,paa.abs_information_category
                   ,'ABS_INFORMATION9'
                   ,xxas_hr_api_transaction_pkg.varchar2_value
                      (paa.person_id
                      ,pend.api_name
                      ,pend.transaction_step_id
                      ,'P_ABS_INFORMATION9'))
       END                                       abs_information9_meaning_p 
,      CASE WHEN pend.transaction_id IS NOT NULL
            THEN xxas_hr_api_transaction_pkg.varchar2_value
                   (paa.person_id
                   ,pend.api_name
                   ,pend.transaction_step_id
                   ,'P_ABS_INFORMATION11')
       END                                       abs_information11_p
,      CASE WHEN pend.transaction_id IS NOT NULL
            THEN xxas_com_vset_pkg.decode_descr_vset_value
                   ('800'
                   ,'PER_ABS_DEVELOPER_DF'
                   ,paa.abs_information_category
                   ,'ABS_INFORMATION11'
                   ,xxas_hr_api_transaction_pkg.varchar2_value
                      (paa.person_id
                      ,pend.api_name
                      ,pend.transaction_step_id
                      ,'P_ABS_INFORMATION11'))
       END                                       abs_information11_meaning_p 
,      CASE WHEN pend.transaction_id IS NOT NULL
            THEN xxas_hr_api_transaction_pkg.varchar2_value
                   (paa.person_id
                   ,pend.api_name
                   ,pend.transaction_step_id
                   ,'P_ABS_INFORMATION12')
       END                                       abs_information12_p
,      CASE WHEN pend.transaction_id IS NOT NULL
            THEN xxas_com_vset_pkg.decode_descr_vset_value
                   ('800'
                   ,'PER_ABS_DEVELOPER_DF'
                   ,paa.abs_information_category
                   ,'ABS_INFORMATION12'
                   ,xxas_hr_api_transaction_pkg.varchar2_value
                      (paa.person_id
                      ,pend.api_name
                      ,pend.transaction_step_id
                      ,'P_ABS_INFORMATION12'))
       END                                       abs_information12_meaning_p 
,      CASE WHEN pend.transaction_id IS NOT NULL
            THEN xxas_hr_api_transaction_pkg.varchar2_value
                   (paa.person_id
                   ,pend.api_name
                   ,pend.transaction_step_id
                   ,'P_ABS_INFORMATION13')
       END                                       abs_information13_p
,      CASE WHEN pend.transaction_id IS NOT NULL
            THEN xxas_com_vset_pkg.decode_descr_vset_value
                   ('800'
                   ,'PER_ABS_DEVELOPER_DF'
                   ,paa.abs_information_category
                   ,'ABS_INFORMATION13'
                   ,xxas_hr_api_transaction_pkg.varchar2_value
                      (paa.person_id
                      ,pend.api_name
                      ,pend.transaction_step_id
                      ,'P_ABS_INFORMATION13'))
       END                                       abs_information13_meaning_p 
,      CASE WHEN pend.transaction_id IS NOT NULL
            THEN xxas_hr_api_transaction_pkg.varchar2_value
                   (paa.person_id
                   ,pend.api_name
                   ,pend.transaction_step_id
                   ,'P_ABS_INFORMATION14')
       END                                       abs_information14_p
,      CASE WHEN pend.transaction_id IS NOT NULL
            THEN xxas_com_vset_pkg.decode_descr_vset_value
                   ('800'
                   ,'PER_ABS_DEVELOPER_DF'
                   ,paa.abs_information_category
                   ,'ABS_INFORMATION14'
                   ,xxas_hr_api_transaction_pkg.varchar2_value
                      (paa.person_id
                      ,pend.api_name
                      ,pend.transaction_step_id
                      ,'P_ABS_INFORMATION14'))
       END                                       abs_information14_meaning_p 
,      CASE WHEN pend.transaction_id IS NOT NULL
            THEN xxas_hr_api_transaction_pkg.varchar2_value
                   (paa.person_id
                   ,pend.api_name
                   ,pend.transaction_step_id
                   ,'P_ABS_INFORMATION15')
       END                                       abs_information15_p
,      CASE WHEN pend.transaction_id IS NOT NULL
            THEN xxas_com_vset_pkg.decode_descr_vset_value
                   ('800'
                   ,'PER_ABS_DEVELOPER_DF'
                   ,paa.abs_information_category
                   ,'ABS_INFORMATION15'
                   ,xxas_hr_api_transaction_pkg.varchar2_value
                      (paa.person_id
                      ,pend.api_name
                      ,pend.transaction_step_id
                      ,'P_ABS_INFORMATION15'))
       END                                       abs_information15_meaning_p 
,      CASE WHEN pend.transaction_id IS NOT NULL
            THEN xxas_hr_api_transaction_pkg.varchar2_value
                   (paa.person_id
                   ,pend.api_name
                   ,pend.transaction_step_id
                   ,'P_ABS_INFORMATION16')
       END                                       abs_information16_p
,      CASE WHEN pend.transaction_id IS NOT NULL
            THEN xxas_com_vset_pkg.decode_descr_vset_value
                   ('800'
                   ,'PER_ABS_DEVELOPER_DF'
                   ,paa.abs_information_category
                   ,'ABS_INFORMATION16'
                   ,xxas_hr_api_transaction_pkg.varchar2_value
                      (paa.person_id
                      ,pend.api_name
                      ,pend.transaction_step_id
                      ,'P_ABS_INFORMATION16'))
       END                                       abs_information16_meaning_p 
,      CASE WHEN pend.transaction_id IS NOT NULL
            THEN xxas_hr_api_transaction_pkg.varchar2_value
                   (paa.person_id
                   ,pend.api_name
                   ,pend.transaction_step_id
                   ,'P_ABS_INFORMATION17')
       END                                       abs_information17_p
,      CASE WHEN pend.transaction_id IS NOT NULL
            THEN xxas_com_vset_pkg.decode_descr_vset_value
                   ('800'
                   ,'PER_ABS_DEVELOPER_DF'
                   ,paa.abs_information_category
                   ,'ABS_INFORMATION17'
                   ,xxas_hr_api_transaction_pkg.varchar2_value
                      (paa.person_id
                      ,pend.api_name
                      ,pend.transaction_step_id
                      ,'P_ABS_INFORMATION17'))
       END                                       abs_information17_meaning_p 
,      CASE WHEN pend.transaction_id IS NOT NULL
            THEN xxas_hr_api_transaction_pkg.varchar2_value
                   (paa.person_id
                   ,pend.api_name
                   ,pend.transaction_step_id
                   ,'P_ABS_INFORMATION18')
       END                                       abs_information18_p
,      CASE WHEN pend.transaction_id IS NOT NULL
            THEN xxas_com_vset_pkg.decode_descr_vset_value
                   ('800'
                   ,'PER_ABS_DEVELOPER_DF'
                   ,paa.abs_information_category
                   ,'ABS_INFORMATION18'
                   ,xxas_hr_api_transaction_pkg.varchar2_value
                      (paa.person_id
                      ,pend.api_name
                      ,pend.transaction_step_id
                      ,'P_ABS_INFORMATION18'))
       END                                       abs_information18_meaning_p 
,      CASE WHEN pend.transaction_id IS NOT NULL
            THEN xxas_hr_api_transaction_pkg.varchar2_value
                   (paa.person_id
                   ,pend.api_name
                   ,pend.transaction_step_id
                   ,'P_ABS_INFORMATION19')
       END                                       abs_information19_p
,      CASE WHEN pend.transaction_id IS NOT NULL
            THEN xxas_com_vset_pkg.decode_descr_vset_value
                   ('800'
                   ,'PER_ABS_DEVELOPER_DF'
                   ,paa.abs_information_category
                   ,'ABS_INFORMATION19'
                   ,xxas_hr_api_transaction_pkg.varchar2_value
                      (paa.person_id
                      ,pend.api_name
                      ,pend.transaction_step_id
                      ,'P_ABS_INFORMATION19'))
       END                                       abs_information19_meaning_p 
,      CASE WHEN pend.transaction_id IS NOT NULL
            THEN xxas_hr_api_transaction_pkg.varchar2_value
                   (paa.person_id
                   ,pend.api_name
                   ,pend.transaction_step_id
                   ,'P_ABS_INFORMATION20')
       END                                       abs_information20_p
,      CASE WHEN pend.transaction_id IS NOT NULL
            THEN xxas_com_vset_pkg.decode_descr_vset_value
                   ('800'
                   ,'PER_ABS_DEVELOPER_DF'
                   ,paa.abs_information_category
                   ,'ABS_INFORMATION20'
                   ,xxas_hr_api_transaction_pkg.varchar2_value
                      (paa.person_id
                      ,pend.api_name
                      ,pend.transaction_step_id
                      ,'P_ABS_INFORMATION20'))
       END                                       abs_information20_meaning_p 
,      CASE WHEN pend.transaction_id IS NOT NULL
            THEN xxas_hr_api_transaction_pkg.varchar2_value
                   (paa.person_id
                   ,pend.api_name
                   ,pend.transaction_step_id
                   ,'P_ABS_INFORMATION21')
       END                                       abs_information21_p
,      CASE WHEN pend.transaction_id IS NOT NULL
            THEN xxas_com_vset_pkg.decode_descr_vset_value
                   ('800'
                   ,'PER_ABS_DEVELOPER_DF'
                   ,paa.abs_information_category
                   ,'ABS_INFORMATION21'
                   ,xxas_hr_api_transaction_pkg.varchar2_value
                      (paa.person_id
                      ,pend.api_name
                      ,pend.transaction_step_id
                      ,'P_ABS_INFORMATION21'))
       END                                       abs_information21_meaning_p 
,      CASE WHEN pend.transaction_id IS NOT NULL
            THEN xxas_hr_api_transaction_pkg.varchar2_value
                   (paa.person_id
                   ,pend.api_name
                   ,pend.transaction_step_id
                   ,'P_ABS_INFORMATION22')
       END                                       abs_information22_p
,      CASE WHEN pend.transaction_id IS NOT NULL
            THEN xxas_com_vset_pkg.decode_descr_vset_value
                   ('800'
                   ,'PER_ABS_DEVELOPER_DF'
                   ,paa.abs_information_category
                   ,'ABS_INFORMATION22'
                   ,xxas_hr_api_transaction_pkg.varchar2_value
                      (paa.person_id
                      ,pend.api_name
                      ,pend.transaction_step_id
                      ,'P_ABS_INFORMATION22'))
       END                                       abs_information22_meaning_p 
,      CASE WHEN pend.transaction_id IS NOT NULL
            THEN xxas_hr_api_transaction_pkg.varchar2_value
                   (paa.person_id
                   ,pend.api_name
                   ,pend.transaction_step_id
                   ,'P_ABS_INFORMATION23')
       END                                       abs_information23_p
,      CASE WHEN pend.transaction_id IS NOT NULL
            THEN xxas_com_vset_pkg.decode_descr_vset_value
                   ('800'
                   ,'PER_ABS_DEVELOPER_DF'
                   ,paa.abs_information_category
                   ,'ABS_INFORMATION23'
                   ,xxas_hr_api_transaction_pkg.varchar2_value
                      (paa.person_id
                      ,pend.api_name
                      ,pend.transaction_step_id
                      ,'P_ABS_INFORMATION23'))
       END                                       abs_information23_meaning_p 
,      CASE WHEN pend.transaction_id IS NOT NULL
            THEN xxas_hr_api_transaction_pkg.varchar2_value
                   (paa.person_id
                   ,pend.api_name
                   ,pend.transaction_step_id
                   ,'P_ABS_INFORMATION24')
       END                                       abs_information24_p
,      CASE WHEN pend.transaction_id IS NOT NULL
            THEN xxas_com_vset_pkg.decode_descr_vset_value
                   ('800'
                   ,'PER_ABS_DEVELOPER_DF'
                   ,paa.abs_information_category
                   ,'ABS_INFORMATION24'
                   ,xxas_hr_api_transaction_pkg.varchar2_value
                      (paa.person_id
                      ,pend.api_name
                      ,pend.transaction_step_id
                      ,'P_ABS_INFORMATION24'))
       END                                       abs_information24_meaning_p 
,      CASE WHEN pend.transaction_id IS NOT NULL
            THEN xxas_hr_api_transaction_pkg.varchar2_value
                   (paa.person_id
                   ,pend.api_name
                   ,pend.transaction_step_id
                   ,'P_ABS_INFORMATION25')
       END                                       abs_information25_p
,      CASE WHEN pend.transaction_id IS NOT NULL
            THEN xxas_com_vset_pkg.decode_descr_vset_value
                   ('800'
                   ,'PER_ABS_DEVELOPER_DF'
                   ,paa.abs_information_category
                   ,'ABS_INFORMATION25'
                   ,xxas_hr_api_transaction_pkg.varchar2_value
                      (paa.person_id
                      ,pend.api_name
                      ,pend.transaction_step_id
                      ,'P_ABS_INFORMATION25'))
       END                                       abs_information25_meaning_p 
,      CASE WHEN pend.transaction_id IS NOT NULL
            THEN xxas_hr_api_transaction_pkg.varchar2_value
                   (paa.person_id
                   ,pend.api_name
                   ,pend.transaction_step_id
                   ,'P_ABS_INFORMATION26')
       END                                       abs_information26_p
,      CASE WHEN pend.transaction_id IS NOT NULL
            THEN xxas_com_vset_pkg.decode_descr_vset_value
                   ('800'
                   ,'PER_ABS_DEVELOPER_DF'
                   ,paa.abs_information_category
                   ,'ABS_INFORMATION26'
                   ,xxas_hr_api_transaction_pkg.varchar2_value
                      (paa.person_id
                      ,pend.api_name
                      ,pend.transaction_step_id
                      ,'P_ABS_INFORMATION26'))
       END                                       abs_information26_meaning_p 
,      CASE WHEN pend.transaction_id IS NOT NULL
            THEN xxas_hr_api_transaction_pkg.varchar2_value
                   (paa.person_id
                   ,pend.api_name
                   ,pend.transaction_step_id
                   ,'P_ABS_INFORMATION27')
       END                                       abs_information27_p
,      CASE WHEN pend.transaction_id IS NOT NULL
            THEN xxas_com_vset_pkg.decode_descr_vset_value
                   ('800'
                   ,'PER_ABS_DEVELOPER_DF'
                   ,paa.abs_information_category
                   ,'ABS_INFORMATION27'
                   ,xxas_hr_api_transaction_pkg.varchar2_value
                      (paa.person_id
                      ,pend.api_name
                      ,pend.transaction_step_id
                      ,'P_ABS_INFORMATION27'))
       END                                       abs_information27_meaning_p 
,      CASE WHEN pend.transaction_id IS NOT NULL
            THEN xxas_hr_api_transaction_pkg.varchar2_value
                   (paa.person_id
                   ,pend.api_name
                   ,pend.transaction_step_id
                   ,'P_ABS_INFORMATION28')
       END                                       abs_information28_p
,      CASE WHEN pend.transaction_id IS NOT NULL
            THEN xxas_com_vset_pkg.decode_descr_vset_value
                   ('800'
                   ,'PER_ABS_DEVELOPER_DF'
                   ,paa.abs_information_category
                   ,'ABS_INFORMATION28'
                   ,xxas_hr_api_transaction_pkg.varchar2_value
                      (paa.person_id
                      ,pend.api_name
                      ,pend.transaction_step_id
                      ,'P_ABS_INFORMATION28'))
       END                                       abs_information28_meaning_p 
,      CASE WHEN pend.transaction_id IS NOT NULL
            THEN xxas_hr_api_transaction_pkg.varchar2_value
                   (paa.person_id
                   ,pend.api_name
                   ,pend.transaction_step_id
                   ,'P_ABS_INFORMATION29')
       END                                       abs_information29_p
,      CASE WHEN pend.transaction_id IS NOT NULL
            THEN xxas_com_vset_pkg.decode_descr_vset_value
                   ('800'
                   ,'PER_ABS_DEVELOPER_DF'
                   ,paa.abs_information_category
                   ,'ABS_INFORMATION29'
                   ,xxas_hr_api_transaction_pkg.varchar2_value
                      (paa.person_id
                      ,pend.api_name
                      ,pend.transaction_step_id
                      ,'P_ABS_INFORMATION29'))
       END                                       abs_information29_meaning_p 
,      CASE WHEN pend.transaction_id IS NOT NULL
            THEN xxas_hr_api_transaction_pkg.varchar2_value
                   (paa.person_id
                   ,pend.api_name
                   ,pend.transaction_step_id
                   ,'P_ABS_INFORMATION30')
       END                                       abs_information30_p
,      CASE WHEN pend.transaction_id IS NOT NULL
            THEN xxas_com_vset_pkg.decode_descr_vset_value
                   ('800'
                   ,'PER_ABS_DEVELOPER_DF'
                   ,paa.abs_information_category
                   ,'ABS_INFORMATION30'
                   ,xxas_hr_api_transaction_pkg.varchar2_value
                      (paa.person_id
                      ,pend.api_name
                      ,pend.transaction_step_id
                      ,'P_ABS_INFORMATION30'))
       END                                       abs_information30_meaning_p 
,      CASE WHEN pend.transaction_id IS NOT NULL
            THEN xxas_hr_api_transaction_pkg.varchar2_value
                   (paa.person_id
                   ,pend.api_name
                   ,pend.transaction_step_id
                   ,'P_COMMENTS')
       END                                       comments_p
,     'PQH_SS_ATTACHMENT'                        attachment_entity
,      pend.transaction_id                       attachment_pk1
FROM   per_absence_attendances      paa
,      per_abs_attendance_types_vl  paat
,      hr_lookups                   fcl
,      (SELECT paap.person_id
        ,      paap.absence_attendance_id
        ,      hats.api_name
        ,      hat.transaction_id
        ,      eid.transaction_step_id
        ,      'UPDATE'                                                   transaction_type
        ,      hat.status                                                 hr_api_status_code
        ,      xxas_selfservice_workflow_pkg.transcode_status(hat.status) workflow_status_code
        ,      paat1.name                                                 absence_type_p
        ,      paat1.absence_category                                     absence_category_code_p
        ,      fcl1.meaning                                               absence_category_p
        FROM   per_absence_attendances     paap
        ,      hr_api_transactions         hat
        ,      hr_api_transaction_steps    hats
        ,      hr_api_transaction_values   act
        ,      hr_api_transaction_values   eid
        ,      hr_api_transaction_values   tid
        ,      per_abs_attendance_types_vl paat1
        ,      hr_lookups                  fcl1
        WHERE  paap.person_id           = hat.selected_person_id
        AND    hat.transaction_id       = hats.transaction_id
        AND    hat.status          NOT IN ('D', 'N', 'W', 'ACTIVE', 'AC')
        AND    hats.api_name            = 'HR_LOA_SS.PROCESS_API'
        AND    hats.transaction_step_id = act.transaction_step_id
        AND    act.name                 = 'P_ACTIVITY_NAME'
        AND    act.varchar2_value       = 'HrLoaUpdate'
        AND    hats.transaction_step_id = eid.transaction_step_id
        AND    eid.name                 = 'P_ABSENCE_ATTENDANCE_ID'
        AND    eid.number_value         = paap.absence_attendance_id
        AND    hats.transaction_step_id = tid.transaction_step_id
        AND    tid.name                 = 'P_ABSENCE_ATTENDANCE_TYPE_ID'
        AND    tid.number_value         = paat1.absence_attendance_type_id
        AND    paat1.absence_category   = fcl1.lookup_code(+)
        AND    fcl1.lookup_type(+)      = 'ABSENCE_CATEGORY'
        ) pend       
WHERE  paa.absence_attendance_type_id  = paat.absence_attendance_type_id
AND    paat.absence_category           = fcl.lookup_code(+)
AND    fcl.lookup_type(+)              = 'ABSENCE_CATEGORY'
AND   paa.person_id                    = pend.person_id(+)        
AND   paa.absence_attendance_id        = pend.absence_attendance_id(+)        
UNION ALL
SELECT NULL                                      absence_attendance_id
,      NULL                                      object_version_number
,      NULL                                      business_group_id
,      NULL                                      absence_type_id
,      NULL                                      absence_type
,      NULL                                      absence_category_code
,      NULL                                      absence_category
,      NULL                                      abs_attendance_reason_id
,      NULL                                      absence_reason
,      hat.selected_person_id                    person_id
,      NULL                                      authorising_person_id
,      NULL                                      replacement_person_id
,      NULL                                      period_of_incapacity_id
,      NULL                                      absence_days
,      NULL                                      absence_hours
,      NULL                                      date_end
,      NULL                                      date_notification
,      NULL                                      date_projected_end
,      NULL                                      date_projected_start
,      NULL                                      date_start
,      NULL                                      occurrence
,      NULL                                      ssp1_issued 
,      NULL                                      time_end
,      NULL                                      time_projected_end
,      NULL                                      time_projected_start
,      NULL                                      time_start
,      NULL                                      attribute_category
,      NULL                                      attribute1
,      NULL                                      attribute1_meaning
,      NULL                                      attribute2
,      NULL                                      attribute2_meaning
,      NULL                                      attribute3
,      NULL                                      attribute3_meaning
,      NULL                                      attribute4
,      NULL                                      attribute4_meaning
,      NULL                                      attribute5
,      NULL                                      attribute5_meaning
,      NULL                                      attribute6
,      NULL                                      attribute6_meaning
,      NULL                                      attribute7
,      NULL                                      attribute7_meaning
,      NULL                                      attribute8
,      NULL                                      attribute8_meaning
,      NULL                                      attribute9
,      NULL                                      attribute9_meaning
,      NULL                                      attribute10
,      NULL                                      attribute10_meaning
,      NULL                                      attribute11
,      NULL                                      attribute11_meaning
,      NULL                                      attribute12
,      NULL                                      attribute12_meaning
,      NULL                                      attribute13
,      NULL                                      attribute13_meaning
,      NULL                                      attribute14
,      NULL                                      attribute14_meaning
,      NULL                                      attribute15
,      NULL                                      attribute15_meaning
,      NULL                                      attribute16
,      NULL                                      attribute16_meaning
,      NULL                                      attribute17
,      NULL                                      attribute17_meaning
,      NULL                                      attribute18
,      NULL                                      attribute18_meaning
,      NULL                                      attribute19
,      NULL                                      attribute19_meaning
,      NULL                                      attribute20
,      NULL                                      attribute20_meaning
,      NULL                                      last_update_date
,      NULL                                      last_updated_by
,      NULL                                      last_update_login
,      NULL                                      created_by
,      NULL                                      creation_date
,      NULL                                      maternity_id
,      NULL                                      sickness_start_date
,      NULL                                      sickness_end_date
,      NULL                                      pregnancy_related_illness 
,      NULL                                      reason_for_notification_delay 
,      NULL                                      accept_late_notification_flag
,      NULL                                      linked_absence_id
,      NULL                                      abs_information_category
,      NULL                                      abs_information1
,      NULL                                      abs_information1_meaning 
,      NULL                                      abs_information2
,      NULL                                      abs_information2_meaning 
,      NULL                                      abs_information3
,      NULL                                      abs_information3_meaning 
,      NULL                                      abs_information4
,      NULL                                      abs_information4_meaning 
,      NULL                                      abs_information5
,      NULL                                      abs_information5_meaning 
,      NULL                                      abs_information6
,      NULL                                      abs_information6_meaning 
,      NULL                                      abs_information7
,      NULL                                      abs_information7_meaning 
,      NULL                                      abs_information8
,      NULL                                      abs_information8_meaning 
,      NULL                                      abs_information9
,      NULL                                      abs_information9_meaning 
,      NULL                                      abs_information10
,      NULL                                      abs_information10_meaning 
,      NULL                                      abs_information11
,      NULL                                      abs_information11_meaning 
,      NULL                                      abs_information12
,      NULL                                      abs_information12_meaning 
,      NULL                                      abs_information13
,      NULL                                      abs_information13_meaning 
,      NULL                                      abs_information14
,      NULL                                      abs_information14_meaning 
,      NULL                                      abs_information15
,      NULL                                      abs_information15_meaning 
,      NULL                                      abs_information16
,      NULL                                      abs_information16_meaning 
,      NULL                                      abs_information17
,      NULL                                      abs_information17_meaning 
,      NULL                                      abs_information18
,      NULL                                      abs_information18_meaning 
,      NULL                                      abs_information19
,      NULL                                      abs_information19_meaning 
,      NULL                                      abs_information20
,      NULL                                      abs_information20_meaning 
,      NULL                                      abs_information21
,      NULL                                      abs_information21_meaning 
,      NULL                                      abs_information22
,      NULL                                      abs_information22_meaning 
,      NULL                                      abs_information23
,      NULL                                      abs_information23_meaning 
,      NULL                                      abs_information24
,      NULL                                      abs_information24_meaning 
,      NULL                                      abs_information25
,      NULL                                      abs_information25_meaning 
,      NULL                                      abs_information26
,      NULL                                      abs_information26_meaning 
,      NULL                                      abs_information27
,      NULL                                      abs_information27_meaning 
,      NULL                                      abs_information28
,      NULL                                      abs_information28_meaning 
,      NULL                                      abs_information29
,      NULL                                      abs_information29_meaning 
,      NULL                                      abs_information30
,      NULL                                      abs_information30_meaning 
,      NULL                                      batch_id
,      NULL                                      comments       
,      NULL                                      absence_case_id
,      NULL                                      approval_status
,      NULL                                      confirmed_until
,      NULL                                      source
,      NULL                                      advance_pay
,      hat.transaction_id
,      act.transaction_step_id
,      'INSERT'                                  transaction_type
,      hat.status                                hr_api_status_code
,      xxas_selfservice_workflow_pkg.transcode_status
         (hat.status)                            workflow_status_code
,      xxas_selfservice_workflow_pkg.decode_status
         (xxas_selfservice_workflow_pkg.transcode_status
         (hat.status))                           workflow_status_meaning   
,      xxas_hr_api_transaction_pkg.number_value
         (hat.selected_person_id
         ,hats.api_name
         ,hats.transaction_step_id
         ,'P_OBJECT_VERSION_NUMBER')             object_version_number_p
,      xxas_hr_api_transaction_pkg.number_value
         (hat.selected_person_id
         ,hats.api_name
         ,hats.transaction_step_id
         ,'P_BUSINESS_GROUP_ID')                 business_group_id_p
,      xxas_hr_api_transaction_pkg.number_value
         (hat.selected_person_id
         ,hats.api_name
         ,hats.transaction_step_id
         ,'P_ABSENCE_ATTENDANCE_TYPE_ID')        absence_type_id_p
,      paat.name                                 absence_type_p
,      paat.absence_category                     absence_category_code_p
,      fcl.meaning                               absence_category_p         
,      xxas_hr_api_transaction_pkg.number_value
         (hat.selected_person_id
         ,hats.api_name
         ,hats.transaction_step_id
         ,'P_ABS_ATTENDANCE_REASON_ID')          abs_attendance_reason_id_p
,      (SELECT rea.meaning     
        FROM   per_abs_attendance_reasons paar
        ,      hr_lookups                 rea
        WHERE  paar.abs_attendance_reason_id = xxas_hr_api_transaction_pkg.number_value
                                                (hat.selected_person_id
                                                ,hats.api_name
                                                ,hats.transaction_step_id
                                                ,'P_ABS_ATTENDANCE_REASON_ID')
        AND    paar.name                     = rea.lookup_code
        AND    rea.lookup_type               = 'ABSENCE_REASON') abs_attendance_reason_p
,      xxas_hr_api_transaction_pkg.number_value
         (hat.selected_person_id
         ,hats.api_name
         ,hats.transaction_step_id
         ,'P_ABSENCE_DAYS')                      absence_days_p
,      xxas_hr_api_transaction_pkg.number_value
         (hat.selected_person_id
         ,hats.api_name
         ,hats.transaction_step_id
         ,'P_ABSENCE_HOURS')                     absence_hours_p
,      xxas_hr_api_transaction_pkg.date_value
         (hat.selected_person_id
         ,hats.api_name
         ,hats.transaction_step_id
         ,'P_DATE_END')                          date_end_p
,      xxas_hr_api_transaction_pkg.date_value
         (hat.selected_person_id
         ,hats.api_name
         ,hats.transaction_step_id
         ,'P_DATE_NOTIFICATION')                 date_notification_p
,      xxas_hr_api_transaction_pkg.date_value
         (hat.selected_person_id
         ,hats.api_name
         ,hats.transaction_step_id
         ,'P_DATE_PROJECTED_END')                date_projected_end_p
,      xxas_hr_api_transaction_pkg.date_value
         (hat.selected_person_id
         ,hats.api_name
         ,hats.transaction_step_id
         ,'P_DATE_PROJECTED_START')              date_projected_start_p
,      xxas_hr_api_transaction_pkg.date_value
         (hat.selected_person_id
         ,hats.api_name
         ,hats.transaction_step_id
         ,'P_DATE_START')                        date_start_p
,      xxas_hr_api_transaction_pkg.varchar2_value
         (hat.selected_person_id
         ,hats.api_name
         ,hats.transaction_step_id
         ,'P_TIME_END')                          time_end_p
,      xxas_hr_api_transaction_pkg.varchar2_value
         (hat.selected_person_id
         ,hats.api_name
         ,hats.transaction_step_id
         ,'P_TIME_PROJECTED_END')                time_projected_end_p
,      xxas_hr_api_transaction_pkg.varchar2_value
         (hat.selected_person_id
         ,hats.api_name
         ,hats.transaction_step_id
         ,'P_TIME_PROJECTED_START')              time_projected_start_p
,      xxas_hr_api_transaction_pkg.varchar2_value
         (hat.selected_person_id
         ,hats.api_name
         ,hats.transaction_step_id
         ,'P_TIME_START')                        time_start_p
,      xxas_hr_api_transaction_pkg.varchar2_value
         (hat.selected_person_id
         ,hats.api_name
         ,hats.transaction_step_id
         ,'P_ATTRIBUTE_CATEGORY')                attribute_category_p
,      xxas_hr_api_transaction_pkg.varchar2_value
         (hat.selected_person_id
         ,hats.api_name
         ,hats.transaction_step_id
         ,'P_ATTRIBUTE1')                        attribute1_p
,      xxas_com_vset_pkg.decode_descr_vset_value
         ('800'
         ,'PER_ABSENCE_ATTENDANCES'
         ,NVL(info.varchar2_value, att.varchar2_value)
         ,'ATTRIBUTE1'
         ,xxas_hr_api_transaction_pkg.varchar2_value
            (hat.selected_person_id
            ,hats.api_name
            ,hats.transaction_step_id
            ,'P_ATTRIBUTE1'))                    attribute1_meaning_p 
,      xxas_hr_api_transaction_pkg.varchar2_value
         (hat.selected_person_id
         ,hats.api_name
         ,hats.transaction_step_id
         ,'P_ATTRIBUTE2')                        attribute2_p
,      xxas_com_vset_pkg.decode_descr_vset_value
         ('800'
         ,'PER_ABSENCE_ATTENDANCES'
         ,NVL(info.varchar2_value, att.varchar2_value)
         ,'ATTRIBUTE2'
         ,xxas_hr_api_transaction_pkg.varchar2_value
            (hat.selected_person_id
            ,hats.api_name
            ,hats.transaction_step_id
            ,'P_ATTRIBUTE2'))                    attribute2_meaning_p 
,      xxas_hr_api_transaction_pkg.varchar2_value
         (hat.selected_person_id
         ,hats.api_name
         ,hats.transaction_step_id
         ,'P_ATTRIBUTE3')                        attribute3_p
,      xxas_com_vset_pkg.decode_descr_vset_value
         ('800'
         ,'PER_ABSENCE_ATTENDANCES'
         ,NVL(info.varchar2_value, att.varchar2_value)
         ,'ATTRIBUTE3'
         ,xxas_hr_api_transaction_pkg.varchar2_value
            (hat.selected_person_id
            ,hats.api_name
            ,hats.transaction_step_id
            ,'P_ATTRIBUTE3'))                    attribute3_meaning_p 
,      xxas_hr_api_transaction_pkg.varchar2_value
         (hat.selected_person_id
         ,hats.api_name
         ,hats.transaction_step_id
         ,'P_ATTRIBUTE4')                        attribute4_p
,      xxas_com_vset_pkg.decode_descr_vset_value
         ('800'
         ,'PER_ABSENCE_ATTENDANCES'
         ,NVL(info.varchar2_value, att.varchar2_value)
         ,'ATTRIBUTE4'
         ,xxas_hr_api_transaction_pkg.varchar2_value
            (hat.selected_person_id
            ,hats.api_name
            ,hats.transaction_step_id
            ,'P_ATTRIBUTE4'))                    attribute4_meaning_p 
,      xxas_hr_api_transaction_pkg.varchar2_value
         (hat.selected_person_id
         ,hats.api_name
         ,hats.transaction_step_id
         ,'P_ATTRIBUTE5')                        attribute5_p
,      xxas_com_vset_pkg.decode_descr_vset_value
         ('800'
         ,'PER_ABSENCE_ATTENDANCES'
         ,NVL(info.varchar2_value, att.varchar2_value)
         ,'ATTRIBUTE5'
         ,xxas_hr_api_transaction_pkg.varchar2_value
            (hat.selected_person_id
            ,hats.api_name
            ,hats.transaction_step_id
            ,'P_ATTRIBUTE5'))                    attribute5_meaning_p 
,      xxas_hr_api_transaction_pkg.varchar2_value
         (hat.selected_person_id
         ,hats.api_name
         ,hats.transaction_step_id
         ,'P_ATTRIBUTE6')                        attribute6_p
,      xxas_com_vset_pkg.decode_descr_vset_value
         ('800'
         ,'PER_ABSENCE_ATTENDANCES'
         ,NVL(info.varchar2_value, att.varchar2_value)
         ,'ATTRIBUTE6'
         ,xxas_hr_api_transaction_pkg.varchar2_value
            (hat.selected_person_id
            ,hats.api_name
            ,hats.transaction_step_id
            ,'P_ATTRIBUTE6'))                    attribute6_meaning_p 
,      xxas_hr_api_transaction_pkg.varchar2_value
         (hat.selected_person_id
         ,hats.api_name
         ,hats.transaction_step_id
         ,'P_ATTRIBUTE7')                        attribute7_p
,      xxas_com_vset_pkg.decode_descr_vset_value
         ('800'
         ,'PER_ABSENCE_ATTENDANCES'
         ,NVL(info.varchar2_value, att.varchar2_value)
         ,'ATTRIBUTE7'
         ,xxas_hr_api_transaction_pkg.varchar2_value
            (hat.selected_person_id
            ,hats.api_name
            ,hats.transaction_step_id
            ,'P_ATTRIBUTE7'))                    attribute7_meaning_p 
,      xxas_hr_api_transaction_pkg.varchar2_value
         (hat.selected_person_id
         ,hats.api_name
         ,hats.transaction_step_id
         ,'P_ATTRIBUTE8')                        attribute8_p
,      xxas_com_vset_pkg.decode_descr_vset_value
         ('800'
         ,'PER_ABSENCE_ATTENDANCES'
         ,NVL(info.varchar2_value, att.varchar2_value)
         ,'ATTRIBUTE8'
         ,xxas_hr_api_transaction_pkg.varchar2_value
            (hat.selected_person_id
            ,hats.api_name
            ,hats.transaction_step_id
            ,'P_ATTRIBUTE8'))                    attribute8_meaning_p 
,      xxas_hr_api_transaction_pkg.varchar2_value
         (hat.selected_person_id
         ,hats.api_name
         ,hats.transaction_step_id
         ,'P_ATTRIBUTE9')                        attribute9_p
,      xxas_com_vset_pkg.decode_descr_vset_value
         ('800'
         ,'PER_ABSENCE_ATTENDANCES'
         ,NVL(info.varchar2_value, att.varchar2_value)
         ,'ATTRIBUTE9'
         ,xxas_hr_api_transaction_pkg.varchar2_value
            (hat.selected_person_id
            ,hats.api_name
            ,hats.transaction_step_id
            ,'P_ATTRIBUTE9'))                    attribute9_meaning_p 
,      xxas_hr_api_transaction_pkg.varchar2_value
         (hat.selected_person_id
         ,hats.api_name
         ,hats.transaction_step_id
         ,'P_ATTRIBUTE10')                       attribute10_p
,      xxas_com_vset_pkg.decode_descr_vset_value
         ('800'
         ,'PER_ABSENCE_ATTENDANCES'
         ,NVL(info.varchar2_value, att.varchar2_value)
         ,'ATTRIBUTE10'
         ,xxas_hr_api_transaction_pkg.varchar2_value
            (hat.selected_person_id
            ,hats.api_name
            ,hats.transaction_step_id
            ,'P_ATTRIBUTE10'))                   attribute10_meaning_p 
,      xxas_hr_api_transaction_pkg.varchar2_value
         (hat.selected_person_id
         ,hats.api_name
         ,hats.transaction_step_id
         ,'P_ATTRIBUTE11')                       attribute11_p
,      xxas_com_vset_pkg.decode_descr_vset_value
         ('800'
         ,'PER_ABSENCE_ATTENDANCES'
         ,NVL(info.varchar2_value, att.varchar2_value)
         ,'ATTRIBUTE11'
         ,xxas_hr_api_transaction_pkg.varchar2_value
            (hat.selected_person_id
            ,hats.api_name
            ,hats.transaction_step_id
            ,'P_ATTRIBUTE11'))                   attribute11_meaning_p 
,      xxas_hr_api_transaction_pkg.varchar2_value
         (hat.selected_person_id
         ,hats.api_name
         ,hats.transaction_step_id
         ,'P_ATTRIBUTE12')                       attribute12_p
,      xxas_com_vset_pkg.decode_descr_vset_value
         ('800'
         ,'PER_ABSENCE_ATTENDANCES'
         ,NVL(info.varchar2_value, att.varchar2_value)
         ,'ATTRIBUTE12'
         ,xxas_hr_api_transaction_pkg.varchar2_value
            (hat.selected_person_id
            ,hats.api_name
            ,hats.transaction_step_id
            ,'P_ATTRIBUTE12'))                   attribute12_meaning_p 
,      xxas_hr_api_transaction_pkg.varchar2_value
         (hat.selected_person_id
         ,hats.api_name
         ,hats.transaction_step_id
         ,'P_ATTRIBUTE13')                       attribute13_p
,      xxas_com_vset_pkg.decode_descr_vset_value
         ('800'
         ,'PER_ABSENCE_ATTENDANCES'
         ,NVL(info.varchar2_value, att.varchar2_value)
         ,'ATTRIBUTE13'
         ,xxas_hr_api_transaction_pkg.varchar2_value
            (hat.selected_person_id
            ,hats.api_name
            ,hats.transaction_step_id
            ,'P_ATTRIBUTE13'))                   attribute13_meaning_p 
,      xxas_hr_api_transaction_pkg.varchar2_value
         (hat.selected_person_id
         ,hats.api_name
         ,hats.transaction_step_id
         ,'P_ATTRIBUTE14')                       attribute14_p
,      xxas_com_vset_pkg.decode_descr_vset_value
         ('800'
         ,'PER_ABSENCE_ATTENDANCES'
         ,NVL(info.varchar2_value, att.varchar2_value)
         ,'ATTRIBUTE14'
         ,xxas_hr_api_transaction_pkg.varchar2_value
            (hat.selected_person_id
            ,hats.api_name
            ,hats.transaction_step_id
            ,'P_ATTRIBUTE14'))                   attribute14_meaning_p 
,      xxas_hr_api_transaction_pkg.varchar2_value
         (hat.selected_person_id
         ,hats.api_name
         ,hats.transaction_step_id
         ,'P_ATTRIBUTE15')                       attribute15_p
,      xxas_com_vset_pkg.decode_descr_vset_value
         ('800'
         ,'PER_ABSENCE_ATTENDANCES'
         ,NVL(info.varchar2_value, att.varchar2_value)
         ,'ATTRIBUTE15'
         ,xxas_hr_api_transaction_pkg.varchar2_value
            (hat.selected_person_id
            ,hats.api_name
            ,hats.transaction_step_id
            ,'P_ATTRIBUTE15'))                   attribute15_meaning_p 
,      xxas_hr_api_transaction_pkg.varchar2_value
         (hat.selected_person_id
         ,hats.api_name
         ,hats.transaction_step_id
         ,'P_ATTRIBUTE16')                       attribute16_p
,      xxas_com_vset_pkg.decode_descr_vset_value
         ('800'
         ,'PER_ABSENCE_ATTENDANCES'
         ,NVL(info.varchar2_value, att.varchar2_value)
         ,'ATTRIBUTE16'
         ,xxas_hr_api_transaction_pkg.varchar2_value
            (hat.selected_person_id
            ,hats.api_name
            ,hats.transaction_step_id
            ,'P_ATTRIBUTE16'))                   attribute16_meaning_p 
,      xxas_hr_api_transaction_pkg.varchar2_value
         (hat.selected_person_id
         ,hats.api_name
         ,hats.transaction_step_id
         ,'P_ATTRIBUTE17')                       attribute17_p
,      xxas_com_vset_pkg.decode_descr_vset_value
         ('800'
         ,'PER_ABSENCE_ATTENDANCES'
         ,NVL(info.varchar2_value, att.varchar2_value)
         ,'ATTRIBUTE17'
         ,xxas_hr_api_transaction_pkg.varchar2_value
            (hat.selected_person_id
            ,hats.api_name
            ,hats.transaction_step_id
            ,'P_ATTRIBUTE17'))                   attribute17_meaning_p 
,      xxas_hr_api_transaction_pkg.varchar2_value
         (hat.selected_person_id
         ,hats.api_name
         ,hats.transaction_step_id
         ,'P_ATTRIBUTE18')                       attribute18_p
,      xxas_com_vset_pkg.decode_descr_vset_value
         ('800'
         ,'PER_ABSENCE_ATTENDANCES'
         ,NVL(info.varchar2_value, att.varchar2_value)
         ,'ATTRIBUTE18'
         ,xxas_hr_api_transaction_pkg.varchar2_value
            (hat.selected_person_id
            ,hats.api_name
            ,hats.transaction_step_id
            ,'P_ATTRIBUTE18'))                   attribute18_meaning_p 
,      xxas_hr_api_transaction_pkg.varchar2_value
         (hat.selected_person_id
         ,hats.api_name
         ,hats.transaction_step_id
         ,'P_ATTRIBUTE19')                       attribute19_p
,      xxas_com_vset_pkg.decode_descr_vset_value
         ('800'
         ,'PER_ABSENCE_ATTENDANCES'
         ,NVL(info.varchar2_value, att.varchar2_value)
         ,'ATTRIBUTE19'
         ,xxas_hr_api_transaction_pkg.varchar2_value
            (hat.selected_person_id
            ,hats.api_name
            ,hats.transaction_step_id
            ,'P_ATTRIBUTE19'))                   attribute19_meaning_p 
,      xxas_hr_api_transaction_pkg.varchar2_value
         (hat.selected_person_id
         ,hats.api_name
         ,hats.transaction_step_id
         ,'P_ATTRIBUTE20')                       attribute20_p
,      xxas_com_vset_pkg.decode_descr_vset_value
         ('800'
         ,'PER_ABSENCE_ATTENDANCES'
         ,NVL(info.varchar2_value, att.varchar2_value)
         ,'ATTRIBUTE20'
         ,xxas_hr_api_transaction_pkg.varchar2_value
            (hat.selected_person_id
            ,hats.api_name
            ,hats.transaction_step_id
            ,'P_ATTRIBUTE20'))                   attribute20_meaning_p 
,      xxas_hr_api_transaction_pkg.varchar2_value
         (hat.selected_person_id
         ,hats.api_name
         ,hats.transaction_step_id
         ,'P_ABS_INFORMATION_CATEGORY')          abs_information_category_p
,      xxas_hr_api_transaction_pkg.varchar2_value
         (hat.selected_person_id
         ,hats.api_name
         ,hats.transaction_step_id
         ,'P_ABS_INFORMATION1')                  abs_information1_p
,      xxas_com_vset_pkg.decode_descr_vset_value
         (hat.selected_person_id
         ,'PER_ABS_DEVELOPER_DF'
         ,info.varchar2_value
         ,'ABS_INFORMATION1'
         ,xxas_hr_api_transaction_pkg.varchar2_value
            (hat.selected_person_id
            ,hats.api_name
            ,hats.transaction_step_id
            ,'P_ABS_INFORMATION1'))              abs_information1_meaning_p 
,      xxas_hr_api_transaction_pkg.varchar2_value
         (hat.selected_person_id
         ,hats.api_name
         ,hats.transaction_step_id
         ,'P_ABS_INFORMATION2')                  abs_information2_p
,      xxas_com_vset_pkg.decode_descr_vset_value
         ('800'
         ,'PER_ABS_DEVELOPER_DF'
         ,info.varchar2_value
         ,'ABS_INFORMATION2'
         ,xxas_hr_api_transaction_pkg.varchar2_value
            (hat.selected_person_id
            ,hats.api_name
            ,hats.transaction_step_id
            ,'P_ABS_INFORMATION2'))              abs_information2_meaning_p 
,      xxas_hr_api_transaction_pkg.varchar2_value
         (hat.selected_person_id
         ,hats.api_name
         ,hats.transaction_step_id
         ,'P_ABS_INFORMATION3')                  abs_information3_p
,      xxas_com_vset_pkg.decode_descr_vset_value
         ('800'
         ,'PER_ABS_DEVELOPER_DF'
         ,info.varchar2_value
         ,'ABS_INFORMATION3'
         ,xxas_hr_api_transaction_pkg.varchar2_value
            (hat.selected_person_id
            ,hats.api_name
            ,hats.transaction_step_id
            ,'P_ABS_INFORMATION3'))              abs_information3_meaning_p 
,      xxas_hr_api_transaction_pkg.varchar2_value
         (hat.selected_person_id
         ,hats.api_name
         ,hats.transaction_step_id
         ,'P_ABS_INFORMATION4')                  abs_information4_p
,      xxas_com_vset_pkg.decode_descr_vset_value
         ('800'
         ,'PER_ABS_DEVELOPER_DF'
         ,info.varchar2_value
         ,'ABS_INFORMATION4'
         ,xxas_hr_api_transaction_pkg.varchar2_value
            (hat.selected_person_id
            ,hats.api_name
            ,hats.transaction_step_id
            ,'P_ABS_INFORMATION4'))              abs_information4_meaning_p 
,      xxas_hr_api_transaction_pkg.varchar2_value
         (hat.selected_person_id
         ,hats.api_name
         ,hats.transaction_step_id
         ,'P_ABS_INFORMATION5')                  abs_information5_p
,      xxas_com_vset_pkg.decode_descr_vset_value
         ('800'
         ,'PER_ABS_DEVELOPER_DF'
         ,info.varchar2_value
         ,'ABS_INFORMATION5'
         ,xxas_hr_api_transaction_pkg.varchar2_value
            (hat.selected_person_id
            ,hats.api_name
            ,hats.transaction_step_id
            ,'P_ABS_INFORMATION5'))              abs_information5_meaning_p 
,      xxas_hr_api_transaction_pkg.varchar2_value
         (hat.selected_person_id
         ,hats.api_name
         ,hats.transaction_step_id
         ,'P_ABS_INFORMATION6')                  abs_information6_p
,      xxas_com_vset_pkg.decode_descr_vset_value
         ('800'
         ,'PER_ABS_DEVELOPER_DF'
         ,info.varchar2_value
         ,'ABS_INFORMATION6'
         ,xxas_hr_api_transaction_pkg.varchar2_value
            (hat.selected_person_id
            ,hats.api_name
            ,hats.transaction_step_id
            ,'P_ABS_INFORMATION6'))              abs_information6_meaning_p 
,      xxas_hr_api_transaction_pkg.varchar2_value
         (hat.selected_person_id
         ,hats.api_name
         ,hats.transaction_step_id
         ,'P_ABS_INFORMATION7')                  abs_information7_p
,      xxas_com_vset_pkg.decode_descr_vset_value
         ('800'
         ,'PER_ABS_DEVELOPER_DF'
         ,info.varchar2_value
         ,'ABS_INFORMATION7'
         ,xxas_hr_api_transaction_pkg.varchar2_value
            (hat.selected_person_id
            ,hats.api_name
            ,hats.transaction_step_id
            ,'P_ABS_INFORMATION7'))              abs_information7_meaning_p 
,      xxas_hr_api_transaction_pkg.varchar2_value
         (hat.selected_person_id
         ,hats.api_name
         ,hats.transaction_step_id
         ,'P_ABS_INFORMATION8')                  abs_information8_p
,      xxas_com_vset_pkg.decode_descr_vset_value
         ('800'
         ,'PER_ABS_DEVELOPER_DF'
         ,info.varchar2_value
         ,'ABS_INFORMATION8'
         ,xxas_hr_api_transaction_pkg.varchar2_value
            (hat.selected_person_id
            ,hats.api_name
            ,hats.transaction_step_id
            ,'P_ABS_INFORMATION8'))              abs_information8_meaning_p 
,      xxas_hr_api_transaction_pkg.varchar2_value
         (hat.selected_person_id
         ,hats.api_name
         ,hats.transaction_step_id
         ,'P_ABS_INFORMATION9')                  abs_information9_p
,      xxas_com_vset_pkg.decode_descr_vset_value
         ('800'
         ,'PER_ABS_DEVELOPER_DF'
         ,info.varchar2_value
         ,'ABS_INFORMATION9'
         ,xxas_hr_api_transaction_pkg.varchar2_value
            (hat.selected_person_id
            ,hats.api_name
            ,hats.transaction_step_id
            ,'P_ABS_INFORMATION9'))              abs_information9_meaning_p 
,      xxas_hr_api_transaction_pkg.varchar2_value
         (hat.selected_person_id
         ,hats.api_name
         ,hats.transaction_step_id
         ,'P_ABS_INFORMATION11')                 abs_information11_p
,      xxas_com_vset_pkg.decode_descr_vset_value
         ('800'
         ,'PER_ABS_DEVELOPER_DF'
         ,info.varchar2_value
         ,'ABS_INFORMATION11'
         ,xxas_hr_api_transaction_pkg.varchar2_value
            (hat.selected_person_id
            ,hats.api_name
            ,hats.transaction_step_id
            ,'P_ABS_INFORMATION11'))             abs_information11_meaning_p 
,      xxas_hr_api_transaction_pkg.varchar2_value
         (hat.selected_person_id
         ,hats.api_name
         ,hats.transaction_step_id
         ,'P_ABS_INFORMATION12')                 abs_information12_p
,      xxas_com_vset_pkg.decode_descr_vset_value
         ('800'
         ,'PER_ABS_DEVELOPER_DF'
         ,info.varchar2_value
         ,'ABS_INFORMATION12'
         ,xxas_hr_api_transaction_pkg.varchar2_value
            (hat.selected_person_id
            ,hats.api_name
            ,hats.transaction_step_id
            ,'P_ABS_INFORMATION12'))             abs_information12_meaning_p 
,      xxas_hr_api_transaction_pkg.varchar2_value
         (hat.selected_person_id
         ,hats.api_name
         ,hats.transaction_step_id
         ,'P_ABS_INFORMATION13')                 abs_information13_p
,      xxas_com_vset_pkg.decode_descr_vset_value
         ('800'
         ,'PER_ABS_DEVELOPER_DF'
         ,info.varchar2_value
         ,'ABS_INFORMATION13'
         ,xxas_hr_api_transaction_pkg.varchar2_value
            (hat.selected_person_id
            ,hats.api_name
            ,hats.transaction_step_id
            ,'P_ABS_INFORMATION13'))             abs_information13_meaning_p 
,      xxas_hr_api_transaction_pkg.varchar2_value
         (hat.selected_person_id
         ,hats.api_name
         ,hats.transaction_step_id
         ,'P_ABS_INFORMATION14')                 abs_information14_p
,      xxas_com_vset_pkg.decode_descr_vset_value
         ('800'
         ,'PER_ABS_DEVELOPER_DF'
         ,info.varchar2_value
         ,'ABS_INFORMATION14'
         ,xxas_hr_api_transaction_pkg.varchar2_value
            (hat.selected_person_id
            ,hats.api_name
            ,hats.transaction_step_id
            ,'P_ABS_INFORMATION14'))             abs_information14_meaning_p 
,      xxas_hr_api_transaction_pkg.varchar2_value
         (hat.selected_person_id
         ,hats.api_name
         ,hats.transaction_step_id
         ,'P_ABS_INFORMATION15')                 abs_information15_p
,      xxas_com_vset_pkg.decode_descr_vset_value
         ('800'
         ,'PER_ABS_DEVELOPER_DF'
         ,info.varchar2_value
         ,'ABS_INFORMATION15'
         ,xxas_hr_api_transaction_pkg.varchar2_value
            (hat.selected_person_id
            ,hats.api_name
            ,hats.transaction_step_id
            ,'P_ABS_INFORMATION15'))             abs_information15_meaning_p 
,      xxas_hr_api_transaction_pkg.varchar2_value
         (hat.selected_person_id
         ,hats.api_name
         ,hats.transaction_step_id
         ,'P_ABS_INFORMATION16')                 abs_information16_p
,      xxas_com_vset_pkg.decode_descr_vset_value
         ('800'
         ,'PER_ABS_DEVELOPER_DF'
         ,info.varchar2_value
         ,'ABS_INFORMATION16'
         ,xxas_hr_api_transaction_pkg.varchar2_value
            (hat.selected_person_id
            ,hats.api_name
            ,hats.transaction_step_id
            ,'P_ABS_INFORMATION16'))             abs_information16_meaning_p 
,      xxas_hr_api_transaction_pkg.varchar2_value
         (hat.selected_person_id
         ,hats.api_name
         ,hats.transaction_step_id
         ,'P_ABS_INFORMATION17')                 abs_information17_p
,      xxas_com_vset_pkg.decode_descr_vset_value
         ('800'
         ,'PER_ABS_DEVELOPER_DF'
         ,info.varchar2_value
         ,'ABS_INFORMATION17'
         ,xxas_hr_api_transaction_pkg.varchar2_value
            (hat.selected_person_id
            ,hats.api_name
            ,hats.transaction_step_id
            ,'P_ABS_INFORMATION17'))             abs_information17_meaning_p 
,      xxas_hr_api_transaction_pkg.varchar2_value
         (hat.selected_person_id
         ,hats.api_name
         ,hats.transaction_step_id
         ,'P_ABS_INFORMATION18')                 abs_information18_p
,      xxas_com_vset_pkg.decode_descr_vset_value
         ('800'
         ,'PER_ABS_DEVELOPER_DF'
         ,info.varchar2_value
         ,'ABS_INFORMATION18'
         ,xxas_hr_api_transaction_pkg.varchar2_value
            (hat.selected_person_id
            ,hats.api_name
            ,hats.transaction_step_id
            ,'P_ABS_INFORMATION18'))             abs_information18_meaning_p 
,      xxas_hr_api_transaction_pkg.varchar2_value
         (hat.selected_person_id
         ,hats.api_name
         ,hats.transaction_step_id
         ,'P_ABS_INFORMATION19')                 abs_information19_p
,      xxas_com_vset_pkg.decode_descr_vset_value
         ('800'
         ,'PER_ABS_DEVELOPER_DF'
         ,info.varchar2_value
         ,'ABS_INFORMATION19'
         ,xxas_hr_api_transaction_pkg.varchar2_value
            (hat.selected_person_id
            ,hats.api_name
            ,hats.transaction_step_id
            ,'P_ABS_INFORMATION19'))             abs_information19_meaning_p 
,      xxas_hr_api_transaction_pkg.varchar2_value
         (hat.selected_person_id
         ,hats.api_name
         ,hats.transaction_step_id
         ,'P_ABS_INFORMATION20')                 abs_information20_p
,      xxas_com_vset_pkg.decode_descr_vset_value
         ('800'
         ,'PER_ABS_DEVELOPER_DF'
         ,info.varchar2_value
         ,'ABS_INFORMATION20'
         ,xxas_hr_api_transaction_pkg.varchar2_value
            (hat.selected_person_id
            ,hats.api_name
            ,hats.transaction_step_id
            ,'P_ABS_INFORMATION20'))             abs_information20_meaning_p 
,      xxas_hr_api_transaction_pkg.varchar2_value
         (hat.selected_person_id
         ,hats.api_name
         ,hats.transaction_step_id
         ,'P_ABS_INFORMATION21')                 abs_information21_p
,      xxas_com_vset_pkg.decode_descr_vset_value
         ('800'
         ,'PER_ABS_DEVELOPER_DF'
         ,info.varchar2_value
         ,'ABS_INFORMATION21'
         ,xxas_hr_api_transaction_pkg.varchar2_value
            (hat.selected_person_id
            ,hats.api_name
            ,hats.transaction_step_id
            ,'P_ABS_INFORMATION21'))             abs_information21_meaning_p 
,      xxas_hr_api_transaction_pkg.varchar2_value
         (hat.selected_person_id
         ,hats.api_name
         ,hats.transaction_step_id
         ,'P_ABS_INFORMATION22')                 abs_information22_p
,      xxas_com_vset_pkg.decode_descr_vset_value
         ('800'
         ,'PER_ABS_DEVELOPER_DF'
         ,info.varchar2_value
         ,'ABS_INFORMATION22'
         ,xxas_hr_api_transaction_pkg.varchar2_value
            (hat.selected_person_id
            ,hats.api_name
            ,hats.transaction_step_id
            ,'P_ABS_INFORMATION22'))             abs_information22_meaning_p 
,      xxas_hr_api_transaction_pkg.varchar2_value
         (hat.selected_person_id
         ,hats.api_name
         ,hats.transaction_step_id
         ,'P_ABS_INFORMATION23')                 abs_information23_p
,      xxas_com_vset_pkg.decode_descr_vset_value
         ('800'
         ,'PER_ABS_DEVELOPER_DF'
         ,info.varchar2_value
         ,'ABS_INFORMATION23'
         ,xxas_hr_api_transaction_pkg.varchar2_value
            (hat.selected_person_id
            ,hats.api_name
            ,hats.transaction_step_id
            ,'P_ABS_INFORMATION23'))             abs_information23_meaning_p 
,      xxas_hr_api_transaction_pkg.varchar2_value
         (hat.selected_person_id
         ,hats.api_name
         ,hats.transaction_step_id
         ,'P_ABS_INFORMATION24')                 abs_information24_p
,      xxas_com_vset_pkg.decode_descr_vset_value
         ('800'
         ,'PER_ABS_DEVELOPER_DF'
         ,info.varchar2_value
         ,'ABS_INFORMATION24'
         ,xxas_hr_api_transaction_pkg.varchar2_value
            (hat.selected_person_id
            ,hats.api_name
            ,hats.transaction_step_id
            ,'P_ABS_INFORMATION24'))             abs_information24_meaning_p 
,      xxas_hr_api_transaction_pkg.varchar2_value
         (hat.selected_person_id
         ,hats.api_name
         ,hats.transaction_step_id
         ,'P_ABS_INFORMATION25')                 abs_information25_p
,      xxas_com_vset_pkg.decode_descr_vset_value
         ('800'
         ,'PER_ABS_DEVELOPER_DF'
         ,info.varchar2_value
         ,'ABS_INFORMATION25'
         ,xxas_hr_api_transaction_pkg.varchar2_value
            (hat.selected_person_id
            ,hats.api_name
            ,hats.transaction_step_id
            ,'P_ABS_INFORMATION25'))             abs_information25_meaning_p 
,      xxas_hr_api_transaction_pkg.varchar2_value
         (hat.selected_person_id
         ,hats.api_name
         ,hats.transaction_step_id
         ,'P_ABS_INFORMATION26')                 abs_information26_p
,      xxas_com_vset_pkg.decode_descr_vset_value
         ('800'
         ,'PER_ABS_DEVELOPER_DF'
         ,info.varchar2_value
         ,'ABS_INFORMATION26'
         ,xxas_hr_api_transaction_pkg.varchar2_value
            (hat.selected_person_id
            ,hats.api_name
            ,hats.transaction_step_id
            ,'P_ABS_INFORMATION26'))             abs_information26_meaning_p 
,      xxas_hr_api_transaction_pkg.varchar2_value
         (hat.selected_person_id
         ,hats.api_name
         ,hats.transaction_step_id
         ,'P_ABS_INFORMATION27')                 abs_information27_p
,      xxas_com_vset_pkg.decode_descr_vset_value
         ('800'
         ,'PER_ABS_DEVELOPER_DF'
         ,info.varchar2_value
         ,'ABS_INFORMATION27'
         ,xxas_hr_api_transaction_pkg.varchar2_value
            (hat.selected_person_id
            ,hats.api_name
            ,hats.transaction_step_id
            ,'P_ABS_INFORMATION27'))             abs_information27_meaning_p 
,      xxas_hr_api_transaction_pkg.varchar2_value
         (hat.selected_person_id
         ,hats.api_name
         ,hats.transaction_step_id
         ,'P_ABS_INFORMATION28')                 abs_information28_p
,      xxas_com_vset_pkg.decode_descr_vset_value
         ('800'
         ,'PER_ABS_DEVELOPER_DF'
         ,info.varchar2_value
         ,'ABS_INFORMATION28'
         ,xxas_hr_api_transaction_pkg.varchar2_value
            (hat.selected_person_id
            ,hats.api_name
            ,hats.transaction_step_id
            ,'P_ABS_INFORMATION28'))             abs_information28_meaning_p 
,      xxas_hr_api_transaction_pkg.varchar2_value
         (hat.selected_person_id
         ,hats.api_name
         ,hats.transaction_step_id
         ,'P_ABS_INFORMATION29')                 abs_information29_p
,      xxas_com_vset_pkg.decode_descr_vset_value
         ('800'
         ,'PER_ABS_DEVELOPER_DF'
         ,info.varchar2_value
         ,'ABS_INFORMATION29'
         ,xxas_hr_api_transaction_pkg.varchar2_value
            (hat.selected_person_id
            ,hats.api_name
            ,hats.transaction_step_id
            ,'P_ABS_INFORMATION29'))             abs_information29_meaning_p 
,      xxas_hr_api_transaction_pkg.varchar2_value
         (hat.selected_person_id
         ,hats.api_name
         ,hats.transaction_step_id
         ,'P_ABS_INFORMATION30')                 abs_information30_p
,      xxas_com_vset_pkg.decode_descr_vset_value
         ('800'
         ,'PER_ABS_DEVELOPER_DF'
         ,info.varchar2_value
         ,'ABS_INFORMATION30'
         ,xxas_hr_api_transaction_pkg.varchar2_value
            (hat.selected_person_id
            ,hats.api_name
            ,hats.transaction_step_id
            ,'P_ABS_INFORMATION30'))             abs_information30_meaning_p 
,      xxas_hr_api_transaction_pkg.varchar2_value
         (hat.selected_person_id
         ,hats.api_name
         ,hats.transaction_step_id
         ,'P_COMMENTS')                          comments_p
,     'PQH_SS_ATTACHMENT'                        attachment_entity
,      hat.transaction_id                        attachment_pk1
FROM   hr_api_transactions         hat
,      hr_api_transaction_steps    hats
,      hr_api_transaction_values   act
,      hr_api_transaction_values   att
,      hr_api_transaction_values   info
,      hr_api_transaction_values   tid
,      per_abs_attendance_types_vl paat
,      hr_lookups                  fcl
WHERE  hat.transaction_id       = hats.transaction_id
AND    hat.status          NOT IN ('D', 'N', 'W', 'ACTIVE', 'AC')
AND    hats.api_name            = 'HR_LOA_SS.PROCESS_API'
AND    hats.transaction_step_id = act.transaction_step_id
AND    act.name                 = 'P_ACTIVITY_NAME'
AND    act.varchar2_value       = 'HrLoa'
AND    hats.transaction_step_id = att.transaction_step_id
AND    att.name                 = 'P_ABS_INFORMATION_CATEGORY'
AND    hats.transaction_step_id = info.transaction_step_id
AND    info.name                = 'P_ATTRIBUTE_CATEGORY'
AND    hats.transaction_step_id = tid.transaction_step_id
AND    tid.name                 = 'P_ABSENCE_ATTENDANCE_TYPE_ID'
AND    tid.number_value         = paat.absence_attendance_type_id
AND    paat.absence_category    = fcl.lookup_code(+)
AND    fcl.lookup_type(+)       = 'ABSENCE_CATEGORY';

BEGIN
  xxas_fnd_dictionary_pkg.add_view
   (p_application_short_name => xxas_util_pkg.app
   ,p_view_name              => 'XXAS_LEAVE_OF_ABSENCE_V'
   ,p_description            => 'Applaud Absence');
END;
/

COMMIT;
EXIT;

