/* $Id$ */
/*============================================================================*
 |                 Copyright (c) 2014 Applaud Solutions UK Ltd                |
 |                             All rights reserved                            |
 *===========================================================================*/

SET VERIFY OFF
SET FEEDBACK OFF
SET SCAN OFF
WHENEVER OSERROR  EXIT FAILURE ROLLBACK
WHENEVER SQLERROR EXIT FAILURE ROLLBACK

DECLARE

  --
  -- Local constants and variables
  --
  l_SERVICE CONSTANT xxas_com_service_repository.service_name%TYPE
                       := 'AriaLabels';

BEGIN

  xxas_com_sr_pkg.set_rest_service
    (p_service_name       => l_SERVICE
    ,p_description        => 'AriaLabels'
    ,p_path               => 'arialabels/'
    ,p_consumes           => 'application/xml'
    ,p_produces           => 'application/xml'
    );

  xxas_com_sr_pkg.set_rest_method
    (p_service_name       => l_SERVICE
    ,p_method_name        => 'GetAriaLabel'
    ,p_description        => 'Get the aria-label properties'
    ,p_methods            => 'GET'
    ,p_remove_root_ele    => true
    ,p_sql                =>
      q'[
        SELECT XMLForest(
                          xxas_com_msg_pkg.get_string('XXAS_COM_FAVOURITE')           as "favouriteButton"
                          ,xxas_com_msg_pkg.get_string('XXAS_COM_POPOVER')            as "popoverButton"
                          ,xxas_com_msg_pkg.get_string('XXAS_COM_SEARCHICON')         as "searchIcon"
                          ,xxas_com_msg_pkg.get_string('XXAS_COM_AVATAR')             as "avatarPopover"
                          ,xxas_com_msg_pkg.get_string('XXAS_COM_MULTIROW_DEL')       as "multirowDelete"
                          ,xxas_com_msg_pkg.get_string('XXAS_COM_MULTIROW_EXP')       as "multirowExpand"
                          ,xxas_com_msg_pkg.get_string('XXAS_COM_MULTIROW_COLLAPSE')  as "multirowCollapse"
                          ,xxas_com_msg_pkg.get_string('XXAS_COM_DELETE_FILE')        as "deleteFileButton"
                          ,xxas_com_msg_pkg.get_string('XXAS_COM_BLOCK_REORDER_UP')   as "blockReorderUp"
                          ,xxas_com_msg_pkg.get_string('XXAS_COM_BLOCK_REORDER_DOWN') as "blockReorderDown"
                          ,xxas_com_msg_pkg.get_string('XXAS_ORG_ZOOM_IN')            as "documentZoomIn"
                          ,xxas_com_msg_pkg.get_string('XXAS_ORG_ZOOM_OUT')           as "documentZoomOut"
                          ,xxas_com_msg_pkg.get_string('XXAS_RB_COM_FULLSCREEN')      as "documentFullScreen"
                          ,xxas_com_msg_pkg.get_string('XXAS_COM_DOWNLOAD_DOCUMENT')  as "documentDownload"
                          ,xxas_com_msg_pkg.get_string('XXAS_COM_PRINT_DOCUMENT')     as "documentPrint"
                          ,xxas_com_msg_pkg.get_string('XXAS_COM_FIND_LABEL')         as "documentFind"
                          ,xxas_com_msg_pkg.get_string('XXAS_COM_FIND_NEXT')          as "documentFindNext"
                          ,xxas_com_msg_pkg.get_string('XXAS_COM_FIND_PREV')          as "documentFindPrevious"
                          ,xxas_com_msg_pkg.get_string('XXAS_RB_COM_CLOSE')           as "documentClose"
                          ,xxas_com_msg_pkg.get_string('XXAS_RB_COM_FILTERS')         as "filtersButton"
                          ,xxas_com_msg_pkg.get_string('XXAS_COM_CLOSE_MODAL')        as "modalPageCloseButton"
                          ,xxas_com_msg_pkg.get_string('XXAS_ORG_ZOOM_IN')            as "hierarchyZoomin"
                          ,xxas_com_msg_pkg.get_string('XXAS_ORG_ZOOM_OUT')           as "hierarchyZoomout"
                          ,xxas_com_msg_pkg.get_string('XXAS_RB_COM_RESET')           as "hierarchyReset"
                          ,xxas_com_msg_pkg.get_string('XXAS_COM_RESTART')            as "hierarchyRestart"
                          ,xxas_com_msg_pkg.get_string('XXAS_RB_EMP_DOWNLOAD')        as "hierarchyDownload"
                          ,xxas_com_msg_pkg.get_string('XXAS_RB_COM_BACK')            as "backButton"
                          ,xxas_com_msg_pkg.get_string('XXAS_COM_PROGRESS_CIRCLE')    as "imageLoading"
                          ,xxas_com_msg_pkg.get_string('XXAS_COM_PROGRESS_CIRCLE')    as "progressCircleIcon"
                          ,xxas_com_msg_pkg.get_string('XXAS_COM_GPS')                as "facetDistanceIcon"
                          ,xxas_com_msg_pkg.get_string('XXAS_COM_COLOR_PICKER')       as "colorPickerInput"
                          ,xxas_com_msg_pkg.get_string('XXAS_COM_PWD_STRENGTH')       as "passwordStregnthIndicator"
                          ,xxas_com_msg_pkg.get_string('XXAS_COM_LOGO')               as "burgerBarLogoIcon"
                          ,xxas_com_msg_pkg.get_string('XXAS_COM_LOGO')               as "navBarLogoIcon"   

                        ) from dual

        ]'
        
    );
END;
/
COMMIT;
EXIT;
                