/* $Id$ */
/*============================================================================*
 |                 Copyright (c) 2010 Applaud Solutions UK Ltd                |
 |                             All rights reserved                            |
 *===========================================================================*/

SET VERIFY OFF
SET FEEDBACK OFF
SET SCAN OFF
WHENEVER OSERROR  EXIT FAILURE ROLLBACK
WHENEVER SQLERROR EXIT FAILURE ROLLBACK

DECLARE

  --
  -- Local constants and variables
  --
  l_sql varchar2(32000);

BEGIN

  --
  -- Register Query Assignments
  --
  l_sql :=
'        SELECT /*+ cardinality(rslts 10)*/
               rslts.*
        FROM   TABLE(xxas_per_search_pkg.people_tbl
                      (:pSearchText, :pEffectiveDate, :pFacet1Value, :pFacet2Value
                      ,:pFacet3Value, :pFacet4Value, :pFacet5Value, :pFacet6Value
                      ,:pFacet7Value, :pFacet8Value, :pFacet9Value, :pFacet10Value
                      ,:pFacet11Value, :pFacet12Value, :pFacet13Value, :pFacet14Value
                      ,:pFacet15Value, :pFacet16Value, :pFacet17Value, :pFacet18Value
                      ,:pFacet19Value, :pFacet20Value, :pFacet21Value, :pFacet22Value
                      ,:pFacet23Value, :pFacet24Value, :pFacet25Value, :pFacet26Value
                      ,:pFacet27Value, :pFacet28Value, :pFacet29Value, :pFacet30Value
                      ,:pFacet31Value, :pFacet32Value, :pFacet33Value, :pFacet34Value
                      ,:pFacet35Value, :pFacet36Value, :pFacet37Value, :pFacet38Value
                      ,:pFacet39Value, :pFacet40Value, :pFacet41Value, :pFacet42Value
                      ,:pFacet43Value, :pFacet44Value, :pFacet45Value, :pFacet46Value
                      ,:pFacet47Value, :pFacet48Value, :pFacet49Value, :pFacet50Value
                      ,:pFacet51Value, :pFacet52Value, :pFacet53Value, :pFacet54Value
                      ,:pFacet55Value, :pFacet56Value, :pFacet57Value, :pFacet58Value
                      ,:pFacet59Value, :pFacet60Value)) rslts  order by score desc';

  xxas_com_sr_pkg.seed_query_service
    (p_service_name      => 'QueryAssignments'
    ,p_securing_function => 'XXAS_SRV_Q_ASG_PERM'
    ,p_sql               => l_sql
    ,p_parameters        => xxas_com_sr_param_varray
                              (xxas_com_sr_param_type('pSearchText', xxas_com_sr_pkg.g_VARCHAR2)
                              ,xxas_com_sr_param_type('pEffectiveDate', xxas_com_sr_pkg.g_DATE)
                              ,xxas_com_sr_param_type('pFacet1Value', xxas_com_sr_pkg.g_VARCHAR2)
                              ,xxas_com_sr_param_type('pFacet2Value', xxas_com_sr_pkg.g_VARCHAR2)
                              ,xxas_com_sr_param_type('pFacet3Value', xxas_com_sr_pkg.g_VARCHAR2)
                              ,xxas_com_sr_param_type('pFacet4Value', xxas_com_sr_pkg.g_VARCHAR2)
                              ,xxas_com_sr_param_type('pFacet5Value', xxas_com_sr_pkg.g_VARCHAR2)
                              ,xxas_com_sr_param_type('pFacet6Value', xxas_com_sr_pkg.g_VARCHAR2)
                              ,xxas_com_sr_param_type('pFacet7Value', xxas_com_sr_pkg.g_VARCHAR2)
                              ,xxas_com_sr_param_type('pFacet8Value', xxas_com_sr_pkg.g_VARCHAR2)
                              ,xxas_com_sr_param_type('pFacet9Value', xxas_com_sr_pkg.g_VARCHAR2)
                              ,xxas_com_sr_param_type('pFacet10Value', xxas_com_sr_pkg.g_VARCHAR2)
                              ,xxas_com_sr_param_type('pFacet11Value', xxas_com_sr_pkg.g_VARCHAR2)
                              ,xxas_com_sr_param_type('pFacet12Value', xxas_com_sr_pkg.g_VARCHAR2)
                              ,xxas_com_sr_param_type('pFacet13Value', xxas_com_sr_pkg.g_VARCHAR2)
                              ,xxas_com_sr_param_type('pFacet14Value', xxas_com_sr_pkg.g_VARCHAR2)
                              ,xxas_com_sr_param_type('pFacet15Value', xxas_com_sr_pkg.g_VARCHAR2)
                              ,xxas_com_sr_param_type('pFacet16Value', xxas_com_sr_pkg.g_VARCHAR2)
                              ,xxas_com_sr_param_type('pFacet17Value', xxas_com_sr_pkg.g_VARCHAR2)
                              ,xxas_com_sr_param_type('pFacet18Value', xxas_com_sr_pkg.g_VARCHAR2)
                              ,xxas_com_sr_param_type('pFacet19Value', xxas_com_sr_pkg.g_VARCHAR2)
                              ,xxas_com_sr_param_type('pFacet20Value', xxas_com_sr_pkg.g_VARCHAR2)
                              ,xxas_com_sr_param_type('pFacet21Value', xxas_com_sr_pkg.g_VARCHAR2)
                              ,xxas_com_sr_param_type('pFacet22Value', xxas_com_sr_pkg.g_VARCHAR2)
                              ,xxas_com_sr_param_type('pFacet23Value', xxas_com_sr_pkg.g_VARCHAR2)
                              ,xxas_com_sr_param_type('pFacet24Value', xxas_com_sr_pkg.g_VARCHAR2)
                              ,xxas_com_sr_param_type('pFacet25Value', xxas_com_sr_pkg.g_VARCHAR2)
                              ,xxas_com_sr_param_type('pFacet26Value', xxas_com_sr_pkg.g_VARCHAR2)
                              ,xxas_com_sr_param_type('pFacet27Value', xxas_com_sr_pkg.g_VARCHAR2)
                              ,xxas_com_sr_param_type('pFacet28Value', xxas_com_sr_pkg.g_VARCHAR2)
                              ,xxas_com_sr_param_type('pFacet29Value', xxas_com_sr_pkg.g_VARCHAR2)
                              ,xxas_com_sr_param_type('pFacet30Value', xxas_com_sr_pkg.g_VARCHAR2)
                              ,xxas_com_sr_param_type('pFacet31Value', xxas_com_sr_pkg.g_VARCHAR2)
                              ,xxas_com_sr_param_type('pFacet32Value', xxas_com_sr_pkg.g_VARCHAR2)
                              ,xxas_com_sr_param_type('pFacet33Value', xxas_com_sr_pkg.g_VARCHAR2)
                              ,xxas_com_sr_param_type('pFacet34Value', xxas_com_sr_pkg.g_VARCHAR2)
                              ,xxas_com_sr_param_type('pFacet35Value', xxas_com_sr_pkg.g_VARCHAR2)
                              ,xxas_com_sr_param_type('pFacet36Value', xxas_com_sr_pkg.g_VARCHAR2)
                              ,xxas_com_sr_param_type('pFacet37Value', xxas_com_sr_pkg.g_VARCHAR2)
                              ,xxas_com_sr_param_type('pFacet38Value', xxas_com_sr_pkg.g_VARCHAR2)
                              ,xxas_com_sr_param_type('pFacet39Value', xxas_com_sr_pkg.g_VARCHAR2)
                              ,xxas_com_sr_param_type('pFacet40Value', xxas_com_sr_pkg.g_VARCHAR2)
                              ,xxas_com_sr_param_type('pFacet41Value', xxas_com_sr_pkg.g_VARCHAR2)
                              ,xxas_com_sr_param_type('pFacet42Value', xxas_com_sr_pkg.g_VARCHAR2)
                              ,xxas_com_sr_param_type('pFacet43Value', xxas_com_sr_pkg.g_VARCHAR2)
                              ,xxas_com_sr_param_type('pFacet44Value', xxas_com_sr_pkg.g_VARCHAR2)
                              ,xxas_com_sr_param_type('pFacet45Value', xxas_com_sr_pkg.g_VARCHAR2)
                              ,xxas_com_sr_param_type('pFacet46Value', xxas_com_sr_pkg.g_VARCHAR2)
                              ,xxas_com_sr_param_type('pFacet47Value', xxas_com_sr_pkg.g_VARCHAR2)
                              ,xxas_com_sr_param_type('pFacet48Value', xxas_com_sr_pkg.g_VARCHAR2)
                              ,xxas_com_sr_param_type('pFacet49Value', xxas_com_sr_pkg.g_VARCHAR2)
                              ,xxas_com_sr_param_type('pFacet50Value', xxas_com_sr_pkg.g_VARCHAR2)
                              ,xxas_com_sr_param_type('pFacet51Value', xxas_com_sr_pkg.g_VARCHAR2)
                              ,xxas_com_sr_param_type('pFacet52Value', xxas_com_sr_pkg.g_VARCHAR2)
                              ,xxas_com_sr_param_type('pFacet53Value', xxas_com_sr_pkg.g_VARCHAR2)
                              ,xxas_com_sr_param_type('pFacet54Value', xxas_com_sr_pkg.g_VARCHAR2)
                              ,xxas_com_sr_param_type('pFacet55Value', xxas_com_sr_pkg.g_VARCHAR2)
                              ,xxas_com_sr_param_type('pFacet56Value', xxas_com_sr_pkg.g_VARCHAR2)
                              ,xxas_com_sr_param_type('pFacet57Value', xxas_com_sr_pkg.g_VARCHAR2)
                              ,xxas_com_sr_param_type('pFacet58Value', xxas_com_sr_pkg.g_VARCHAR2)
                              ,xxas_com_sr_param_type('pFacet59Value', xxas_com_sr_pkg.g_VARCHAR2)
                              ,xxas_com_sr_param_type('pFacet60Value', xxas_com_sr_pkg.g_VARCHAR2))
    ,p_page_size         => 25);

END;
/
COMMIT;
EXIT;
