/* $Id$ */
/*============================================================================*
 |                 Copyright (c) 2010 Applaud Solutions UK Ltd                |
 |                             All rights reserved                            |
 *===========================================================================*/

SET VERIFY OFF
SET FEEDBACK OFF
SET SCAN OFF
WHENEVER OSERROR  EXIT FAILURE ROLLBACK
WHENEVER SQLERROR EXIT FAILURE ROLLBACK

DECLARE

  --
  -- Local constants and variables
  --
  l_sql varchar2(32000);

BEGIN

  --
  -- Register Query Search Facets
  --
  l_sql :=
'        SELECT xxas_per_search_pkg.get_facet_delimiter safe_delimiter
              ,xxas_per_search_pkg.get_facet_title(1) facet1_title
              ,xxas_per_search_pkg.get_facet_all_label(1) facet1_all_label
              ,xxas_per_search_pkg.get_facet_title(2) facet2_title
              ,xxas_per_search_pkg.get_facet_all_label(2) facet2_all_label
              ,xxas_per_search_pkg.get_facet_title(3) facet3_title
              ,xxas_per_search_pkg.get_facet_all_label(3) facet3_all_label
              ,xxas_per_search_pkg.get_facet_title(4) facet4_title
              ,xxas_per_search_pkg.get_facet_all_label(4) facet4_all_label
              ,xxas_per_search_pkg.get_facet_title(5) facet5_title
              ,xxas_per_search_pkg.get_facet_all_label(5) facet5_all_label
              ,xxas_per_search_pkg.get_facet_title(6) facet6_title
              ,xxas_per_search_pkg.get_facet_all_label(6) facet6_all_label
              ,xxas_per_search_pkg.get_facet_title(7) facet7_title
              ,xxas_per_search_pkg.get_facet_all_label(7) facet7_all_label
              ,xxas_per_search_pkg.get_facet_title(8) facet8_title
              ,xxas_per_search_pkg.get_facet_all_label(8) facet8_all_label
              ,xxas_per_search_pkg.get_facet_title(9) facet9_title
              ,xxas_per_search_pkg.get_facet_all_label(9) facet9_all_label
              ,xxas_per_search_pkg.get_facet_title(10) facet10_title
              ,xxas_per_search_pkg.get_facet_all_label(10) facet10_all_label
              ,xxas_per_search_pkg.get_facet_title(11) facet11_title
              ,xxas_per_search_pkg.get_facet_all_label(11) facet11_all_label
              ,xxas_per_search_pkg.get_facet_title(12) facet12_title
              ,xxas_per_search_pkg.get_facet_all_label(12) facet12_all_label
              ,xxas_per_search_pkg.get_facet_title(13) facet13_title
              ,xxas_per_search_pkg.get_facet_all_label(13) facet13_all_label
              ,xxas_per_search_pkg.get_facet_title(14) facet14_title
              ,xxas_per_search_pkg.get_facet_all_label(14) facet14_all_label
              ,xxas_per_search_pkg.get_facet_title(15) facet15_title
              ,xxas_per_search_pkg.get_facet_all_label(15) facet15_all_label
              ,xxas_per_search_pkg.get_facet_title(16) facet16_title
              ,xxas_per_search_pkg.get_facet_all_label(16) facet16_all_label
              ,xxas_per_search_pkg.get_facet_title(17) facet17_title
              ,xxas_per_search_pkg.get_facet_all_label(17) facet17_all_label
              ,xxas_per_search_pkg.get_facet_title(18) facet18_title
              ,xxas_per_search_pkg.get_facet_all_label(18) facet18_all_label
              ,xxas_per_search_pkg.get_facet_title(19) facet19_title
              ,xxas_per_search_pkg.get_facet_all_label(19) facet19_all_label
              ,xxas_per_search_pkg.get_facet_title(20) facet20_title
              ,xxas_per_search_pkg.get_facet_all_label(20) facet20_all_label
              ,xxas_per_search_pkg.get_facet_title(21) facet21_title
              ,xxas_per_search_pkg.get_facet_all_label(21) facet21_all_label
              ,xxas_per_search_pkg.get_facet_title(22) facet22_title
              ,xxas_per_search_pkg.get_facet_all_label(22) facet22_all_label
              ,xxas_per_search_pkg.get_facet_title(23) facet23_title
              ,xxas_per_search_pkg.get_facet_all_label(23) facet23_all_label
              ,xxas_per_search_pkg.get_facet_title(24) facet24_title
              ,xxas_per_search_pkg.get_facet_all_label(24) facet24_all_label
              ,xxas_per_search_pkg.get_facet_title(25) facet25_title
              ,xxas_per_search_pkg.get_facet_all_label(25) facet25_all_label
              ,xxas_per_search_pkg.get_facet_title(26) facet26_title
              ,xxas_per_search_pkg.get_facet_all_label(26) facet26_all_label
              ,xxas_per_search_pkg.get_facet_title(27) facet27_title
              ,xxas_per_search_pkg.get_facet_all_label(27) facet27_all_label
              ,xxas_per_search_pkg.get_facet_title(28) facet28_title
              ,xxas_per_search_pkg.get_facet_all_label(28) facet28_all_label
              ,xxas_per_search_pkg.get_facet_title(29) facet29_title
              ,xxas_per_search_pkg.get_facet_all_label(29) facet29_all_label
              ,xxas_per_search_pkg.get_facet_title(30) facet30_title
              ,xxas_per_search_pkg.get_facet_all_label(30) facet30_all_label
              ,xxas_per_search_pkg.get_facet_title(31) facet31_title
              ,xxas_per_search_pkg.get_facet_all_label(31) facet31_all_label
              ,xxas_per_search_pkg.get_facet_title(32) facet32_title
              ,xxas_per_search_pkg.get_facet_all_label(32) facet32_all_label
              ,xxas_per_search_pkg.get_facet_title(33) facet33_title
              ,xxas_per_search_pkg.get_facet_all_label(33) facet33_all_label
              ,xxas_per_search_pkg.get_facet_title(34) facet34_title
              ,xxas_per_search_pkg.get_facet_all_label(34) facet34_all_label
              ,xxas_per_search_pkg.get_facet_title(35) facet35_title
              ,xxas_per_search_pkg.get_facet_all_label(35) facet35_all_label
              ,xxas_per_search_pkg.get_facet_title(36) facet36_title
              ,xxas_per_search_pkg.get_facet_all_label(36) facet36_all_label
              ,xxas_per_search_pkg.get_facet_title(37) facet37_title
              ,xxas_per_search_pkg.get_facet_all_label(37) facet37_all_label
              ,xxas_per_search_pkg.get_facet_title(38) facet38_title
              ,xxas_per_search_pkg.get_facet_all_label(38) facet38_all_label
              ,xxas_per_search_pkg.get_facet_title(39) facet39_title
              ,xxas_per_search_pkg.get_facet_all_label(39) facet39_all_label
              ,xxas_per_search_pkg.get_facet_title(40) facet40_title
              ,xxas_per_search_pkg.get_facet_all_label(40) facet40_all_label
              ,xxas_per_search_pkg.get_facet_title(41) facet41_title
              ,xxas_per_search_pkg.get_facet_all_label(41) facet41_all_label
              ,xxas_per_search_pkg.get_facet_title(42) facet42_title
              ,xxas_per_search_pkg.get_facet_all_label(42) facet42_all_label
              ,xxas_per_search_pkg.get_facet_title(43) facet43_title
              ,xxas_per_search_pkg.get_facet_all_label(43) facet43_all_label
              ,xxas_per_search_pkg.get_facet_title(44) facet44_title
              ,xxas_per_search_pkg.get_facet_all_label(44) facet44_all_label
              ,xxas_per_search_pkg.get_facet_title(45) facet45_title
              ,xxas_per_search_pkg.get_facet_all_label(45) facet45_all_label
              ,xxas_per_search_pkg.get_facet_title(46) facet46_title
              ,xxas_per_search_pkg.get_facet_all_label(46) facet46_all_label
              ,xxas_per_search_pkg.get_facet_title(47) facet47_title
              ,xxas_per_search_pkg.get_facet_all_label(47) facet47_all_label
              ,xxas_per_search_pkg.get_facet_title(48) facet48_title
              ,xxas_per_search_pkg.get_facet_all_label(48) facet48_all_label
              ,xxas_per_search_pkg.get_facet_title(49) facet49_title
              ,xxas_per_search_pkg.get_facet_all_label(49) facet49_all_label
              ,xxas_per_search_pkg.get_facet_title(50) facet50_title
              ,xxas_per_search_pkg.get_facet_all_label(50) facet50_all_label
              ,xxas_per_search_pkg.get_facet_title(51) facet51_title
              ,xxas_per_search_pkg.get_facet_all_label(51) facet51_all_label
              ,xxas_per_search_pkg.get_facet_title(52) facet52_title
              ,xxas_per_search_pkg.get_facet_all_label(52) facet52_all_label
              ,xxas_per_search_pkg.get_facet_title(53) facet53_title
              ,xxas_per_search_pkg.get_facet_all_label(53) facet53_all_label
              ,xxas_per_search_pkg.get_facet_title(54) facet54_title
              ,xxas_per_search_pkg.get_facet_all_label(54) facet54_all_label
              ,xxas_per_search_pkg.get_facet_title(55) facet55_title
              ,xxas_per_search_pkg.get_facet_all_label(55) facet55_all_label
              ,xxas_per_search_pkg.get_facet_title(56) facet56_title
              ,xxas_per_search_pkg.get_facet_all_label(56) facet56_all_label
              ,xxas_per_search_pkg.get_facet_title(57) facet57_title
              ,xxas_per_search_pkg.get_facet_all_label(57) facet57_all_label
              ,xxas_per_search_pkg.get_facet_title(58) facet58_title
              ,xxas_per_search_pkg.get_facet_all_label(58) facet58_all_label
              ,xxas_per_search_pkg.get_facet_title(59) facet59_title
              ,xxas_per_search_pkg.get_facet_all_label(59) facet59_all_label
              ,xxas_per_search_pkg.get_facet_title(60) facet60_title
              ,xxas_per_search_pkg.get_facet_all_label(60) facet60_all_label
        FROM   dual ';

  xxas_com_sr_pkg.seed_query_service
    (p_service_name      => 'QuerySearchFacets'
    ,p_securing_function => 'XXAS_SRV_Q_FACETS_PERM'
    ,p_sql               => l_sql);

END;
/
COMMIT;
EXIT;
